/*
 * MPU6050_acq_sf.c
 *
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * Code generation for model "MPU6050_acq_sf".
 *
 * Model version              : 1.86
 * Simulink Coder version : 8.12 (R2017a) 16-Feb-2017
 * C source code generated on : Fri Oct 06 10:41:13 2017
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "MPU6050_acq_sf.h"
#include "MPU6050_acq_sf_private.h"
#include "MPU6050_acq_sf_dt.h"
#define MPU6050_acq_sf_NoAck           (false)
#define MPU6050_acq_sf_RepeatedStart   (false)
#define MPU6050_acq_sf_SlaveAddress    (104U)

/* Named constants for Chart: '<Root>/MPU6050' */
#define MPU6050_acq__IN_NO_ACTIVE_CHILD ((uint8_T)0U)
#define MPU6050_acq_s_IN_initialisation ((uint8_T)2U)
#define M_IN_Lecture_acceleration3_axes ((uint8_T)1U)

/* Named constants for Chart: '<S8>/grav_init_avg' */
#define MPU6050__IN_Steadystate_gravity ((uint8_T)1U)
#define MPU6050_acq_sf_IN_config       ((uint8_T)1U)
#define MPU6050_acq_sf_IN_exec         ((uint8_T)2U)
#define MPU6050_acq_sf_IN_failure_mode ((uint8_T)3U)
#define MPU6050_acq_sf_IN_init_phase   ((uint8_T)4U)
#define MPU6050_SlaveAddress_pe1cae5aby (104U)
#define MPU6050_acq_sf_Pin             (44U)
#define MPU6050_acq_sf_Pin_pe1cae5aby  (43U)
#define MPU6050_acq_sf_Pin_pe1cae5abyr (42U)
#define MPU6050_acq_sf_RegisterAddress ((uint8_T)59U)

/* Block signals (auto storage) */
B_MPU6050_acq_sf_T MPU6050_acq_sf_B;

/* Block states (auto storage) */
DW_MPU6050_acq_sf_T MPU6050_acq_sf_DW;

/* Real-time model */
RT_MODEL_MPU6050_acq_sf_T MPU6050_acq_sf_M_;
RT_MODEL_MPU6050_acq_sf_T *const MPU6050_acq_sf_M = &MPU6050_acq_sf_M_;

/* Start for function-call system: '<S4>/i2cWr' */
void MPU6050_acq_sf_i2cWr_Start(DW_i2cWr_MPU6050_acq_sf_T *localDW)
{
  uint32_T i2cname;

  /* Start for MATLABSystem: '<S13>/I2C Master Write' */
  localDW->obj.isInitialized = 0;

  /* [EOF] */
  /*  */
  localDW->obj.isInitialized = 1;
  i2cname = 0;
  MW_I2C_Open(i2cname, 0U);

  /* 100KHz. */
  /* KHz */
  localDW->obj.BusSpeed = 100000U;
  i2cname = 0;
  MW_I2C_SetBusSpeed(i2cname, localDW->obj.BusSpeed);
}

/* Output and update for function-call system: '<S4>/i2cWr' */
void MPU6050_acq_sf_i2cWr(uint16_T rtu_dataw, DW_i2cWr_MPU6050_acq_sf_T *localDW)
{
  uint8_T SwappedDataBytes[2];
  uint32_T i2cname;
  uint16_T x;
  uint8_T x_0[2];

  /* Start for MATLABSystem: '<S13>/I2C Master Write' incorporates:
   *  MATLABSystem: '<S13>/I2C Master Write'
   */
  memcpy((void *)&SwappedDataBytes[0], (void *)&rtu_dataw, (size_t)2 * sizeof
         (uint8_T));
  x_0[0] = SwappedDataBytes[1];
  x_0[1] = SwappedDataBytes[0];
  memcpy((void *)&x, (void *)&x_0[0], (size_t)1 * sizeof(uint16_T));
  memcpy((void *)&SwappedDataBytes[0], (void *)&x, (size_t)2 * sizeof(uint8_T));
  i2cname = 0;
  MW_I2C_MasterWrite(i2cname, MPU6050_acq_sf_SlaveAddress, SwappedDataBytes, 2U,
                     MPU6050_acq_sf_RepeatedStart, MPU6050_acq_sf_NoAck);
  localDW->i2cWr_SubsysRanBC = 4;
}

/* Termination for function-call system: '<S4>/i2cWr' */
void MPU6050_acq_sf_i2cWr_Term(DW_i2cWr_MPU6050_acq_sf_T *localDW)
{
  uint32_T i2cname;

  /* Start for MATLABSystem: '<S13>/I2C Master Write' incorporates:
   *  Terminate for MATLABSystem: '<S13>/I2C Master Write'
   */
  if (localDW->obj.isInitialized == 1) {
    localDW->obj.isInitialized = 2;
    i2cname = 0;
    MW_I2C_Close(i2cname);
  }

  /* End of Start for MATLABSystem: '<S13>/I2C Master Write' */
}

/* Model step function */
void MPU6050_acq_sf_step(void)
{
  real_T currentTime;
  int16_T output[3];
  uint8_T output_raw[6];
  boolean_T p;
  boolean_T p_0;
  uint8_T status;
  uint32_T i2cname;
  uint8_T y[2];
  uint8_T x[2];
  uint32_T elapsedTicks;
  int32_T i;
  int16_T output_0;
  uint16_T output_1;

  /* Reset subsysRan breadcrumbs */
  srClearBC(MPU6050_acq_sf_DW.i2cWr.i2cWr_SubsysRanBC);

  /* Reset subsysRan breadcrumbs */
  srClearBC(MPU6050_acq_sf_DW.i2cRd_SubsysRanBC);

  /* DiscreteIntegrator: '<S9>/Discrete-Time Integrator' */
  MPU6050_acq_sf_B.ms = MPU6050_acq_sf_DW.DiscreteTimeIntegrator_DSTATE;

  /* Gain: '<S9>/to- km_h' */
  MPU6050_acq_sf_B.tokm_h = MPU6050_acq_sf_P.tokm_h_Gain * MPU6050_acq_sf_B.ms;

  /* DiscreteIntegrator: '<S9>/Discrete-Time Integrator1' */
  MPU6050_acq_sf_B.DiscreteTimeIntegrator1 =
    MPU6050_acq_sf_DW.DiscreteTimeIntegrator1_DSTATE;

  /* Gain: '<S9>/Gain4' */
  MPU6050_acq_sf_B.Gain4 = MPU6050_acq_sf_P.Gain4_Gain *
    MPU6050_acq_sf_B.DiscreteTimeIntegrator1;

  /* DiscreteIntegrator: '<S10>/Discrete-Time Integrator' */
  MPU6050_acq_sf_B.ms_aoti0aembx =
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_d55dfs0xze;

  /* Gain: '<S10>/to- km_h' */
  MPU6050_acq_sf_B.tokm_h_g4tmtqpyy3 = MPU6050_acq_sf_P.tokm_h_Gain_i0zxrskrml *
    MPU6050_acq_sf_B.ms_aoti0aembx;

  /* DiscreteIntegrator: '<S10>/Discrete-Time Integrator1' */
  MPU6050_acq_sf_B.DiscreteTimeIntegrat_kkx04wtjrb =
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_nvqe3zzsmy;

  /* Gain: '<S10>/Gain4' */
  MPU6050_acq_sf_B.Gain4_dhjf2huq5b = MPU6050_acq_sf_P.Gain4_Gain_fwjs0klxb4 *
    MPU6050_acq_sf_B.DiscreteTimeIntegrat_kkx04wtjrb;

  /* DiscreteIntegrator: '<S11>/Discrete-Time Integrator' */
  MPU6050_acq_sf_B.ms_lmya2fq1on =
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_hi5vld3rfw;

  /* Gain: '<S11>/to- km_h' */
  MPU6050_acq_sf_B.tokm_h_bdjcdnhyci = MPU6050_acq_sf_P.tokm_h_Gain_ij5ephcub4 *
    MPU6050_acq_sf_B.ms_lmya2fq1on;

  /* DiscreteIntegrator: '<S11>/Discrete-Time Integrator1' */
  MPU6050_acq_sf_B.DiscreteTimeIntegrat_jyeoei41v3 =
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_pniv0mwsqd;

  /* Gain: '<S11>/Gain4' */
  MPU6050_acq_sf_B.Gain4_na2kacdtwv = MPU6050_acq_sf_P.Gain4_Gain_g45celja43 *
    MPU6050_acq_sf_B.DiscreteTimeIntegrat_jyeoei41v3;

  /* Chart: '<Root>/MPU6050' */
  /* Gateway: MPU6050 */
  /* During: MPU6050 */
  if (MPU6050_acq_sf_DW.is_active_c3_MPU6050_acq_sf == 0U) {
    /* Entry: MPU6050 */
    MPU6050_acq_sf_DW.is_active_c3_MPU6050_acq_sf = 1U;

    /* Entry Internal: MPU6050 */
    /* Transition: '<S4>:35' */
    if (MPU6050_acq_sf_DW.is_c3_MPU6050_acq_sf !=
        MPU6050_acq_s_IN_initialisation) {
      MPU6050_acq_sf_DW.is_c3_MPU6050_acq_sf = MPU6050_acq_s_IN_initialisation;

      /* Entry 'initialisation': '<S4>:34' */
      /* Simulink Function 'i2cWr': '<S4>:28' */
      MPU6050_acq_sf_B.dataw = 27392U;

      /* Outputs for Function Call SubSystem: '<S4>/i2cWr' */
      MPU6050_acq_sf_i2cWr(MPU6050_acq_sf_B.dataw, &MPU6050_acq_sf_DW.i2cWr);

      /* End of Outputs for SubSystem: '<S4>/i2cWr' */

      /* Power on */
      /* Simulink Function 'i2cWr': '<S4>:28' */
      MPU6050_acq_sf_B.dataw = 6912U;

      /* Outputs for Function Call SubSystem: '<S4>/i2cWr' */
      MPU6050_acq_sf_i2cWr(MPU6050_acq_sf_B.dataw, &MPU6050_acq_sf_DW.i2cWr);

      /* End of Outputs for SubSystem: '<S4>/i2cWr' */

      /* FSEL= 0 gyro 0x00=250/s */
      /* Simulink Function 'i2cWr': '<S4>:28' */
      MPU6050_acq_sf_B.dataw = 7176U;

      /* Outputs for Function Call SubSystem: '<S4>/i2cWr' */
      MPU6050_acq_sf_i2cWr(MPU6050_acq_sf_B.dataw, &MPU6050_acq_sf_DW.i2cWr);

      /* End of Outputs for SubSystem: '<S4>/i2cWr' */

      /* acce 0x08= 4G */
      /* Simulink Function 'i2cWr': '<S4>:28' */
      MPU6050_acq_sf_B.dataw = 6662U;

      /* Outputs for Function Call SubSystem: '<S4>/i2cWr' */
      MPU6050_acq_sf_i2cWr(MPU6050_acq_sf_B.dataw, &MPU6050_acq_sf_DW.i2cWr);

      /* End of Outputs for SubSystem: '<S4>/i2cWr' */

      /* filtrage+actu 0x06= 19ms */
      /* Simulink Function 'i2cWr': '<S4>:28' */
      MPU6050_acq_sf_B.dataw = 14096U;

      /* Outputs for Function Call SubSystem: '<S4>/i2cWr' */
      MPU6050_acq_sf_i2cWr(MPU6050_acq_sf_B.dataw, &MPU6050_acq_sf_DW.i2cWr);

      /* End of Outputs for SubSystem: '<S4>/i2cWr' */

      /* INT_PIN_CFG */
      /* Simulink Function 'i2cWr': '<S4>:28' */
      MPU6050_acq_sf_B.dataw = 14336U;

      /* Outputs for Function Call SubSystem: '<S4>/i2cWr' */
      MPU6050_acq_sf_i2cWr(MPU6050_acq_sf_B.dataw, &MPU6050_acq_sf_DW.i2cWr);

      /* End of Outputs for SubSystem: '<S4>/i2cWr' */

      /* Interrupt Enable 0 dsactiv */
    }
  } else {
    switch (MPU6050_acq_sf_DW.is_c3_MPU6050_acq_sf) {
     case M_IN_Lecture_acceleration3_axes:
      /* Outputs for Function Call SubSystem: '<S4>/i2cRd' */
      /* Start for MATLABSystem: '<S12>/I2C Master Read' incorporates:
       *  MATLABSystem: '<S12>/I2C Master Read'
       */
      /* During 'Lecture_acceleration3_axes': '<S4>:52' */
      /* Simulink Function 'i2cRd': '<S4>:56' */
      p = false;
      p_0 = true;
      if (!(MPU6050_acq_sf_DW.obj_gyfctg30e0.SampleTime ==
            MPU6050_acq_sf_P.I2CMasterRead_SampleTime)) {
        p_0 = false;
      }

      if (p_0) {
        p = true;
      }

      if (!p) {
        MPU6050_acq_sf_DW.obj_gyfctg30e0.SampleTime =
          MPU6050_acq_sf_P.I2CMasterRead_SampleTime;
      }

      for (i = 0; i < 7; i++) {
        MPU6050_acq_sf_B.output[i] = 0U;
      }

      status = MPU6050_acq_sf_RegisterAddress;
      i2cname = 0;
      status = MW_I2C_MasterWrite(i2cname, MPU6050_SlaveAddress_pe1cae5aby,
        &status, 1U, true, false);
      if (0 == status) {
        i2cname = 0;
        MW_I2C_MasterRead(i2cname, MPU6050_SlaveAddress_pe1cae5aby,
                          MPU6050_acq_sf_B.output_raw, 14U, false, true);
        memcpy((void *)&MPU6050_acq_sf_B.output[0], (void *)
               &MPU6050_acq_sf_B.output_raw[0], (size_t)7 * sizeof(uint16_T));
        for (i = 0; i < 7; i++) {
          output_1 = MPU6050_acq_sf_B.output[i];
          memcpy((void *)&y[0], (void *)&output_1, (size_t)2 * sizeof(uint8_T));
          x[0] = y[1];
          x[1] = y[0];
          memcpy((void *)&output_1, (void *)&x[0], (size_t)1 * sizeof(uint16_T));
          MPU6050_acq_sf_B.output[i] = output_1;
        }
      }

      /* DataTypeConversion: '<S12>/Data Type Conversion' incorporates:
       *  MATLABSystem: '<S12>/I2C Master Read'
       *  Start for MATLABSystem: '<S12>/I2C Master Read'
       */
      for (i = 0; i < 7; i++) {
        MPU6050_acq_sf_B.DataTypeConversion_khxxwq3rq5[i] = (int16_T)
          MPU6050_acq_sf_B.output[i];
      }

      /* End of DataTypeConversion: '<S12>/Data Type Conversion' */
      MPU6050_acq_sf_DW.i2cRd_SubsysRanBC = 4;

      /* End of Outputs for SubSystem: '<S4>/i2cRd' */
      MPU6050_acq_sf_B.acc[0] = MPU6050_acq_sf_B.DataTypeConversion_khxxwq3rq5[0];
      MPU6050_acq_sf_B.gyro[0] = MPU6050_acq_sf_B.DataTypeConversion_khxxwq3rq5
        [4];
      MPU6050_acq_sf_B.acc[1] = MPU6050_acq_sf_B.DataTypeConversion_khxxwq3rq5[1];
      MPU6050_acq_sf_B.gyro[1] = MPU6050_acq_sf_B.DataTypeConversion_khxxwq3rq5
        [5];
      MPU6050_acq_sf_B.acc[2] = MPU6050_acq_sf_B.DataTypeConversion_khxxwq3rq5[2];
      MPU6050_acq_sf_B.gyro[2] = MPU6050_acq_sf_B.DataTypeConversion_khxxwq3rq5
        [6];
      MPU6050_acq_sf_B.temp = MPU6050_acq_sf_B.DataTypeConversion_khxxwq3rq5[3];
      break;

     case MPU6050_acq_s_IN_initialisation:
      /* During 'initialisation': '<S4>:34' */
      /* Transition: '<S4>:60' */
      MPU6050_acq_sf_DW.is_c3_MPU6050_acq_sf = M_IN_Lecture_acceleration3_axes;
      break;

     default:
      /* Unreachable state, for coverage only */
      MPU6050_acq_sf_DW.is_c3_MPU6050_acq_sf = MPU6050_acq__IN_NO_ACTIVE_CHILD;
      break;
    }
  }

  /* End of Chart: '<Root>/MPU6050' */

  /* Gain: '<Root>/Gain' */
  MPU6050_acq_sf_B.Gain[0] = (real32_T)MPU6050_acq_sf_P.Gain_Gain *
    7.4505806E-9F * (real32_T)MPU6050_acq_sf_B.acc[0];

  /* Gain: '<Root>/Gain3' */
  MPU6050_acq_sf_B.Gain3[0] = MPU6050_acq_sf_P.Gain3_Gain *
    MPU6050_acq_sf_B.Gain[0];

  /* Gain: '<Root>/Gain' */
  MPU6050_acq_sf_B.Gain[1] = (real32_T)MPU6050_acq_sf_P.Gain_Gain *
    7.4505806E-9F * (real32_T)MPU6050_acq_sf_B.acc[1];

  /* Gain: '<Root>/Gain3' */
  MPU6050_acq_sf_B.Gain3[1] = MPU6050_acq_sf_P.Gain3_Gain *
    MPU6050_acq_sf_B.Gain[1];

  /* Gain: '<Root>/Gain' */
  MPU6050_acq_sf_B.Gain[2] = (real32_T)MPU6050_acq_sf_P.Gain_Gain *
    7.4505806E-9F * (real32_T)MPU6050_acq_sf_B.acc[2];

  /* Gain: '<Root>/Gain3' */
  MPU6050_acq_sf_B.Gain3[2] = MPU6050_acq_sf_P.Gain3_Gain *
    MPU6050_acq_sf_B.Gain[2];

  /* DataTypeConversion: '<S8>/Data Type Conversion' incorporates:
   *  Product: '<S18>/Product'
   *  Product: '<S18>/Product1'
   *  Product: '<S18>/Product2'
   *  Sqrt: '<S18>/Sqrt'
   *  Sum: '<S18>/Sum of Elements'
   */
  MPU6050_acq_sf_B.DataTypeConversion = (real32_T)sqrt((MPU6050_acq_sf_B.Gain[0]
    * MPU6050_acq_sf_B.Gain[0] + MPU6050_acq_sf_B.Gain[1] *
    MPU6050_acq_sf_B.Gain[1]) + MPU6050_acq_sf_B.Gain[2] *
    MPU6050_acq_sf_B.Gain[2]);

  /* DataTypeConversion: '<S8>/Data Type Conversion1' */
  MPU6050_acq_sf_B.DataTypeConversion1 = MPU6050_acq_sf_B.Gain[0];

  /* DataTypeConversion: '<S8>/Data Type Conversion2' */
  MPU6050_acq_sf_B.DataTypeConversion2 = MPU6050_acq_sf_B.Gain[1];

  /* DataTypeConversion: '<S8>/Data Type Conversion3' */
  MPU6050_acq_sf_B.DataTypeConversion3 = MPU6050_acq_sf_B.Gain[2];

  /* Step: '<S2>/Step' */
  MPU6050_acq_sf_B.currentTime = MPU6050_acq_sf_M->Timing.t[0];

  /* Step: '<S3>/Step' */
  MPU6050_acq_sf_B.currentTime_mbvzarwird = MPU6050_acq_sf_M->Timing.t[0];

  /* ManualSwitch: '<Root>/Manual Switch' incorporates:
   *  Step: '<S3>/Step'
   */
  if (MPU6050_acq_sf_P.ManualSwitch_CurrentSetting == 1) {
    /* Step: '<S2>/Step' */
    if (MPU6050_acq_sf_B.currentTime < MPU6050_acq_sf_P.Step_Time) {
      /* DataTypeConversion: '<Root>/Data Type Conversion' */
      MPU6050_acq_sf_B.DataTypeConversion_dn5jwqzs2w = (real32_T)
        MPU6050_acq_sf_P.Step_Y0;
    } else {
      /* DataTypeConversion: '<Root>/Data Type Conversion' */
      MPU6050_acq_sf_B.DataTypeConversion_dn5jwqzs2w = (real32_T)
        MPU6050_acq_sf_P.Step_YFinal;
    }
  } else if (MPU6050_acq_sf_B.currentTime_mbvzarwird <
             MPU6050_acq_sf_P.Step_Time_b1t1biy2dc) {
    /* Step: '<S3>/Step' incorporates:
     *  DataTypeConversion: '<Root>/Data Type Conversion'
     */
    MPU6050_acq_sf_B.DataTypeConversion_dn5jwqzs2w = (real32_T)
      MPU6050_acq_sf_P.Step_Y0_jyfw5vgabt;
  } else {
    /* DataTypeConversion: '<Root>/Data Type Conversion' incorporates:
     *  Step: '<S3>/Step'
     */
    MPU6050_acq_sf_B.DataTypeConversion_dn5jwqzs2w = (real32_T)
      MPU6050_acq_sf_P.Step_YFinal_diuzh5gyxc;
  }

  /* End of ManualSwitch: '<Root>/Manual Switch' */

  /* Chart: '<S8>/grav_init_avg' */
  elapsedTicks = MPU6050_acq_sf_M->Timing.clockTick1 -
    MPU6050_acq_sf_DW.previousTicks;
  MPU6050_acq_sf_DW.previousTicks = MPU6050_acq_sf_M->Timing.clockTick1;
  if (MPU6050_acq_sf_DW.temporalCounter_i1 + elapsedTicks <= 63U) {
    MPU6050_acq_sf_DW.temporalCounter_i1 = (uint8_T)
      (MPU6050_acq_sf_DW.temporalCounter_i1 + elapsedTicks);
  } else {
    MPU6050_acq_sf_DW.temporalCounter_i1 = 63U;
  }

  /* Gateway: grav_init_phase/grav_init_avg */
  /* During: grav_init_phase/grav_init_avg */
  /* During 'Steadystate_gravity': '<S19>:9' */
  switch (MPU6050_acq_sf_DW.is_Steadystate_gravity) {
   case MPU6050_acq_sf_IN_config:
    status = 1U;

    /* During 'config': '<S19>:28' */
    if (MPU6050_acq_sf_DW.temporalCounter_i1 >= 40U) {
      /* Transition: '<S19>:31' */
      MPU6050_acq_sf_DW.is_Steadystate_gravity = MPU6050_acq_sf_IN_init_phase;

      /* Entry 'init_phase': '<S19>:1' */
      MPU6050_acq_sf_B.init_failure = 0U;
      MPU6050_acq_sf_B.init_good = 0U;
      MPU6050_acq_sf_DW.i = 0.0F;
      MPU6050_acq_sf_DW.sum = 0.0F;
      MPU6050_acq_sf_DW.sumx = 0.0F;
      MPU6050_acq_sf_DW.sumy = 0.0F;
      MPU6050_acq_sf_DW.sumz = 0.0F;
    }
    break;

   case MPU6050_acq_sf_IN_exec:
    status = 0U;
    MPU6050_acq_sf_B.init_good = 1U;

    /* During 'exec': '<S19>:2' */
    break;

   case MPU6050_acq_sf_IN_failure_mode:
    status = 0U;
    MPU6050_acq_sf_B.init_failure = 1U;

    /* During 'failure_mode': '<S19>:35' */
    break;

   default:
    status = 1U;
    MPU6050_acq_sf_B.init_good = 0U;
    MPU6050_acq_sf_B.init_failure = 0U;

    /* During 'init_phase': '<S19>:1' */
    if (MPU6050_acq_sf_B.DataTypeConversion_dn5jwqzs2w != 0.0F) {
      /* Transition: '<S19>:41' */
      MPU6050_acq_sf_DW.is_Steadystate_gravity = MPU6050_acq_sf_IN_failure_mode;

      /* Entry 'failure_mode': '<S19>:35' */
      status = 0U;
      MPU6050_acq_sf_B.init_failure = 1U;
    } else if (MPU6050_acq_sf_DW.i >= 50.0F) {
      /* Transition: '<S19>:52' */
      MPU6050_acq_sf_DW.is_Steadystate_gravity = MPU6050_acq_sf_IN_exec;

      /* Entry 'exec': '<S19>:2' */
      MPU6050_acq_sf_B.avr_gr = MPU6050_acq_sf_DW.sum / MPU6050_acq_sf_DW.i;
      MPU6050_acq_sf_B.avr_gr_x = MPU6050_acq_sf_DW.sumx / MPU6050_acq_sf_DW.i;
      MPU6050_acq_sf_B.avr_gr_y = MPU6050_acq_sf_DW.sumy / MPU6050_acq_sf_DW.i;
      MPU6050_acq_sf_B.avr_gr_z = MPU6050_acq_sf_DW.sumz / MPU6050_acq_sf_DW.i;
      status = 0U;
      MPU6050_acq_sf_B.init_good = 1U;
    } else {
      MPU6050_acq_sf_DW.i++;
      MPU6050_acq_sf_DW.sum += MPU6050_acq_sf_B.DataTypeConversion;
      MPU6050_acq_sf_DW.sumx += MPU6050_acq_sf_B.DataTypeConversion1;
      MPU6050_acq_sf_DW.sumy += MPU6050_acq_sf_B.DataTypeConversion2;
      MPU6050_acq_sf_DW.sumz += MPU6050_acq_sf_B.DataTypeConversion3;
    }
    break;
  }

  /* End of Chart: '<S8>/grav_init_avg' */

  /* Start for MATLABSystem: '<Root>/Digital Write' incorporates:
   *  MATLABSystem: '<Root>/Digital Write'
   */
  MW_digitalIO_write(MPU6050_acq_sf_Pin_pe1cae5abyr,
                     MPU6050_acq_sf_B.init_failure != 0);

  /* Start for MATLABSystem: '<Root>/Digital Write1' incorporates:
   *  MATLABSystem: '<Root>/Digital Write1'
   */
  MW_digitalIO_write(MPU6050_acq_sf_Pin_pe1cae5aby, MPU6050_acq_sf_B.init_good
                     != 0);

  /* Start for MATLABSystem: '<Root>/Digital Write2' incorporates:
   *  MATLABSystem: '<Root>/Digital Write2'
   */
  MW_digitalIO_write(MPU6050_acq_sf_Pin, status != 0);

  /* Gain: '<Root>/Gain2' */
  MPU6050_acq_sf_B.Gain2[0] = (real32_T)MPU6050_acq_sf_P.Gain2_Gain *
    9.53674316E-7F * (real32_T)MPU6050_acq_sf_B.gyro[0];
  MPU6050_acq_sf_B.Gain2[1] = (real32_T)MPU6050_acq_sf_P.Gain2_Gain *
    9.53674316E-7F * (real32_T)MPU6050_acq_sf_B.gyro[1];
  MPU6050_acq_sf_B.Gain2[2] = (real32_T)MPU6050_acq_sf_P.Gain2_Gain *
    9.53674316E-7F * (real32_T)MPU6050_acq_sf_B.gyro[2];

  /* Trigonometry: '<S6>/Trigonometric Function1' incorporates:
   *  Product: '<S6>/Divide1'
   *  Product: '<S6>/Product2'
   *  Product: '<S6>/Product3'
   *  Sqrt: '<S6>/Sqrt1'
   *  Sum: '<S6>/Sum1'
   */
  MPU6050_acq_sf_B.TrigonometricFunction1 = (real32_T)tan(MPU6050_acq_sf_B.Gain
    [1] / (real32_T)sqrt(MPU6050_acq_sf_B.Gain[0] * MPU6050_acq_sf_B.Gain[0] +
    MPU6050_acq_sf_B.Gain[2] * MPU6050_acq_sf_B.Gain[2]));

  /* Sqrt: '<S5>/Sqrt' incorporates:
   *  Product: '<S5>/Product'
   *  Product: '<S5>/Product1'
   *  Product: '<S5>/Product2'
   *  Sum: '<S5>/Sum of Elements'
   */
  MPU6050_acq_sf_B.Sqrt = (real32_T)sqrt((MPU6050_acq_sf_B.Gain[0] *
    MPU6050_acq_sf_B.Gain[0] + MPU6050_acq_sf_B.Gain[1] * MPU6050_acq_sf_B.Gain
    [1]) + MPU6050_acq_sf_B.Gain[2] * MPU6050_acq_sf_B.Gain[2]);

  /* DiscreteIntegrator: '<Root>/Discrete-Time Integrator2' */
  MPU6050_acq_sf_B.DiscreteTimeIntegrator2 =
    MPU6050_acq_sf_DW.DiscreteTimeIntegrator2_DSTATE;

  /* Sum: '<Root>/Sum' incorporates:
   *  Constant: '<Root>/Constant'
   *  Gain: '<Root>/Gain1'
   */
  MPU6050_acq_sf_B.Sum = (real32_T)MPU6050_acq_sf_P.Gain1_Gain * 1.1920929E-7F *
    (real32_T)MPU6050_acq_sf_B.temp + MPU6050_acq_sf_P.Constant_Value_kmf41b2fgv;

  /* Trigonometry: '<S6>/Trigonometric Function' incorporates:
   *  Product: '<S6>/Divide'
   *  Product: '<S6>/Product'
   *  Product: '<S6>/Product1'
   *  Sqrt: '<S6>/Sqrt'
   *  Sum: '<S6>/Sum'
   */
  MPU6050_acq_sf_B.TrigonometricFunction = (real32_T)tan(MPU6050_acq_sf_B.Gain[0]
    / (real32_T)sqrt(MPU6050_acq_sf_B.Gain[1] * MPU6050_acq_sf_B.Gain[1] +
                     MPU6050_acq_sf_B.Gain[2] * MPU6050_acq_sf_B.Gain[2]));

  /* Trigonometry: '<S6>/Trigonometric Function5' incorporates:
   *  Product: '<S6>/Divide5'
   *  Product: '<S6>/Product10'
   *  Product: '<S6>/Product11'
   *  Sqrt: '<S6>/Sqrt5'
   *  Sum: '<S6>/Sum5'
   */
  MPU6050_acq_sf_B.TrigonometricFunction5 = (real32_T)tan(MPU6050_acq_sf_B.Gain
    [2] / (real32_T)sqrt(MPU6050_acq_sf_B.Gain[2] * MPU6050_acq_sf_B.Gain[2] +
    MPU6050_acq_sf_B.Gain[0] * MPU6050_acq_sf_B.Gain[0]));

  /* Step: '<S14>/Step' */
  MPU6050_acq_sf_B.currentTime = MPU6050_acq_sf_M->Timing.t[0];

  /* Step: '<S15>/Step' */
  MPU6050_acq_sf_B.currentTime_mbvzarwird = MPU6050_acq_sf_M->Timing.t[0];

  /* Step: '<S16>/Step' */
  MPU6050_acq_sf_B.currentTime_cl54gopm0x = MPU6050_acq_sf_M->Timing.t[0];

  /* Step: '<S17>/Step' */
  currentTime = MPU6050_acq_sf_M->Timing.t[0];

  /* Step: '<S14>/Step' */
  if (MPU6050_acq_sf_B.currentTime < MPU6050_acq_sf_P.Ramp_start) {
    MPU6050_acq_sf_B.currentTime = MPU6050_acq_sf_P.Step_Y0_pwqnqfylev;
  } else {
    MPU6050_acq_sf_B.currentTime = MPU6050_acq_sf_P.Ramp_slope;
  }

  /* Step: '<S15>/Step' */
  if (MPU6050_acq_sf_B.currentTime_mbvzarwird < MPU6050_acq_sf_P.Ramp1_start) {
    MPU6050_acq_sf_B.currentTime_mbvzarwird =
      MPU6050_acq_sf_P.Step_Y0_lh4xw1o41y;
  } else {
    MPU6050_acq_sf_B.currentTime_mbvzarwird = MPU6050_acq_sf_P.Ramp1_slope;
  }

  /* Step: '<S16>/Step' */
  if (MPU6050_acq_sf_B.currentTime_cl54gopm0x < MPU6050_acq_sf_P.Ramp2_start) {
    MPU6050_acq_sf_B.currentTime_cl54gopm0x =
      MPU6050_acq_sf_P.Step_Y0_komqk5xoj3;
  } else {
    MPU6050_acq_sf_B.currentTime_cl54gopm0x = MPU6050_acq_sf_P.Ramp2_slope;
  }

  /* Step: '<S17>/Step' */
  if (currentTime < MPU6050_acq_sf_P.Ramp3_start) {
    currentTime = MPU6050_acq_sf_P.Step_Y0_l54d23geyq;
  } else {
    currentTime = MPU6050_acq_sf_P.Ramp3_slope;
  }

  /* DataTypeConversion: '<Root>/Data Type Conversion1' incorporates:
   *  Clock: '<S14>/Clock'
   *  Clock: '<S15>/Clock'
   *  Clock: '<S16>/Clock'
   *  Clock: '<S17>/Clock'
   *  Constant: '<S14>/Constant'
   *  Constant: '<S14>/Constant1'
   *  Constant: '<S15>/Constant'
   *  Constant: '<S15>/Constant1'
   *  Constant: '<S16>/Constant'
   *  Constant: '<S16>/Constant1'
   *  Constant: '<S17>/Constant'
   *  Constant: '<S17>/Constant1'
   *  Constant: '<S7>/Constant'
   *  Product: '<S14>/Product'
   *  Product: '<S15>/Product'
   *  Product: '<S16>/Product'
   *  Product: '<S17>/Product'
   *  Sum: '<S14>/Output'
   *  Sum: '<S14>/Sum'
   *  Sum: '<S15>/Output'
   *  Sum: '<S15>/Sum'
   *  Sum: '<S16>/Output'
   *  Sum: '<S16>/Sum'
   *  Sum: '<S17>/Output'
   *  Sum: '<S17>/Sum'
   *  Sum: '<S7>/Sum'
   */
  MPU6050_acq_sf_B.DataTypeConversion1_k1kseus42m = (real32_T)
    ((((((MPU6050_acq_sf_M->Timing.t[0] - MPU6050_acq_sf_P.Ramp_start) *
         MPU6050_acq_sf_B.currentTime + MPU6050_acq_sf_P.Ramp_X0) +
        MPU6050_acq_sf_P.Constant_Value) + ((MPU6050_acq_sf_M->Timing.t[0] -
         MPU6050_acq_sf_P.Ramp1_start) * MPU6050_acq_sf_B.currentTime_mbvzarwird
        + MPU6050_acq_sf_P.Ramp1_X0)) + ((MPU6050_acq_sf_M->Timing.t[0] -
        MPU6050_acq_sf_P.Ramp2_start) * MPU6050_acq_sf_B.currentTime_cl54gopm0x
       + MPU6050_acq_sf_P.Ramp2_X0)) + ((MPU6050_acq_sf_M->Timing.t[0] -
       MPU6050_acq_sf_P.Ramp3_start) * currentTime + MPU6050_acq_sf_P.Ramp3_X0));

  /* Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' incorporates:
   *  MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor'
   */
  p = false;
  p_0 = true;
  if (!(MPU6050_acq_sf_DW.obj.SampleTime ==
        MPU6050_acq_sf_P.FXOS87006AxesSensor_SampleTime)) {
    p_0 = false;
  }

  if (p_0) {
    p = true;
  }

  if (!p) {
    MPU6050_acq_sf_DW.obj.SampleTime =
      MPU6050_acq_sf_P.FXOS87006AxesSensor_SampleTime;
  }

  output[0] = 0;
  output[1] = 0;
  output[2] = 0;
  status = 51U;
  i2cname = 0;
  status = MW_I2C_MasterWrite(i2cname, 29U, &status, 1U, true, false);
  if (0 == status) {
    i2cname = 0;
    MW_I2C_MasterRead(i2cname, 29U, output_raw, 6U, false, true);
    memcpy((void *)&output[0], (void *)&output_raw[0], (size_t)3 * sizeof
           (int16_T));
    output_0 = output[0];
    memcpy((void *)&y[0], (void *)&output_0, (size_t)2 * sizeof(uint8_T));
    x[0] = y[1];
    x[1] = y[0];
    memcpy((void *)&output_0, (void *)&x[0], (size_t)1 * sizeof(int16_T));
    output[0] = output_0;
    output_0 = output[1];
    memcpy((void *)&y[0], (void *)&output_0, (size_t)2 * sizeof(uint8_T));
    x[0] = y[1];
    x[1] = y[0];
    memcpy((void *)&output_0, (void *)&x[0], (size_t)1 * sizeof(int16_T));
    output[1] = output_0;
    output_0 = output[2];
    memcpy((void *)&y[0], (void *)&output_0, (size_t)2 * sizeof(uint8_T));
    x[0] = y[1];
    x[1] = y[0];
    memcpy((void *)&output_0, (void *)&x[0], (size_t)1 * sizeof(int16_T));
    output[2] = output_0;
  }

  /* DataTypeConversion: '<Root>/Data Type Conversion2' incorporates:
   *  MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor'
   *  Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor'
   */
  MPU6050_acq_sf_B.DataTypeConversion2_pm4akzoypx[0] = (real32_T)((real_T)
    output[0] * 0.1);
  MPU6050_acq_sf_B.DataTypeConversion2_pm4akzoypx[1] = (real32_T)((real_T)
    output[1] * 0.1);
  MPU6050_acq_sf_B.DataTypeConversion2_pm4akzoypx[2] = (real32_T)((real_T)
    output[2] * 0.1);

  /* Update for DiscreteIntegrator: '<S9>/Discrete-Time Integrator' */
  MPU6050_acq_sf_DW.DiscreteTimeIntegrator_DSTATE +=
    MPU6050_acq_sf_P.DiscreteTimeIntegrator_gainval * MPU6050_acq_sf_B.Gain3[0];

  /* Update for DiscreteIntegrator: '<S9>/Discrete-Time Integrator1' */
  MPU6050_acq_sf_DW.DiscreteTimeIntegrator1_DSTATE +=
    MPU6050_acq_sf_P.DiscreteTimeIntegrator1_gainval * MPU6050_acq_sf_B.ms;

  /* Update for DiscreteIntegrator: '<S10>/Discrete-Time Integrator' */
  MPU6050_acq_sf_DW.DiscreteTimeIntegrat_d55dfs0xze +=
    MPU6050_acq_sf_P.DiscreteTimeIntegrat_pqq5vkmipt * MPU6050_acq_sf_B.Gain3[1];

  /* Update for DiscreteIntegrator: '<S10>/Discrete-Time Integrator1' */
  MPU6050_acq_sf_DW.DiscreteTimeIntegrat_nvqe3zzsmy +=
    MPU6050_acq_sf_P.DiscreteTimeIntegrat_ahkmhvyocf *
    MPU6050_acq_sf_B.ms_aoti0aembx;

  /* Update for DiscreteIntegrator: '<S11>/Discrete-Time Integrator' */
  MPU6050_acq_sf_DW.DiscreteTimeIntegrat_hi5vld3rfw +=
    MPU6050_acq_sf_P.DiscreteTimeIntegrat_g2335324ts * MPU6050_acq_sf_B.Gain3[2];

  /* Update for DiscreteIntegrator: '<S11>/Discrete-Time Integrator1' */
  MPU6050_acq_sf_DW.DiscreteTimeIntegrat_pniv0mwsqd +=
    MPU6050_acq_sf_P.DiscreteTimeIntegrat_h4r10twv4i *
    MPU6050_acq_sf_B.ms_lmya2fq1on;

  /* Update for DiscreteIntegrator: '<Root>/Discrete-Time Integrator2' */
  MPU6050_acq_sf_DW.DiscreteTimeIntegrator2_DSTATE +=
    MPU6050_acq_sf_P.DiscreteTimeIntegrator2_gainval *
    MPU6050_acq_sf_B.DataTypeConversion_dn5jwqzs2w;

  /* External mode */
  rtExtModeUploadCheckTrigger(2);

  {                                    /* Sample time: [0.0s, 0.0s] */
    rtExtModeUpload(0, MPU6050_acq_sf_M->Timing.t[0]);
  }

  {                                    /* Sample time: [0.05s, 0.0s] */
    rtExtModeUpload(1, ((MPU6050_acq_sf_M->Timing.clockTick1) * 0.05));
  }

  /* signal main to stop simulation */
  {                                    /* Sample time: [0.0s, 0.0s] */
    if ((rtmGetTFinal(MPU6050_acq_sf_M)!=-1) &&
        !((rtmGetTFinal(MPU6050_acq_sf_M)-MPU6050_acq_sf_M->Timing.t[0]) >
          MPU6050_acq_sf_M->Timing.t[0] * (DBL_EPSILON))) {
      rtmSetErrorStatus(MPU6050_acq_sf_M, "Simulation finished");
    }

    if (rtmGetStopRequested(MPU6050_acq_sf_M)) {
      rtmSetErrorStatus(MPU6050_acq_sf_M, "Simulation finished");
    }
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   */
  MPU6050_acq_sf_M->Timing.t[0] =
    (++MPU6050_acq_sf_M->Timing.clockTick0) * MPU6050_acq_sf_M->Timing.stepSize0;

  {
    /* Update absolute timer for sample time: [0.05s, 0.0s] */
    /* The "clockTick1" counts the number of times the code of this task has
     * been executed. The resolution of this integer timer is 0.05, which is the step size
     * of the task. Size of "clockTick1" ensures timer will not overflow during the
     * application lifespan selected.
     */
    MPU6050_acq_sf_M->Timing.clockTick1++;
  }
}

/* Model initialize function */
void MPU6050_acq_sf_initialize(void)
{
  /* Registration code */

  /* initialize real-time model */
  (void) memset((void *)MPU6050_acq_sf_M, 0,
                sizeof(RT_MODEL_MPU6050_acq_sf_T));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&MPU6050_acq_sf_M->solverInfo,
                          &MPU6050_acq_sf_M->Timing.simTimeStep);
    rtsiSetTPtr(&MPU6050_acq_sf_M->solverInfo, &rtmGetTPtr(MPU6050_acq_sf_M));
    rtsiSetStepSizePtr(&MPU6050_acq_sf_M->solverInfo,
                       &MPU6050_acq_sf_M->Timing.stepSize0);
    rtsiSetErrorStatusPtr(&MPU6050_acq_sf_M->solverInfo, (&rtmGetErrorStatus
      (MPU6050_acq_sf_M)));
    rtsiSetRTModelPtr(&MPU6050_acq_sf_M->solverInfo, MPU6050_acq_sf_M);
  }

  rtsiSetSimTimeStep(&MPU6050_acq_sf_M->solverInfo, MAJOR_TIME_STEP);
  rtsiSetSolverName(&MPU6050_acq_sf_M->solverInfo,"FixedStepDiscrete");
  rtmSetTPtr(MPU6050_acq_sf_M, &MPU6050_acq_sf_M->Timing.tArray[0]);
  rtmSetTFinal(MPU6050_acq_sf_M, -1);
  MPU6050_acq_sf_M->Timing.stepSize0 = 0.05;

  /* External mode info */
  MPU6050_acq_sf_M->Sizes.checksums[0] = (1140130080U);
  MPU6050_acq_sf_M->Sizes.checksums[1] = (3432384141U);
  MPU6050_acq_sf_M->Sizes.checksums[2] = (3773557362U);
  MPU6050_acq_sf_M->Sizes.checksums[3] = (93340573U);

  {
    static const sysRanDType rtAlwaysEnabled = SUBSYS_RAN_BC_ENABLE;
    static RTWExtModeInfo rt_ExtModeInfo;
    static const sysRanDType *systemRan[11];
    MPU6050_acq_sf_M->extModeInfo = (&rt_ExtModeInfo);
    rteiSetSubSystemActiveVectorAddresses(&rt_ExtModeInfo, systemRan);
    systemRan[0] = &rtAlwaysEnabled;
    systemRan[1] = &rtAlwaysEnabled;
    systemRan[2] = &rtAlwaysEnabled;
    systemRan[3] = &rtAlwaysEnabled;
    systemRan[4] = &rtAlwaysEnabled;
    systemRan[5] = (sysRanDType *)&MPU6050_acq_sf_DW.i2cRd_SubsysRanBC;
    systemRan[6] = (sysRanDType *)&MPU6050_acq_sf_DW.i2cRd_SubsysRanBC;
    systemRan[7] = (sysRanDType *)&MPU6050_acq_sf_DW.i2cWr.i2cWr_SubsysRanBC;
    systemRan[8] = (sysRanDType *)&MPU6050_acq_sf_DW.i2cWr.i2cWr_SubsysRanBC;
    systemRan[9] = &rtAlwaysEnabled;
    systemRan[10] = &rtAlwaysEnabled;
    rteiSetModelMappingInfoPtr(MPU6050_acq_sf_M->extModeInfo,
      &MPU6050_acq_sf_M->SpecialInfo.mappingInfo);
    rteiSetChecksumsPtr(MPU6050_acq_sf_M->extModeInfo,
                        MPU6050_acq_sf_M->Sizes.checksums);
    rteiSetTPtr(MPU6050_acq_sf_M->extModeInfo, rtmGetTPtr(MPU6050_acq_sf_M));
  }

  /* block I/O */
  (void) memset(((void *) &MPU6050_acq_sf_B), 0,
                sizeof(B_MPU6050_acq_sf_T));

  /* states (dwork) */
  (void) memset((void *)&MPU6050_acq_sf_DW, 0,
                sizeof(DW_MPU6050_acq_sf_T));

  /* data type transition information */
  {
    static DataTypeTransInfo dtInfo;
    (void) memset((char_T *) &dtInfo, 0,
                  sizeof(dtInfo));
    MPU6050_acq_sf_M->SpecialInfo.mappingInfo = (&dtInfo);
    dtInfo.numDataTypes = 21;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.BTransTable = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.PTransTable = &rtPTransTable;
  }

  {
    freedomk64f_fxos8700_MPU6050__T *obj;
    uint8_T output;
    uint8_T status;
    uint8_T SwappedDataBytes[2];
    uint32_T i2cname;
    int32_T i;

    /* Start for Chart: '<Root>/MPU6050' incorporates:
     *  Start for SubSystem: '<S4>/i2cWr'
     */
    MPU6050_acq_sf_i2cWr_Start(&MPU6050_acq_sf_DW.i2cWr);

    /* Start for Chart: '<Root>/MPU6050' incorporates:
     *  Start for SubSystem: '<S4>/i2cRd'
     */
    /* Start for MATLABSystem: '<S12>/I2C Master Read' */
    MPU6050_acq_sf_DW.obj_gyfctg30e0.isInitialized = 0;

    /* [EOF] */
    /*  */
    MPU6050_acq_sf_DW.obj_gyfctg30e0.SampleTime =
      MPU6050_acq_sf_P.I2CMasterRead_SampleTime;
    MPU6050_acq_sf_DW.obj_gyfctg30e0.isInitialized = 1;
    i2cname = 0;
    MW_I2C_Open(i2cname, 0U);

    /* 100KHz. */
    /* KHz */
    MPU6050_acq_sf_DW.obj_gyfctg30e0.BusSpeed = 100000U;
    i2cname = 0;
    MW_I2C_SetBusSpeed(i2cname, MPU6050_acq_sf_DW.obj_gyfctg30e0.BusSpeed);

    /* Start for MATLABSystem: '<Root>/Digital Write' */
    MPU6050_acq_sf_DW.obj_j4lwpkksvg.isInitialized = 0;

    /* [EOF] */
    MPU6050_acq_sf_DW.obj_j4lwpkksvg.isInitialized = 1;
    MW_digitalIO_open(MPU6050_acq_sf_Pin_pe1cae5abyr, 1U);

    /* Start for MATLABSystem: '<Root>/Digital Write1' */
    MPU6050_acq_sf_DW.obj_l3d0nzm41i.isInitialized = 0;

    /* [EOF] */
    MPU6050_acq_sf_DW.obj_l3d0nzm41i.isInitialized = 1;
    MW_digitalIO_open(MPU6050_acq_sf_Pin_pe1cae5aby, 1U);

    /* Start for MATLABSystem: '<Root>/Digital Write2' */
    MPU6050_acq_sf_DW.obj_aoj3snuc3w.isInitialized = 0;

    /* [EOF] */
    MPU6050_acq_sf_DW.obj_aoj3snuc3w.isInitialized = 1;
    MW_digitalIO_open(MPU6050_acq_sf_Pin, 1U);

    /* Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' */
    obj = &MPU6050_acq_sf_DW.obj;
    MPU6050_acq_sf_DW.obj.isInitialized = 0;
    obj->i2cobj.isInitialized = 0;

    /* [EOF] */
    /*  */
    MPU6050_acq_sf_DW.obj.SampleTime =
      MPU6050_acq_sf_P.FXOS87006AxesSensor_SampleTime;
    obj = &MPU6050_acq_sf_DW.obj;
    MPU6050_acq_sf_DW.obj.isInitialized = 1;
    i2cname = 0;
    MW_I2C_Open(i2cname, 0U);

    /* KHz */
    obj->i2cobj.BusSpeed = 100000U;
    i2cname = 0;
    MW_I2C_SetBusSpeed(i2cname, obj->i2cobj.BusSpeed);
    SwappedDataBytes[0] = 43U;
    SwappedDataBytes[1] = 64U;
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);
    OSA_TimeDelay(500U);
    output = 0U;
    status = 42U;
    i2cname = 0;
    status = MW_I2C_MasterWrite(i2cname, 29U, &status, 1U, true, false);
    if (0 == status) {
      i2cname = 0;
      MW_I2C_MasterRead(i2cname, 29U, &status, 1U, false, true);
      memcpy((void *)&output, (void *)&status, (size_t)1 * sizeof(uint8_T));
    }

    SwappedDataBytes[0] = 42U;
    SwappedDataBytes[1] = (uint8_T)(output & 254);
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);
    SwappedDataBytes[0] = 14U;
    SwappedDataBytes[1] = 1U;
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);
    SwappedDataBytes[0] = 91U;
    SwappedDataBytes[1] = 1U;
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);
    SwappedDataBytes[0] = 42U;
    SwappedDataBytes[1] = 1U;
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);

    /* End of Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' */

    /* InitializeConditions for DiscreteIntegrator: '<S9>/Discrete-Time Integrator' */
    MPU6050_acq_sf_DW.DiscreteTimeIntegrator_DSTATE =
      MPU6050_acq_sf_P.DiscreteTimeIntegrator_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S9>/Discrete-Time Integrator1' */
    MPU6050_acq_sf_DW.DiscreteTimeIntegrator1_DSTATE =
      MPU6050_acq_sf_P.DiscreteTimeIntegrator1_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S10>/Discrete-Time Integrator' */
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_d55dfs0xze =
      MPU6050_acq_sf_P.DiscreteTimeIntegrat_aq4ds4pyqg;

    /* InitializeConditions for DiscreteIntegrator: '<S10>/Discrete-Time Integrator1' */
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_nvqe3zzsmy =
      MPU6050_acq_sf_P.DiscreteTimeIntegrat_k0purytsyl;

    /* InitializeConditions for DiscreteIntegrator: '<S11>/Discrete-Time Integrator' */
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_hi5vld3rfw =
      MPU6050_acq_sf_P.DiscreteTimeIntegrat_ond4h1bj2k;

    /* InitializeConditions for DiscreteIntegrator: '<S11>/Discrete-Time Integrator1' */
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_pniv0mwsqd =
      MPU6050_acq_sf_P.DiscreteTimeIntegrat_lxbswrp2g2;

    /* InitializeConditions for DiscreteIntegrator: '<Root>/Discrete-Time Integrator2' */
    MPU6050_acq_sf_DW.DiscreteTimeIntegrator2_DSTATE =
      MPU6050_acq_sf_P.DiscreteTimeIntegrator2_IC;
    MPU6050_acq_sf_DW.is_active_c3_MPU6050_acq_sf = 0U;
    MPU6050_acq_sf_DW.is_c3_MPU6050_acq_sf = MPU6050_acq__IN_NO_ACTIVE_CHILD;

    /* SystemInitialize for Chart: '<Root>/MPU6050' incorporates:
     *  SystemInitialize for SubSystem: '<S4>/i2cRd'
     */
    for (i = 0; i < 7; i++) {
      /* SystemInitialize for Outport: '<S12>/datar' */
      MPU6050_acq_sf_B.DataTypeConversion_khxxwq3rq5[i] =
        MPU6050_acq_sf_P.datar_Y0;
    }

    /* SystemInitialize for Chart: '<S8>/grav_init_avg' */
    /* Entry: grav_init_phase/grav_init_avg */
    MPU6050_acq_sf_DW.is_active_c1_MPU6050_acq_sf = 1U;

    /* Entry Internal: grav_init_phase/grav_init_avg */
    MPU6050_acq_sf_DW.is_c1_MPU6050_acq_sf = MPU6050__IN_Steadystate_gravity;

    /* Entry Internal 'Steadystate_gravity': '<S19>:9' */
    /* Transition: '<S19>:38' */
    MPU6050_acq_sf_DW.is_Steadystate_gravity = MPU6050_acq_sf_IN_config;
    MPU6050_acq_sf_DW.temporalCounter_i1 = 0U;

    /* Enable for Chart: '<S8>/grav_init_avg' */
    /* Entry 'config': '<S19>:28' */
    MPU6050_acq_sf_DW.previousTicks = MPU6050_acq_sf_M->Timing.clockTick1;
  }
}

/* Model terminate function */
void MPU6050_acq_sf_terminate(void)
{
  uint32_T i2cname;

  /* Terminate for Chart: '<Root>/MPU6050' incorporates:
   *  Terminate for SubSystem: '<S4>/i2cWr'
   */
  MPU6050_acq_sf_i2cWr_Term(&MPU6050_acq_sf_DW.i2cWr);

  /* Terminate for Chart: '<Root>/MPU6050' incorporates:
   *  Terminate for SubSystem: '<S4>/i2cRd'
   */
  /* Start for MATLABSystem: '<S12>/I2C Master Read' incorporates:
   *  Terminate for MATLABSystem: '<S12>/I2C Master Read'
   */
  if (MPU6050_acq_sf_DW.obj_gyfctg30e0.isInitialized == 1) {
    MPU6050_acq_sf_DW.obj_gyfctg30e0.isInitialized = 2;
    i2cname = 0;
    MW_I2C_Close(i2cname);
  }

  /* End of Start for MATLABSystem: '<S12>/I2C Master Read' */

  /* Start for MATLABSystem: '<Root>/Digital Write' incorporates:
   *  Terminate for MATLABSystem: '<Root>/Digital Write'
   */
  if (MPU6050_acq_sf_DW.obj_j4lwpkksvg.isInitialized == 1) {
    MPU6050_acq_sf_DW.obj_j4lwpkksvg.isInitialized = 2;
    MW_digitalIO_close(MPU6050_acq_sf_Pin_pe1cae5abyr);
  }

  /* End of Start for MATLABSystem: '<Root>/Digital Write' */

  /* Start for MATLABSystem: '<Root>/Digital Write1' incorporates:
   *  Terminate for MATLABSystem: '<Root>/Digital Write1'
   */
  if (MPU6050_acq_sf_DW.obj_l3d0nzm41i.isInitialized == 1) {
    MPU6050_acq_sf_DW.obj_l3d0nzm41i.isInitialized = 2;
    MW_digitalIO_close(MPU6050_acq_sf_Pin_pe1cae5aby);
  }

  /* End of Start for MATLABSystem: '<Root>/Digital Write1' */

  /* Start for MATLABSystem: '<Root>/Digital Write2' incorporates:
   *  Terminate for MATLABSystem: '<Root>/Digital Write2'
   */
  if (MPU6050_acq_sf_DW.obj_aoj3snuc3w.isInitialized == 1) {
    MPU6050_acq_sf_DW.obj_aoj3snuc3w.isInitialized = 2;
    MW_digitalIO_close(MPU6050_acq_sf_Pin);
  }

  /* End of Start for MATLABSystem: '<Root>/Digital Write2' */
  /* Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' incorporates:
   *  Terminate for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor'
   */
  if (MPU6050_acq_sf_DW.obj.isInitialized == 1) {
    MPU6050_acq_sf_DW.obj.isInitialized = 2;
    i2cname = 0;
    MW_I2C_Close(i2cname);
  }

  /* End of Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' */
}
