/*
 * MPU6050_acq_sf.c
 *
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * Code generation for model "MPU6050_acq_sf".
 *
 * Model version              : 1.61
 * Simulink Coder version : 8.12 (R2017a) 16-Feb-2017
 * C source code generated on : Mon Oct 02 16:38:26 2017
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "MPU6050_acq_sf.h"
#include "MPU6050_acq_sf_private.h"
#include "MPU6050_acq_sf_dt.h"
#define MPU6050_acq_sf_NoAck           (false)
#define MPU6050_acq_sf_RepeatedStart   (false)
#define MPU6050_acq_sf_SlaveAddress    (104U)

/* Named constants for Chart: '<Root>/MPU6050' */
#define MPU6050_acq__IN_NO_ACTIVE_CHILD ((uint8_T)0U)
#define MPU6050_acq_s_IN_initialisation ((uint8_T)2U)
#define M_IN_Lecture_acceleration3_axes ((uint8_T)1U)
#define MPU6050_SlaveAddress_pe1cae5aby (104U)
#define MPU6050_acq_sf_RegisterAddress ((uint8_T)59U)

/* Block signals (auto storage) */
B_MPU6050_acq_sf_T MPU6050_acq_sf_B;

/* Block states (auto storage) */
DW_MPU6050_acq_sf_T MPU6050_acq_sf_DW;

/* Real-time model */
RT_MODEL_MPU6050_acq_sf_T MPU6050_acq_sf_M_;
RT_MODEL_MPU6050_acq_sf_T *const MPU6050_acq_sf_M = &MPU6050_acq_sf_M_;

/* Start for function-call system: '<S2>/i2cWr' */
void MPU6050_acq_sf_i2cWr_Start(DW_i2cWr_MPU6050_acq_sf_T *localDW)
{
  uint32_T i2cname;

  /* Start for MATLABSystem: '<S9>/I2C Master Write' */
  localDW->obj.isInitialized = 0;

  /* [EOF] */
  /*  */
  localDW->obj.isInitialized = 1;
  i2cname = 0;
  MW_I2C_Open(i2cname, 0U);

  /* 100KHz. */
  /* KHz */
  localDW->obj.BusSpeed = 100000U;
  i2cname = 0;
  MW_I2C_SetBusSpeed(i2cname, localDW->obj.BusSpeed);
}

/* Output and update for function-call system: '<S2>/i2cWr' */
void MPU6050_acq_sf_i2cWr(uint16_T rtu_dataw, DW_i2cWr_MPU6050_acq_sf_T *localDW)
{
  uint8_T SwappedDataBytes[2];
  uint32_T i2cname;
  uint16_T x;
  uint8_T x_0[2];

  /* Start for MATLABSystem: '<S9>/I2C Master Write' incorporates:
   *  MATLABSystem: '<S9>/I2C Master Write'
   */
  memcpy((void *)&SwappedDataBytes[0], (void *)&rtu_dataw, (size_t)2 * sizeof
         (uint8_T));
  x_0[0] = SwappedDataBytes[1];
  x_0[1] = SwappedDataBytes[0];
  memcpy((void *)&x, (void *)&x_0[0], (size_t)1 * sizeof(uint16_T));
  memcpy((void *)&SwappedDataBytes[0], (void *)&x, (size_t)2 * sizeof(uint8_T));
  i2cname = 0;
  MW_I2C_MasterWrite(i2cname, MPU6050_acq_sf_SlaveAddress, SwappedDataBytes, 2U,
                     MPU6050_acq_sf_RepeatedStart, MPU6050_acq_sf_NoAck);
  localDW->i2cWr_SubsysRanBC = 4;
}

/* Termination for function-call system: '<S2>/i2cWr' */
void MPU6050_acq_sf_i2cWr_Term(DW_i2cWr_MPU6050_acq_sf_T *localDW)
{
  uint32_T i2cname;

  /* Start for MATLABSystem: '<S9>/I2C Master Write' incorporates:
   *  Terminate for MATLABSystem: '<S9>/I2C Master Write'
   */
  if (localDW->obj.isInitialized == 1) {
    localDW->obj.isInitialized = 2;
    i2cname = 0;
    MW_I2C_Close(i2cname);
  }

  /* End of Start for MATLABSystem: '<S9>/I2C Master Write' */
}

/* Model step function */
void MPU6050_acq_sf_step(void)
{
  boolean_T p;
  boolean_T p_0;
  uint8_T status;
  uint32_T i2cname;
  uint8_T output_raw[14];
  uint8_T y[2];
  uint8_T x[2];
  real32_T rtb_Sqrt5;
  real32_T rtb_Product1;
  real32_T rtb_Product;
  int32_T i;
  uint16_T output;

  /* Reset subsysRan breadcrumbs */
  srClearBC(MPU6050_acq_sf_DW.i2cWr.i2cWr_SubsysRanBC);

  /* Reset subsysRan breadcrumbs */
  srClearBC(MPU6050_acq_sf_DW.i2cRd_SubsysRanBC);

  /* DiscreteIntegrator: '<S5>/Discrete-Time Integrator' */
  MPU6050_acq_sf_B.ms = MPU6050_acq_sf_DW.DiscreteTimeIntegrator_DSTATE;

  /* Gain: '<S5>/to- km_h' */
  MPU6050_acq_sf_B.tokm_h = MPU6050_acq_sf_P.tokm_h_Gain * MPU6050_acq_sf_B.ms;

  /* DiscreteIntegrator: '<S5>/Discrete-Time Integrator1' */
  MPU6050_acq_sf_B.DiscreteTimeIntegrator1 =
    MPU6050_acq_sf_DW.DiscreteTimeIntegrator1_DSTATE;

  /* Gain: '<S5>/Gain4' */
  MPU6050_acq_sf_B.Gain4 = MPU6050_acq_sf_P.Gain4_Gain *
    MPU6050_acq_sf_B.DiscreteTimeIntegrator1;

  /* Chart: '<Root>/MPU6050' */
  /* Gateway: MPU6050 */
  /* During: MPU6050 */
  if (MPU6050_acq_sf_DW.is_active_c3_MPU6050_acq_sf == 0U) {
    /* Entry: MPU6050 */
    MPU6050_acq_sf_DW.is_active_c3_MPU6050_acq_sf = 1U;

    /* Entry Internal: MPU6050 */
    /* Transition: '<S2>:35' */
    MPU6050_acq_sf_DW.is_c3_MPU6050_acq_sf = MPU6050_acq_s_IN_initialisation;

    /* Entry 'initialisation': '<S2>:34' */
    /* Simulink Function 'i2cWr': '<S2>:28' */
    MPU6050_acq_sf_B.dataw = 27392U;

    /* Outputs for Function Call SubSystem: '<S2>/i2cWr' */
    MPU6050_acq_sf_i2cWr(MPU6050_acq_sf_B.dataw, &MPU6050_acq_sf_DW.i2cWr);

    /* End of Outputs for SubSystem: '<S2>/i2cWr' */

    /* Power on */
    /* Simulink Function 'i2cWr': '<S2>:28' */
    MPU6050_acq_sf_B.dataw = 6928U;

    /* Outputs for Function Call SubSystem: '<S2>/i2cWr' */
    MPU6050_acq_sf_i2cWr(MPU6050_acq_sf_B.dataw, &MPU6050_acq_sf_DW.i2cWr);

    /* End of Outputs for SubSystem: '<S2>/i2cWr' */

    /* gyro 0x10=1000/s */
    /* Simulink Function 'i2cWr': '<S2>:28' */
    MPU6050_acq_sf_B.dataw = 7176U;

    /* Outputs for Function Call SubSystem: '<S2>/i2cWr' */
    MPU6050_acq_sf_i2cWr(MPU6050_acq_sf_B.dataw, &MPU6050_acq_sf_DW.i2cWr);

    /* End of Outputs for SubSystem: '<S2>/i2cWr' */

    /* acce 0x08= 4G */
    /* Simulink Function 'i2cWr': '<S2>:28' */
    MPU6050_acq_sf_B.dataw = 6662U;

    /* Outputs for Function Call SubSystem: '<S2>/i2cWr' */
    MPU6050_acq_sf_i2cWr(MPU6050_acq_sf_B.dataw, &MPU6050_acq_sf_DW.i2cWr);

    /* End of Outputs for SubSystem: '<S2>/i2cWr' */

    /* filtrage+actu 0x06= 19ms */
    /* Simulink Function 'i2cWr': '<S2>:28' */
    MPU6050_acq_sf_B.dataw = 14096U;

    /* Outputs for Function Call SubSystem: '<S2>/i2cWr' */
    MPU6050_acq_sf_i2cWr(MPU6050_acq_sf_B.dataw, &MPU6050_acq_sf_DW.i2cWr);

    /* End of Outputs for SubSystem: '<S2>/i2cWr' */

    /* INT_PIN_CFG */
    /* Simulink Function 'i2cWr': '<S2>:28' */
    MPU6050_acq_sf_B.dataw = 14336U;

    /* Outputs for Function Call SubSystem: '<S2>/i2cWr' */
    MPU6050_acq_sf_i2cWr(MPU6050_acq_sf_B.dataw, &MPU6050_acq_sf_DW.i2cWr);

    /* End of Outputs for SubSystem: '<S2>/i2cWr' */

    /* Interrupt Enable 0 dsactiv */
  } else if (MPU6050_acq_sf_DW.is_c3_MPU6050_acq_sf ==
             M_IN_Lecture_acceleration3_axes) {
    /* Outputs for Function Call SubSystem: '<S2>/i2cRd' */
    /* Start for MATLABSystem: '<S8>/I2C Master Read' incorporates:
     *  MATLABSystem: '<S8>/I2C Master Read'
     */
    /* During 'Lecture_acceleration3_axes': '<S2>:52' */
    /* Simulink Function 'i2cRd': '<S2>:56' */
    p = false;
    p_0 = true;
    if (!(MPU6050_acq_sf_DW.obj.SampleTime ==
          MPU6050_acq_sf_P.I2CMasterRead_SampleTime)) {
      p_0 = false;
    }

    if (p_0) {
      p = true;
    }

    if (!p) {
      MPU6050_acq_sf_DW.obj.SampleTime =
        MPU6050_acq_sf_P.I2CMasterRead_SampleTime;
    }

    for (i = 0; i < 7; i++) {
      MPU6050_acq_sf_B.output[i] = 0U;
    }

    status = MPU6050_acq_sf_RegisterAddress;
    i2cname = 0;
    status = MW_I2C_MasterWrite(i2cname, MPU6050_SlaveAddress_pe1cae5aby,
      &status, 1U, true, false);
    if (0 == status) {
      i2cname = 0;
      MW_I2C_MasterRead(i2cname, MPU6050_SlaveAddress_pe1cae5aby, output_raw,
                        14U, false, true);
      memcpy((void *)&MPU6050_acq_sf_B.output[0], (void *)&output_raw[0],
             (size_t)7 * sizeof(uint16_T));
      for (i = 0; i < 7; i++) {
        output = MPU6050_acq_sf_B.output[i];
        memcpy((void *)&y[0], (void *)&output, (size_t)2 * sizeof(uint8_T));
        x[0] = y[1];
        x[1] = y[0];
        memcpy((void *)&output, (void *)&x[0], (size_t)1 * sizeof(uint16_T));
        MPU6050_acq_sf_B.output[i] = output;
      }
    }

    /* DataTypeConversion: '<S8>/Data Type Conversion' incorporates:
     *  MATLABSystem: '<S8>/I2C Master Read'
     *  Start for MATLABSystem: '<S8>/I2C Master Read'
     */
    for (i = 0; i < 7; i++) {
      MPU6050_acq_sf_B.DataTypeConversion[i] = (int16_T)
        MPU6050_acq_sf_B.output[i];
    }

    /* End of DataTypeConversion: '<S8>/Data Type Conversion' */
    MPU6050_acq_sf_DW.i2cRd_SubsysRanBC = 4;

    /* End of Outputs for SubSystem: '<S2>/i2cRd' */
    MPU6050_acq_sf_B.acc[0] = MPU6050_acq_sf_B.DataTypeConversion[0];
    MPU6050_acq_sf_B.gyro[0] = MPU6050_acq_sf_B.DataTypeConversion[4];
    MPU6050_acq_sf_B.acc[1] = MPU6050_acq_sf_B.DataTypeConversion[1];
    MPU6050_acq_sf_B.gyro[1] = MPU6050_acq_sf_B.DataTypeConversion[5];
    MPU6050_acq_sf_B.acc[2] = MPU6050_acq_sf_B.DataTypeConversion[2];
    MPU6050_acq_sf_B.gyro[2] = MPU6050_acq_sf_B.DataTypeConversion[6];
    MPU6050_acq_sf_B.temp = MPU6050_acq_sf_B.DataTypeConversion[3];
  } else {
    /* During 'initialisation': '<S2>:34' */
    /* Transition: '<S2>:60' */
    MPU6050_acq_sf_DW.is_c3_MPU6050_acq_sf = M_IN_Lecture_acceleration3_axes;
  }

  /* End of Chart: '<Root>/MPU6050' */

  /* Gain: '<Root>/Gain' */
  MPU6050_acq_sf_B.Gain[0] = (real32_T)MPU6050_acq_sf_P.Gain_Gain_ha1plv3jwv *
    7.4505806E-9F * (real32_T)MPU6050_acq_sf_B.acc[0];

  /* Gain: '<Root>/Gain3' */
  MPU6050_acq_sf_B.Gain3[0] = MPU6050_acq_sf_P.Gain3_Gain *
    MPU6050_acq_sf_B.Gain[0];

  /* Gain: '<Root>/Gain' */
  MPU6050_acq_sf_B.Gain[1] = (real32_T)MPU6050_acq_sf_P.Gain_Gain_ha1plv3jwv *
    7.4505806E-9F * (real32_T)MPU6050_acq_sf_B.acc[1];

  /* Gain: '<Root>/Gain3' */
  MPU6050_acq_sf_B.Gain3[1] = MPU6050_acq_sf_P.Gain3_Gain *
    MPU6050_acq_sf_B.Gain[1];

  /* Gain: '<Root>/Gain' */
  MPU6050_acq_sf_B.Gain[2] = (real32_T)MPU6050_acq_sf_P.Gain_Gain_ha1plv3jwv *
    7.4505806E-9F * (real32_T)MPU6050_acq_sf_B.acc[2];

  /* Gain: '<Root>/Gain3' */
  MPU6050_acq_sf_B.Gain3[2] = MPU6050_acq_sf_P.Gain3_Gain *
    MPU6050_acq_sf_B.Gain[2];

  /* DiscreteIntegrator: '<S6>/Discrete-Time Integrator' */
  MPU6050_acq_sf_B.ms_aoti0aembx =
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_d55dfs0xze;

  /* Gain: '<S6>/to- km_h' */
  MPU6050_acq_sf_B.tokm_h_g4tmtqpyy3 = MPU6050_acq_sf_P.tokm_h_Gain_i0zxrskrml *
    MPU6050_acq_sf_B.ms_aoti0aembx;

  /* DiscreteIntegrator: '<S6>/Discrete-Time Integrator1' */
  MPU6050_acq_sf_B.DiscreteTimeIntegrat_kkx04wtjrb =
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_nvqe3zzsmy;

  /* Gain: '<S6>/Gain4' */
  MPU6050_acq_sf_B.Gain4_dhjf2huq5b = MPU6050_acq_sf_P.Gain4_Gain_fwjs0klxb4 *
    MPU6050_acq_sf_B.DiscreteTimeIntegrat_kkx04wtjrb;

  /* DiscreteIntegrator: '<S7>/Discrete-Time Integrator' */
  MPU6050_acq_sf_B.ms_lmya2fq1on =
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_hi5vld3rfw;

  /* Gain: '<S7>/to- km_h' */
  MPU6050_acq_sf_B.tokm_h_bdjcdnhyci = MPU6050_acq_sf_P.tokm_h_Gain_ij5ephcub4 *
    MPU6050_acq_sf_B.ms_lmya2fq1on;

  /* DiscreteIntegrator: '<S7>/Discrete-Time Integrator1' */
  MPU6050_acq_sf_B.DiscreteTimeIntegrat_jyeoei41v3 =
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_pniv0mwsqd;

  /* Gain: '<S7>/Gain4' */
  MPU6050_acq_sf_B.Gain4_na2kacdtwv = MPU6050_acq_sf_P.Gain4_Gain_g45celja43 *
    MPU6050_acq_sf_B.DiscreteTimeIntegrat_jyeoei41v3;

  /* Gain: '<Root>/Gain2' */
  MPU6050_acq_sf_B.Gain2[0] = (real32_T)MPU6050_acq_sf_P.Gain2_Gain_fm05jmatpj *
    9.53674316E-7F * (real32_T)MPU6050_acq_sf_B.gyro[0];
  MPU6050_acq_sf_B.Gain2[1] = (real32_T)MPU6050_acq_sf_P.Gain2_Gain_fm05jmatpj *
    9.53674316E-7F * (real32_T)MPU6050_acq_sf_B.gyro[1];
  MPU6050_acq_sf_B.Gain2[2] = (real32_T)MPU6050_acq_sf_P.Gain2_Gain_fm05jmatpj *
    9.53674316E-7F * (real32_T)MPU6050_acq_sf_B.gyro[2];

  /* Trigonometry: '<S4>/Trigonometric Function1' incorporates:
   *  Product: '<S4>/Divide1'
   *  Product: '<S4>/Product2'
   *  Product: '<S4>/Product3'
   *  Sqrt: '<S4>/Sqrt1'
   *  Sum: '<S4>/Sum1'
   */
  MPU6050_acq_sf_B.TrigonometricFunction1 = (real32_T)tan(MPU6050_acq_sf_B.Gain
    [1] / (real32_T)sqrt(MPU6050_acq_sf_B.Gain[0] * MPU6050_acq_sf_B.Gain[0] +
    MPU6050_acq_sf_B.Gain[2] * MPU6050_acq_sf_B.Gain[2]));

  /* Gain: '<S3>/Gain' */
  rtb_Sqrt5 = MPU6050_acq_sf_P.Gain_Gain * MPU6050_acq_sf_B.Gain3[0];

  /* Product: '<S3>/Product' */
  rtb_Product = rtb_Sqrt5 * rtb_Sqrt5;

  /* Gain: '<S3>/Gain1' */
  rtb_Sqrt5 = MPU6050_acq_sf_P.Gain1_Gain * MPU6050_acq_sf_B.Gain3[1];

  /* Product: '<S3>/Product1' */
  rtb_Product1 = rtb_Sqrt5 * rtb_Sqrt5;

  /* Gain: '<S3>/Gain2' */
  rtb_Sqrt5 = MPU6050_acq_sf_P.Gain2_Gain * MPU6050_acq_sf_B.Gain3[2];

  /* Sqrt: '<S3>/Sqrt' incorporates:
   *  Product: '<S3>/Product2'
   *  Sum: '<S3>/Sum of Elements'
   */
  MPU6050_acq_sf_B.Sqrt = (real32_T)sqrt((rtb_Product + rtb_Product1) +
    rtb_Sqrt5 * rtb_Sqrt5);

  /* Sum: '<Root>/Sum' incorporates:
   *  Constant: '<Root>/Constant'
   *  Gain: '<Root>/Gain1'
   */
  MPU6050_acq_sf_B.Sum = (real32_T)MPU6050_acq_sf_P.Gain1_Gain_eqxfa3sskl *
    1.1920929E-7F * (real32_T)MPU6050_acq_sf_B.temp +
    MPU6050_acq_sf_P.Constant_Value;

  /* Trigonometry: '<S4>/Trigonometric Function' incorporates:
   *  Product: '<S4>/Divide'
   *  Product: '<S4>/Product'
   *  Product: '<S4>/Product1'
   *  Sqrt: '<S4>/Sqrt'
   *  Sum: '<S4>/Sum'
   */
  MPU6050_acq_sf_B.TrigonometricFunction = (real32_T)tan(MPU6050_acq_sf_B.Gain[0]
    / (real32_T)sqrt(MPU6050_acq_sf_B.Gain[1] * MPU6050_acq_sf_B.Gain[1] +
                     MPU6050_acq_sf_B.Gain[2] * MPU6050_acq_sf_B.Gain[2]));

  /* Trigonometry: '<S4>/Trigonometric Function5' incorporates:
   *  Product: '<S4>/Divide5'
   *  Product: '<S4>/Product10'
   *  Product: '<S4>/Product11'
   *  Sqrt: '<S4>/Sqrt5'
   *  Sum: '<S4>/Sum5'
   */
  MPU6050_acq_sf_B.TrigonometricFunction5 = (real32_T)tan(MPU6050_acq_sf_B.Gain
    [2] / (real32_T)sqrt(MPU6050_acq_sf_B.Gain[2] * MPU6050_acq_sf_B.Gain[2] +
    MPU6050_acq_sf_B.Gain[0] * MPU6050_acq_sf_B.Gain[0]));

  /* Update for DiscreteIntegrator: '<S5>/Discrete-Time Integrator' */
  MPU6050_acq_sf_DW.DiscreteTimeIntegrator_DSTATE +=
    MPU6050_acq_sf_P.DiscreteTimeIntegrator_gainval * MPU6050_acq_sf_B.Gain3[0];

  /* Update for DiscreteIntegrator: '<S5>/Discrete-Time Integrator1' */
  MPU6050_acq_sf_DW.DiscreteTimeIntegrator1_DSTATE +=
    MPU6050_acq_sf_P.DiscreteTimeIntegrator1_gainval * MPU6050_acq_sf_B.ms;

  /* Update for DiscreteIntegrator: '<S6>/Discrete-Time Integrator' */
  MPU6050_acq_sf_DW.DiscreteTimeIntegrat_d55dfs0xze +=
    MPU6050_acq_sf_P.DiscreteTimeIntegrat_pqq5vkmipt * MPU6050_acq_sf_B.Gain3[1];

  /* Update for DiscreteIntegrator: '<S6>/Discrete-Time Integrator1' */
  MPU6050_acq_sf_DW.DiscreteTimeIntegrat_nvqe3zzsmy +=
    MPU6050_acq_sf_P.DiscreteTimeIntegrat_ahkmhvyocf *
    MPU6050_acq_sf_B.ms_aoti0aembx;

  /* Update for DiscreteIntegrator: '<S7>/Discrete-Time Integrator' */
  MPU6050_acq_sf_DW.DiscreteTimeIntegrat_hi5vld3rfw +=
    MPU6050_acq_sf_P.DiscreteTimeIntegrat_g2335324ts * MPU6050_acq_sf_B.Gain3[2];

  /* Update for DiscreteIntegrator: '<S7>/Discrete-Time Integrator1' */
  MPU6050_acq_sf_DW.DiscreteTimeIntegrat_pniv0mwsqd +=
    MPU6050_acq_sf_P.DiscreteTimeIntegrat_h4r10twv4i *
    MPU6050_acq_sf_B.ms_lmya2fq1on;

  /* External mode */
  rtExtModeUploadCheckTrigger(1);

  {                                    /* Sample time: [0.05s, 0.0s] */
    rtExtModeUpload(0, MPU6050_acq_sf_M->Timing.taskTime0);
  }

  /* signal main to stop simulation */
  {                                    /* Sample time: [0.05s, 0.0s] */
    if ((rtmGetTFinal(MPU6050_acq_sf_M)!=-1) &&
        !((rtmGetTFinal(MPU6050_acq_sf_M)-MPU6050_acq_sf_M->Timing.taskTime0) >
          MPU6050_acq_sf_M->Timing.taskTime0 * (DBL_EPSILON))) {
      rtmSetErrorStatus(MPU6050_acq_sf_M, "Simulation finished");
    }

    if (rtmGetStopRequested(MPU6050_acq_sf_M)) {
      rtmSetErrorStatus(MPU6050_acq_sf_M, "Simulation finished");
    }
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   */
  MPU6050_acq_sf_M->Timing.taskTime0 =
    (++MPU6050_acq_sf_M->Timing.clockTick0) * MPU6050_acq_sf_M->Timing.stepSize0;
}

/* Model initialize function */
void MPU6050_acq_sf_initialize(void)
{
  /* Registration code */

  /* initialize real-time model */
  (void) memset((void *)MPU6050_acq_sf_M, 0,
                sizeof(RT_MODEL_MPU6050_acq_sf_T));
  rtmSetTFinal(MPU6050_acq_sf_M, -1);
  MPU6050_acq_sf_M->Timing.stepSize0 = 0.05;

  /* External mode info */
  MPU6050_acq_sf_M->Sizes.checksums[0] = (2140758257U);
  MPU6050_acq_sf_M->Sizes.checksums[1] = (2376781971U);
  MPU6050_acq_sf_M->Sizes.checksums[2] = (539344879U);
  MPU6050_acq_sf_M->Sizes.checksums[3] = (1656372485U);

  {
    static const sysRanDType rtAlwaysEnabled = SUBSYS_RAN_BC_ENABLE;
    static RTWExtModeInfo rt_ExtModeInfo;
    static const sysRanDType *systemRan[6];
    MPU6050_acq_sf_M->extModeInfo = (&rt_ExtModeInfo);
    rteiSetSubSystemActiveVectorAddresses(&rt_ExtModeInfo, systemRan);
    systemRan[0] = &rtAlwaysEnabled;
    systemRan[1] = (sysRanDType *)&MPU6050_acq_sf_DW.i2cRd_SubsysRanBC;
    systemRan[2] = (sysRanDType *)&MPU6050_acq_sf_DW.i2cRd_SubsysRanBC;
    systemRan[3] = (sysRanDType *)&MPU6050_acq_sf_DW.i2cWr.i2cWr_SubsysRanBC;
    systemRan[4] = (sysRanDType *)&MPU6050_acq_sf_DW.i2cWr.i2cWr_SubsysRanBC;
    systemRan[5] = &rtAlwaysEnabled;
    rteiSetModelMappingInfoPtr(MPU6050_acq_sf_M->extModeInfo,
      &MPU6050_acq_sf_M->SpecialInfo.mappingInfo);
    rteiSetChecksumsPtr(MPU6050_acq_sf_M->extModeInfo,
                        MPU6050_acq_sf_M->Sizes.checksums);
    rteiSetTPtr(MPU6050_acq_sf_M->extModeInfo, rtmGetTPtr(MPU6050_acq_sf_M));
  }

  /* block I/O */
  (void) memset(((void *) &MPU6050_acq_sf_B), 0,
                sizeof(B_MPU6050_acq_sf_T));

  /* states (dwork) */
  (void) memset((void *)&MPU6050_acq_sf_DW, 0,
                sizeof(DW_MPU6050_acq_sf_T));

  /* data type transition information */
  {
    static DataTypeTransInfo dtInfo;
    (void) memset((char_T *) &dtInfo, 0,
                  sizeof(dtInfo));
    MPU6050_acq_sf_M->SpecialInfo.mappingInfo = (&dtInfo);
    dtInfo.numDataTypes = 19;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.BTransTable = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.PTransTable = &rtPTransTable;
  }

  {
    uint32_T i2cname;
    int32_T i;

    /* Start for Chart: '<Root>/MPU6050' incorporates:
     *  Start for SubSystem: '<S2>/i2cWr'
     */
    MPU6050_acq_sf_i2cWr_Start(&MPU6050_acq_sf_DW.i2cWr);

    /* Start for Chart: '<Root>/MPU6050' incorporates:
     *  Start for SubSystem: '<S2>/i2cRd'
     */
    /* Start for MATLABSystem: '<S8>/I2C Master Read' */
    MPU6050_acq_sf_DW.obj.isInitialized = 0;

    /* [EOF] */
    /*  */
    MPU6050_acq_sf_DW.obj.SampleTime = MPU6050_acq_sf_P.I2CMasterRead_SampleTime;
    MPU6050_acq_sf_DW.obj.isInitialized = 1;
    i2cname = 0;
    MW_I2C_Open(i2cname, 0U);

    /* 100KHz. */
    /* KHz */
    MPU6050_acq_sf_DW.obj.BusSpeed = 100000U;
    i2cname = 0;
    MW_I2C_SetBusSpeed(i2cname, MPU6050_acq_sf_DW.obj.BusSpeed);

    /* InitializeConditions for DiscreteIntegrator: '<S5>/Discrete-Time Integrator' */
    MPU6050_acq_sf_DW.DiscreteTimeIntegrator_DSTATE =
      MPU6050_acq_sf_P.DiscreteTimeIntegrator_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S5>/Discrete-Time Integrator1' */
    MPU6050_acq_sf_DW.DiscreteTimeIntegrator1_DSTATE =
      MPU6050_acq_sf_P.DiscreteTimeIntegrator1_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S6>/Discrete-Time Integrator' */
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_d55dfs0xze =
      MPU6050_acq_sf_P.DiscreteTimeIntegrat_aq4ds4pyqg;

    /* InitializeConditions for DiscreteIntegrator: '<S6>/Discrete-Time Integrator1' */
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_nvqe3zzsmy =
      MPU6050_acq_sf_P.DiscreteTimeIntegrat_k0purytsyl;

    /* InitializeConditions for DiscreteIntegrator: '<S7>/Discrete-Time Integrator' */
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_hi5vld3rfw =
      MPU6050_acq_sf_P.DiscreteTimeIntegrat_ond4h1bj2k;

    /* InitializeConditions for DiscreteIntegrator: '<S7>/Discrete-Time Integrator1' */
    MPU6050_acq_sf_DW.DiscreteTimeIntegrat_pniv0mwsqd =
      MPU6050_acq_sf_P.DiscreteTimeIntegrat_lxbswrp2g2;
    MPU6050_acq_sf_DW.is_active_c3_MPU6050_acq_sf = 0U;
    MPU6050_acq_sf_DW.is_c3_MPU6050_acq_sf = MPU6050_acq__IN_NO_ACTIVE_CHILD;

    /* SystemInitialize for Chart: '<Root>/MPU6050' incorporates:
     *  SystemInitialize for SubSystem: '<S2>/i2cRd'
     */
    for (i = 0; i < 7; i++) {
      /* SystemInitialize for Outport: '<S8>/datar' */
      MPU6050_acq_sf_B.DataTypeConversion[i] = MPU6050_acq_sf_P.datar_Y0;
    }
  }
}

/* Model terminate function */
void MPU6050_acq_sf_terminate(void)
{
  uint32_T i2cname;

  /* Terminate for Chart: '<Root>/MPU6050' incorporates:
   *  Terminate for SubSystem: '<S2>/i2cWr'
   */
  MPU6050_acq_sf_i2cWr_Term(&MPU6050_acq_sf_DW.i2cWr);

  /* Terminate for Chart: '<Root>/MPU6050' incorporates:
   *  Terminate for SubSystem: '<S2>/i2cRd'
   */
  /* Start for MATLABSystem: '<S8>/I2C Master Read' incorporates:
   *  Terminate for MATLABSystem: '<S8>/I2C Master Read'
   */
  if (MPU6050_acq_sf_DW.obj.isInitialized == 1) {
    MPU6050_acq_sf_DW.obj.isInitialized = 2;
    i2cname = 0;
    MW_I2C_Close(i2cname);
  }

  /* End of Start for MATLABSystem: '<S8>/I2C Master Read' */
}
