/*
 * fusion_only_accellerometer_2dn3.c
 *
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * Code generation for model "fusion_only_accellerometer_2dn3".
 *
 * Model version              : 1.12
 * Simulink Coder version : 8.12 (R2017a) 16-Feb-2017
 * C source code generated on : Sun Feb 18 23:15:38 2018
 *
 * Target selection: grt.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: Intel->x86-64 (Windows64)
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "fusion_only_accellerometer_2dn3.h"
#include "fusion_only_accellerometer_2dn3_private.h"

/* Named constants for Chart: '<S93>/mag_init_avg' */
#define fusion_only_acc_IN_failure_mode ((uint8_T)3U)
#define fusion_only_accel_IN_init_phase ((uint8_T)4U)
#define fusion_only_accellero_IN_config ((uint8_T)1U)
#define fusion_only_accellerome_IN_exec ((uint8_T)2U)

/* Block signals (auto storage) */
B_fusion_only_accellerometer__T fusion_only_accellerometer_2d_B;

/* Block states (auto storage) */
DW_fusion_only_accellerometer_T fusion_only_accellerometer_2_DW;

/* Real-time model */
RT_MODEL_fusion_only_acceller_T fusion_only_accellerometer_2_M_;
RT_MODEL_fusion_only_acceller_T *const fusion_only_accellerometer_2_M =
  &fusion_only_accellerometer_2_M_;
static void rate_scheduler(void);

/*
 *   This function updates active task flag for each subrate.
 * The function is called at model base rate, hence the
 * generated code self-manages all its subrates.
 */
static void rate_scheduler(void)
{
  /* Compute which subrates run during the next base time step.  Subrates
   * are an integer multiple of the base rate counter.  Therefore, the subtask
   * counter is reset when it reaches its limit (zero means run).
   */
  (fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[2])++;
  if ((fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[2]) > 1) {/* Sample time: [0.1s, 0.0s] */
    fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[2] = 0;
  }

  (fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[3])++;
  if ((fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[3]) > 99) {/* Sample time: [5.0s, 0.0s] */
    fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[3] = 0;
  }
}

void LDLf_int32_Treal_T(real_T out[], real_T vArray[], int32_T nRows, const
  real_T in[])
{
  int32_T c;
  int32_T r;
  int32_T idx1;
  int32_T idx2;
  real_T mYTmp;
  real_T mYTmpR;
  boolean_T done;
  int32_T k;
  real_T prod;

  /* S-Function (sdspldl2): '<S55>/LDL Factorization' */
  done = false;

  /* use done to control the for loop return early  */
  /* when non-positive definite eigenvalue is detected */
  c = 0;
  while ((c < nRows) && (!done)) {
    idx2 = c * nRows;
    for (r = 0; r < c; r++) {
      idx1 = r * nRows;
      mYTmp = out[idx1 + c];
      mYTmpR = out[idx1 + r];
      vArray[r] = mYTmp * mYTmpR;
    }

    mYTmp = in[idx2 + c];
    idx1 = c;
    for (r = 0; r < c; r++) {
      prod = out[idx1] * vArray[r];
      mYTmp -= prod;
      idx1 += nRows;
    }

    mYTmpR = mYTmp;
    if (mYTmp <= 0.0) {
      done = true;
    } else {
      out[idx2 + c] = mYTmp;
      for (r = c + 1; r < nRows; r++) {
        mYTmp = in[idx2 + r];
        idx1 = r;
        for (k = 0; k < c; k++) {
          prod = out[idx1] * vArray[k];
          mYTmp -= prod;
          idx1 += nRows;
        }

        out[idx2 + r] = mYTmp / mYTmpR;
      }
    }

    c++;
  }

  /* transpose and copy lower sub-triang to upper */
  c = 0;
  while ((c < nRows) && (!done)) {
    for (r = c + 1; r < nRows; r++) {
      mYTmp = out[c * nRows + r];
      out[r * nRows + c] = mYTmp;
    }

    c++;
  }

  /* End of S-Function (sdspldl2): '<S55>/LDL Factorization' */
}

/*
 * System initialize for iterator system:
 *    '<S46>/Control'
 *    '<S80>/Control'
 */
void fusion_only_accell_Control_Init(B_Control_fusion_only_accelle_T *localB,
  P_Control_fusion_only_accelle_T *localP)
{
  int32_T i;

  /* SystemInitialize for Outport: '<S48>/Z_est' */
  localB->Assignment_m[0] = localP->Z_est_Y0;
  localB->Assignment_m[1] = localP->Z_est_Y0;

  /* SystemInitialize for Outport: '<S48>/X_est' */
  localB->Assignment_b[0] = localP->X_est_Y0;

  /* SystemInitialize for Outport: '<S48>/X_prd' */
  localB->Assignment_i[0] = localP->X_prd_Y0;

  /* SystemInitialize for Outport: '<S48>/X_est' */
  localB->Assignment_b[1] = localP->X_est_Y0;

  /* SystemInitialize for Outport: '<S48>/X_prd' */
  localB->Assignment_i[1] = localP->X_prd_Y0;

  /* SystemInitialize for Outport: '<S48>/X_est' */
  localB->Assignment_b[2] = localP->X_est_Y0;

  /* SystemInitialize for Outport: '<S48>/X_prd' */
  localB->Assignment_i[2] = localP->X_prd_Y0;

  /* SystemInitialize for Outport: '<S48>/X_est' */
  localB->Assignment_b[3] = localP->X_est_Y0;

  /* SystemInitialize for Outport: '<S48>/X_prd' */
  localB->Assignment_i[3] = localP->X_prd_Y0;

  /* SystemInitialize for Outport: '<S48>/P_prd' */
  for (i = 0; i < 16; i++) {
    localB->Assignment[i] = localP->P_prd_Y0;
  }

  /* End of SystemInitialize for Outport: '<S48>/P_prd' */
}

/*
 * Output and update for iterator system:
 *    '<S46>/Control'
 *    '<S80>/Control'
 */
void fusion_only_accellerome_Control(const real_T rtu_Z[2], const real_T rtu_X[4],
  const real_T rtu_P[16], B_Control_fusion_only_accelle_T *localB,
  DW_Control_fusion_only_accell_T *localDW, P_Control_fusion_only_accelle_T
  *localP)
{
  real_T accTmp;
  int32_T s48_iter;
  int32_T i;
  real_T rtb_Z_est_Multiply[2];
  int32_T idxV;
  real_T rtb_y[8];
  real_T rtb_LDLFactorization[4];
  real_T rtb_BackwardSubstitution[8];
  real_T rtu_Z_0[2];
  real_T tmp[8];
  real_T rtu_P_0[16];
  real_T rtu_P_1[16];

  /* Outputs for Iterator SubSystem: '<S46>/Control' incorporates:
   *  ForIterator: '<S48>/Iterator'
   */
  memcpy(&localB->Assignment[0], &rtu_P[0], sizeof(real_T) << 4U);
  localB->Assignment_i[0] = rtu_X[0];
  localB->Assignment_i[1] = rtu_X[1];
  localB->Assignment_i[2] = rtu_X[2];
  localB->Assignment_i[3] = rtu_X[3];
  for (s48_iter = 1; s48_iter <= localP->Iterator_IterationLimit; s48_iter++) {
    for (idxV = 0; idxV < 2; idxV++) {
      /* Product: '<S50>/H*P_prdt' incorporates:
       *  Constant: '<S50>/Hcst'
       *  Math: '<S50>/P_prd Trans'
       *  Selector: '<S49>/Selector2'
       */
      for (i = 0; i < 4; i++) {
        rtb_y[idxV + (i << 1)] = 0.0;
        rtb_y[idxV + (i << 1)] += localP->Hcst_Value[idxV] * rtu_P[i];
        rtb_y[idxV + (i << 1)] += localP->Hcst_Value[idxV + 2] * rtu_P[i + 4];
        rtb_y[idxV + (i << 1)] += localP->Hcst_Value[idxV + 4] * rtu_P[i + 8];
        rtb_y[idxV + (i << 1)] += localP->Hcst_Value[idxV + 6] * rtu_P[i + 12];
      }

      /* End of Product: '<S50>/H*P_prdt' */

      /* Sum: '<S50>/H*P_prdt*Ht+R' incorporates:
       *  Constant: '<S50>/Constant2'
       *  Constant: '<S50>/Hcst_t'
       *  Product: '<S50>/H*P_prdt*Ht'
       */
      for (i = 0; i < 2; i++) {
        rtb_LDLFactorization[idxV + (i << 1)] = (((localP->Hcst_t_Value[(i << 2)
          + 1] * rtb_y[idxV + 2] + localP->Hcst_t_Value[i << 2] * rtb_y[idxV]) +
          localP->Hcst_t_Value[(i << 2) + 2] * rtb_y[idxV + 4]) +
          localP->Hcst_t_Value[(i << 2) + 3] * rtb_y[idxV + 6]) +
          localP->Constant2_Value[(i << 1) + idxV];
      }

      /* End of Sum: '<S50>/H*P_prdt*Ht+R' */
    }

    /* S-Function (sdspldl2): '<S55>/LDL Factorization' */
    LDLf_int32_Treal_T(&rtb_LDLFactorization[0U], &localDW->
                       LDLFactorization_VMX[0U], 2, &rtb_LDLFactorization[0U]);

    /* S-Function (sdspfbsub2): '<S55>/Forward Substitution' */
    idxV = 1;
    accTmp = rtb_y[1];
    i = 0;
    while (i < 1) {
      accTmp -= rtb_LDLFactorization[idxV] * rtb_y[0];
      idxV += 2;
      i = 1;
    }

    rtb_y[1] = accTmp;
    idxV = 1;
    accTmp = rtb_y[3];
    i = 0;
    while (i < 1) {
      accTmp -= rtb_LDLFactorization[idxV] * rtb_y[2];
      idxV += 2;
      i = 1;
    }

    rtb_y[3] = accTmp;
    idxV = 1;
    accTmp = rtb_y[5];
    i = 0;
    while (i < 1) {
      accTmp -= rtb_LDLFactorization[idxV] * rtb_y[4];
      idxV += 2;
      i = 1;
    }

    rtb_y[5] = accTmp;
    idxV = 1;
    accTmp = rtb_y[7];
    i = 0;
    while (i < 1) {
      accTmp -= rtb_LDLFactorization[idxV] * rtb_y[6];
      idxV += 2;
      i = 1;
    }

    rtb_y[7] = accTmp;

    /* End of S-Function (sdspfbsub2): '<S55>/Forward Substitution' */

    /* S-Function (sdspdiag2): '<S55>/Extract Diagonal' incorporates:
     *  Math: '<S55>/Math Function'
     *
     * About '<S55>/Math Function':
     *  Operator: reciprocal
     */
    rtb_Z_est_Multiply[0] = 1.0 / rtb_LDLFactorization[0];

    /* Math: '<S55>/Math Function' incorporates:
     *  S-Function (sdspdiag2): '<S55>/Extract Diagonal'
     *
     * About '<S55>/Math Function':
     *  Operator: reciprocal
     */
    accTmp = 1.0 / rtb_LDLFactorization[3];

    /* S-Function (sdspdiag2): '<S55>/Extract Diagonal' */
    rtb_Z_est_Multiply[1] = accTmp;

    /* S-Function (sdspdmult2): '<S55>/Matrix Scaling' */
    idxV = 0;
    for (i = 0; i < 4; i++) {
      rtb_BackwardSubstitution[idxV] = rtb_y[idxV] * rtb_Z_est_Multiply[0];
      idxV++;
      rtb_BackwardSubstitution[idxV] = rtb_y[idxV] * accTmp;
      idxV++;
    }

    /* End of S-Function (sdspdmult2): '<S55>/Matrix Scaling' */

    /* S-Function (sdspfbsub2): '<S55>/Backward Substitution' */
    idxV = 0;
    accTmp = rtb_BackwardSubstitution[0];
    i = 1;
    while (i > 0) {
      accTmp -= rtb_LDLFactorization[idxV + 2] * rtb_BackwardSubstitution[1];
      idxV -= 2;
      i = 0;
    }

    rtb_BackwardSubstitution[0] = accTmp;
    idxV = 0;
    accTmp = rtb_BackwardSubstitution[2];
    i = 1;
    while (i > 0) {
      accTmp -= rtb_LDLFactorization[idxV + 2] * rtb_BackwardSubstitution[3];
      idxV -= 2;
      i = 0;
    }

    rtb_BackwardSubstitution[2] = accTmp;
    idxV = 0;
    accTmp = rtb_BackwardSubstitution[4];
    i = 1;
    while (i > 0) {
      accTmp -= rtb_LDLFactorization[idxV + 2] * rtb_BackwardSubstitution[5];
      idxV -= 2;
      i = 0;
    }

    rtb_BackwardSubstitution[4] = accTmp;
    idxV = 0;
    accTmp = rtb_BackwardSubstitution[6];
    i = 1;
    while (i > 0) {
      accTmp -= rtb_LDLFactorization[idxV + 2] * rtb_BackwardSubstitution[7];
      idxV -= 2;
      i = 0;
    }

    rtb_BackwardSubstitution[6] = accTmp;

    /* End of S-Function (sdspfbsub2): '<S55>/Backward Substitution' */
    for (idxV = 0; idxV < 2; idxV++) {
      /* Math: '<S50>/K Trans' */
      rtb_y[idxV << 2] = rtb_BackwardSubstitution[idxV];
      rtb_y[1 + (idxV << 2)] = rtb_BackwardSubstitution[idxV + 2];
      rtb_y[2 + (idxV << 2)] = rtb_BackwardSubstitution[idxV + 4];
      rtb_y[3 + (idxV << 2)] = rtb_BackwardSubstitution[idxV + 6];

      /* Sum: '<S50>/Z-H*X_prd' incorporates:
       *  Constant: '<S50>/Hcst'
       *  Product: '<S50>/H*X_prd'
       *  Product: '<S50>/K*(Z-H*X_prd)'
       *  Selector: '<S49>/Selector'
       *  Selector: '<S49>/Selector1'
       */
      rtu_Z_0[idxV] = rtu_Z[idxV] - (((localP->Hcst_Value[idxV + 2] * rtu_X[1] +
        localP->Hcst_Value[idxV] * rtu_X[0]) + localP->Hcst_Value[idxV + 4] *
        rtu_X[2]) + localP->Hcst_Value[idxV + 6] * rtu_X[3]);
    }

    /* Sum: '<S50>/X_prd+K*(Z-H*X_prd)' incorporates:
     *  Product: '<S50>/K*(Z-H*X_prd)'
     *  Selector: '<S49>/Selector1'
     */
    for (idxV = 0; idxV < 4; idxV++) {
      rtb_LDLFactorization[idxV] = (rtb_y[idxV + 4] * rtu_Z_0[1] + rtb_y[idxV] *
        rtu_Z_0[0]) + rtu_X[idxV];
    }

    /* End of Sum: '<S50>/X_prd+K*(Z-H*X_prd)' */
    for (idxV = 0; idxV < 2; idxV++) {
      /* Product: '<S50>/Z_est_Multiply' incorporates:
       *  Constant: '<S50>/Hcst'
       *  Product: '<S50>/K*H*P_prd'
       *  Selector: '<S49>/Selector2'
       */
      rtb_Z_est_Multiply[idxV] = 0.0;
      for (i = 0; i < 4; i++) {
        /* Product: '<S50>/K*H*P_prd' */
        tmp[idxV + (i << 1)] = 0.0;
        tmp[idxV + (i << 1)] += rtu_P[i << 2] * localP->Hcst_Value[idxV];
        tmp[idxV + (i << 1)] += rtu_P[(i << 2) + 1] * localP->Hcst_Value[idxV +
          2];
        tmp[idxV + (i << 1)] += rtu_P[(i << 2) + 2] * localP->Hcst_Value[idxV +
          4];
        tmp[idxV + (i << 1)] += rtu_P[(i << 2) + 3] * localP->Hcst_Value[idxV +
          6];
        rtb_Z_est_Multiply[idxV] += localP->Hcst_Value[(i << 1) + idxV] *
          rtb_LDLFactorization[i];
      }

      /* End of Product: '<S50>/Z_est_Multiply' */
    }

    for (idxV = 0; idxV < 4; idxV++) {
      /* Sum: '<S50>/P_prd-K*H*P_prd' incorporates:
       *  Product: '<S50>/A*P*At'
       *  Product: '<S50>/K*H*P_prd'
       *  Selector: '<S49>/Selector2'
       */
      for (i = 0; i < 4; i++) {
        rtu_P_0[idxV + (i << 2)] = rtu_P[(i << 2) + idxV] - (tmp[(i << 1) + 1] *
          rtb_y[idxV + 4] + tmp[i << 1] * rtb_y[idxV]);
      }

      /* End of Sum: '<S50>/P_prd-K*H*P_prd' */

      /* Product: '<S50>/A*P*At' incorporates:
       *  Constant: '<S50>/Constant4'
       */
      for (i = 0; i < 4; i++) {
        rtu_P_1[idxV + (i << 2)] = 0.0;
        rtu_P_1[idxV + (i << 2)] += localP->Constant4_Value[i << 2] *
          rtu_P_0[idxV];
        rtu_P_1[idxV + (i << 2)] += localP->Constant4_Value[(i << 2) + 1] *
          rtu_P_0[idxV + 4];
        rtu_P_1[idxV + (i << 2)] += localP->Constant4_Value[(i << 2) + 2] *
          rtu_P_0[idxV + 8];
        rtu_P_1[idxV + (i << 2)] += localP->Constant4_Value[(i << 2) + 3] *
          rtu_P_0[idxV + 12];
      }
    }

    /* Sum: '<S50>/A*P*At+Q' incorporates:
     *  Constant: '<S50>/Constant3'
     *  Constant: '<S50>/Constant5'
     *  Product: '<S50>/A*P*At'
     */
    for (idxV = 0; idxV < 4; idxV++) {
      for (i = 0; i < 4; i++) {
        rtu_P_0[idxV + (i << 2)] = (((rtu_P_1[(i << 2) + 1] *
          localP->Constant3_Value[idxV + 4] + rtu_P_1[i << 2] *
          localP->Constant3_Value[idxV]) + rtu_P_1[(i << 2) + 2] *
          localP->Constant3_Value[idxV + 8]) + rtu_P_1[(i << 2) + 3] *
          localP->Constant3_Value[idxV + 12]) + localP->Constant5_Value[(i << 2)
          + idxV];
      }
    }

    /* Assignment: '<S51>/Assignment' incorporates:
     *  Sum: '<S50>/A*P*At+Q'
     */
    memcpy(&localB->Assignment[0], &rtu_P_0[0], sizeof(real_T) << 4U);
    for (i = 0; i < 4; i++) {
      /* Assignment: '<S52>/Assignment' */
      localB->Assignment_b[i] = rtb_LDLFactorization[i];

      /* Product: '<S50>/A*X' incorporates:
       *  Constant: '<S50>/Constant3'
       */
      accTmp = localP->Constant3_Value[i + 12] * rtb_LDLFactorization[3] +
        (localP->Constant3_Value[i + 8] * rtb_LDLFactorization[2] +
         (localP->Constant3_Value[i + 4] * rtb_LDLFactorization[1] +
          localP->Constant3_Value[i] * rtb_LDLFactorization[0]));

      /* Assignment: '<S53>/Assignment' incorporates:
       *  Product: '<S50>/A*X'
       */
      localB->Assignment_i[i] = accTmp;
    }

    /* Assignment: '<S54>/Assignment' */
    localB->Assignment_m[0] = rtb_Z_est_Multiply[0];
    localB->Assignment_m[1] = rtb_Z_est_Multiply[1];
  }

  /* End of Outputs for SubSystem: '<S46>/Control' */
}

real_T rt_urand_Upu32_Yd_f_pw_snf(uint32_T *u)
{
  uint32_T lo;
  uint32_T hi;

  /* Uniform random number generator (random number between 0 and 1)

     #define IA      16807                      magic multiplier = 7^5
     #define IM      2147483647                 modulus = 2^31-1
     #define IQ      127773                     IM div IA
     #define IR      2836                       IM modulo IA
     #define S       4.656612875245797e-10      reciprocal of 2^31-1
     test = IA * (seed % IQ) - IR * (seed/IQ)
     seed = test < 0 ? (test + IM) : test
     return (seed*S)
   */
  lo = *u % 127773U * 16807U;
  hi = *u / 127773U * 2836U;
  if (lo < hi) {
    *u = 2147483647U - (hi - lo);
  } else {
    *u = lo - hi;
  }

  return (real_T)*u * 4.6566128752457969E-10;
}

real_T rt_nrand_Upu32_Yd_f_pw_snf(uint32_T *u)
{
  real_T y;
  real_T sr;
  real_T si;

  /* Normal (Gaussian) random number generator */
  do {
    sr = 2.0 * rt_urand_Upu32_Yd_f_pw_snf(u) - 1.0;
    si = 2.0 * rt_urand_Upu32_Yd_f_pw_snf(u) - 1.0;
    si = sr * sr + si * si;
  } while (si > 1.0);

  y = sqrt(-2.0 * log(si) / si) * sr;
  return y;
}

real32_T rt_atan2f_snf(real32_T u0, real32_T u1)
{
  real32_T y;
  int32_T u0_0;
  int32_T u1_0;
  if (rtIsNaNF(u0) || rtIsNaNF(u1)) {
    y = (rtNaNF);
  } else if (rtIsInfF(u0) && rtIsInfF(u1)) {
    if (u0 > 0.0F) {
      u0_0 = 1;
    } else {
      u0_0 = -1;
    }

    if (u1 > 0.0F) {
      u1_0 = 1;
    } else {
      u1_0 = -1;
    }

    y = atan2f((real32_T)u0_0, (real32_T)u1_0);
  } else if (u1 == 0.0F) {
    if (u0 > 0.0F) {
      y = RT_PIF / 2.0F;
    } else if (u0 < 0.0F) {
      y = -(RT_PIF / 2.0F);
    } else {
      y = 0.0F;
    }
  } else {
    y = atan2f(u0, u1);
  }

  return y;
}

real_T rt_atan2d_snf(real_T u0, real_T u1)
{
  real_T y;
  int32_T u0_0;
  int32_T u1_0;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = (rtNaN);
  } else if (rtIsInf(u0) && rtIsInf(u1)) {
    if (u0 > 0.0) {
      u0_0 = 1;
    } else {
      u0_0 = -1;
    }

    if (u1 > 0.0) {
      u1_0 = 1;
    } else {
      u1_0 = -1;
    }

    y = atan2(u0_0, u1_0);
  } else if (u1 == 0.0) {
    if (u0 > 0.0) {
      y = RT_PI / 2.0;
    } else if (u0 < 0.0) {
      y = -(RT_PI / 2.0);
    } else {
      y = 0.0;
    }
  } else {
    y = atan2(u0, u1);
  }

  return y;
}

real_T rt_hypotd_snf(real_T u0, real_T u1)
{
  real_T y;
  real_T a;
  a = fabs(u0);
  y = fabs(u1);
  if (a < y) {
    a /= y;
    y *= sqrt(a * a + 1.0);
  } else if (a > y) {
    y /= a;
    y = sqrt(y * y + 1.0) * a;
  } else {
    if (!rtIsNaN(y)) {
      y = a * 1.4142135623730951;
    }
  }

  return y;
}

/* Model step function */
void fusion_only_accellerometer_2dn3_step(void)
{
  /* local block i/o variables */
  real_T rtb_FromWs[2];
  real_T rtb_TSamp[2];
  real_T rtb_TSamp_f[2];
  real_T rtb_Diff[2];
  real_T rtb_AxAy[2];
  real_T rtb_UnitDelay2_e[4];
  real_T rtb_UnitDelay3_f[16];
  real_T rtb_DiscreteTimeIntegrator;
  real_T rtb_DiscreteTimeIntegrator2;
  real_T rtb_DiscreteTimeIntegrator_d;
  real_T rtb_DiscreteTimeIntegrator2_d;
  real_T rtb_Product_i[3];
  real_T rtb_Product_e[3];
  real_T rtb_s;
  real_T rtb_VectorConcatenate[2];
  real_T rtb_Product1[4];
  real_T rtb_Product1_n[4];
  real_T rtb_s_c;
  real_T rtb_DiscreteTimeIntegrator_c[3];
  real_T rtb_RandomNumber;
  real_T rtb_DiscreteTimeIntegrator_h[3];
  real_T rtb_Sum[2];
  real_T rtb_TrigonometricFunction2;
  real_T rtb_Gain;
  real_T rtb_TrigonometricFunction;
  real_T rtb_UnitDelay2[4];
  real_T rtb_UnitDelay3[16];
  real_T rtb_steeringratelimit;
  uint8_T rtb_FixPtSwitch;
  uint8_T rtb_FixPtSwitch_e;
  real_T rtb_Product;
  uint8_T rtb_Output;
  uint8_T rtb_Output_b;
  real_T rtb_TrigonometricFunction1_o2;
  int32_T i;
  real_T rtb_TrigonometricFunction1_o2_0[16];

  /* DiscreteIntegrator: '<S38>/Discrete-Time Integrator' */
  rtb_s = fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE;

  /* SignalConversion: '<S38>/ConcatBufferAtVector ConcatenateIn1' */
  fusion_only_accellerometer_2d_B.VectorConcatenate[0] = rtb_s;

  /* Constant: '<S38>/Constant' */
  fusion_only_accellerometer_2d_B.VectorConcatenate[1] =
    fusion_only_accellerometer_2d_P.Constant_Value;

  /* ZeroOrderHold: '<S79>/Zero-Order Hold' */
  if (fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[2] == 0) {
    fusion_only_accellerometer_2d_B.ZeroOrderHold[0] =
      fusion_only_accellerometer_2d_B.VectorConcatenate[0];
    fusion_only_accellerometer_2d_B.ZeroOrderHold[1] =
      fusion_only_accellerometer_2d_B.VectorConcatenate[1];

    /* UnitDelay: '<S80>/Unit Delay2' */
    rtb_UnitDelay2[0] = fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE[0];
    rtb_UnitDelay2[1] = fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE[1];
    rtb_UnitDelay2[2] = fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE[2];
    rtb_UnitDelay2[3] = fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE[3];

    /* UnitDelay: '<S80>/Unit Delay3' */
    memcpy(&rtb_UnitDelay3[0],
           &fusion_only_accellerometer_2_DW.UnitDelay3_DSTATE[0], sizeof(real_T)
           << 4U);

    /* Outputs for Iterator SubSystem: '<S80>/Control' */
    fusion_only_accellerome_Control
      (fusion_only_accellerometer_2d_B.ZeroOrderHold, rtb_UnitDelay2,
       rtb_UnitDelay3, &fusion_only_accellerometer_2d_B.Control,
       &fusion_only_accellerometer_2_DW.Control,
       (P_Control_fusion_only_accelle_T *)
       &fusion_only_accellerometer_2d_P.Control);

    /* End of Outputs for SubSystem: '<S80>/Control' */
  }

  /* End of ZeroOrderHold: '<S79>/Zero-Order Hold' */
  /* FromWorkspace: '<S101>/FromWs' */
  {
    real_T *pDataValues = (real_T *)
      fusion_only_accellerometer_2_DW.FromWs_PWORK.DataPtr;
    real_T *pTimeValues = (real_T *)
      fusion_only_accellerometer_2_DW.FromWs_PWORK.TimePtr;
    int_T currTimeIndex = fusion_only_accellerometer_2_DW.FromWs_IWORK.PrevIndex;
    real_T t = fusion_only_accellerometer_2_M->Timing.t[0];

    /* Get index */
    if (t <= pTimeValues[0]) {
      currTimeIndex = 0;
    } else if (t >= pTimeValues[17]) {
      currTimeIndex = 16;
    } else {
      if (t < pTimeValues[currTimeIndex]) {
        while (t < pTimeValues[currTimeIndex]) {
          currTimeIndex--;
        }
      } else {
        while (t >= pTimeValues[currTimeIndex + 1]) {
          currTimeIndex++;
        }
      }
    }

    fusion_only_accellerometer_2_DW.FromWs_IWORK.PrevIndex = currTimeIndex;

    /* Post output */
    {
      real_T t1 = pTimeValues[currTimeIndex];
      real_T t2 = pTimeValues[currTimeIndex + 1];
      if (t1 == t2) {
        if (t < t1) {
          {
            int_T elIdx;
            for (elIdx = 0; elIdx < 2; ++elIdx) {
              (&rtb_FromWs[0])[elIdx] = pDataValues[currTimeIndex];
              pDataValues += 18;
            }
          }
        } else {
          {
            int_T elIdx;
            for (elIdx = 0; elIdx < 2; ++elIdx) {
              (&rtb_FromWs[0])[elIdx] = pDataValues[currTimeIndex + 1];
              pDataValues += 18;
            }
          }
        }
      } else {
        real_T f1 = (t2 - t) / (t2 - t1);
        real_T f2 = 1.0 - f1;
        real_T d1;
        real_T d2;
        int_T TimeIndex= currTimeIndex;

        {
          int_T elIdx;
          for (elIdx = 0; elIdx < 2; ++elIdx) {
            d1 = pDataValues[TimeIndex];
            d2 = pDataValues[TimeIndex + 1];
            (&rtb_FromWs[0])[elIdx] = (real_T) rtInterpolate(d1, d2, f1, f2);
            pDataValues += 18;
          }
        }
      }
    }
  }

  /* SignalConversion: '<S18>/ConcatBufferAtVector ConcatenateIn1' */
  fusion_only_accellerometer_2d_B.VectorConcatenate_h[0] = rtb_FromWs[0];

  /* SignalConversion: '<S18>/ConcatBufferAtVector ConcatenateIn2' */
  fusion_only_accellerometer_2d_B.VectorConcatenate_h[1] = rtb_FromWs[1];

  /* Product: '<S33>/Product' incorporates:
   *  Constant: '<S33>/Constant'
   *  RandomNumber: '<S33>/Random Number'
   */
  rtb_Product = fusion_only_accellerometer_2_DW.NextOutput *
    fusion_only_accellerometer_2d_P.Constant_Value_i;

  /* SampleTimeMath: '<S42>/TSamp'
   *
   * About '<S42>/TSamp':
   *  y = u * K where K = 1 / ( w * Ts )
   */
  rtb_TSamp[0] = fusion_only_accellerometer_2d_B.VectorConcatenate_h[0] *
    fusion_only_accellerometer_2d_P.TSamp_WtEt;

  /* Sum: '<S42>/Diff' incorporates:
   *  UnitDelay: '<S42>/UD'
   */
  rtb_Sum[0] = rtb_TSamp[0] - fusion_only_accellerometer_2_DW.UD_DSTATE[0];

  /* SampleTimeMath: '<S43>/TSamp'
   *
   * About '<S43>/TSamp':
   *  y = u * K where K = 1 / ( w * Ts )
   */
  rtb_TSamp_f[0] = rtb_Sum[0] * fusion_only_accellerometer_2d_P.TSamp_WtEt_i;

  /* Sum: '<S43>/Diff' incorporates:
   *  UnitDelay: '<S43>/UD'
   */
  rtb_Diff[0] = rtb_TSamp_f[0] - fusion_only_accellerometer_2_DW.UD_DSTATE_n[0];

  /* Sum: '<Root>/Sum3' */
  rtb_AxAy[0] = rtb_Product + rtb_Diff[0];

  /* SampleTimeMath: '<S42>/TSamp'
   *
   * About '<S42>/TSamp':
   *  y = u * K where K = 1 / ( w * Ts )
   */
  rtb_TSamp[1] = fusion_only_accellerometer_2d_B.VectorConcatenate_h[1] *
    fusion_only_accellerometer_2d_P.TSamp_WtEt;

  /* Sum: '<S42>/Diff' incorporates:
   *  UnitDelay: '<S42>/UD'
   */
  rtb_Sum[1] = rtb_TSamp[1] - fusion_only_accellerometer_2_DW.UD_DSTATE[1];

  /* SampleTimeMath: '<S43>/TSamp'
   *
   * About '<S43>/TSamp':
   *  y = u * K where K = 1 / ( w * Ts )
   */
  rtb_TSamp_f[1] = rtb_Sum[1] * fusion_only_accellerometer_2d_P.TSamp_WtEt_i;

  /* Sum: '<S43>/Diff' incorporates:
   *  UnitDelay: '<S43>/UD'
   */
  rtb_Diff[1] = rtb_TSamp_f[1] - fusion_only_accellerometer_2_DW.UD_DSTATE_n[1];

  /* Sum: '<Root>/Sum3' */
  rtb_AxAy[1] = rtb_Product + rtb_Diff[1];

  /* UnitDelay: '<S46>/Unit Delay2' */
  rtb_UnitDelay2_e[0] = fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE_e[0];
  rtb_UnitDelay2_e[1] = fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE_e[1];
  rtb_UnitDelay2_e[2] = fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE_e[2];
  rtb_UnitDelay2_e[3] = fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE_e[3];

  /* UnitDelay: '<S46>/Unit Delay3' */
  memcpy(&rtb_UnitDelay3_f[0],
         &fusion_only_accellerometer_2_DW.UnitDelay3_DSTATE_d[0], sizeof(real_T)
         << 4U);

  /* Outputs for Iterator SubSystem: '<S46>/Control' */
  fusion_only_accellerome_Control(rtb_AxAy, rtb_UnitDelay2_e, rtb_UnitDelay3_f,
    &fusion_only_accellerometer_2d_B.Control_l,
    &fusion_only_accellerometer_2_DW.Control_l, (P_Control_fusion_only_accelle_T
    *)&fusion_only_accellerometer_2d_P.Control_l);

  /* End of Outputs for SubSystem: '<S46>/Control' */

  /* Trigonometry: '<S27>/Trigonometric Function1' incorporates:
   *  DiscreteIntegrator: '<S27>/Discrete-Time Integrator1'
   */
  rtb_Product = sin
    (fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator1_DSTATE);
  rtb_TrigonometricFunction1_o2 = cos
    (fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator1_DSTATE);

  /* MATLAB Function: '<S27>/MATLAB Function' incorporates:
   *  Constant: '<S27>/Constant'
   *  Constant: '<S27>/Constant1'
   *  Constant: '<S27>/Constant2'
   *  Constant: '<S27>/one1'
   *  Constant: '<S27>/one2'
   *  Constant: '<S27>/zero1'
   *  Constant: '<S27>/zero2'
   *  Gain: '<S27>/Gain1'
   */
  /* MATLAB Function 'Rotation matrix1/MATLAB Function': '<S127>:1' */
  /* '<S127>:1:2' */
  /* '<S127>:1:4' */
  fusion_only_accellerometer_2d_B.A[0] = rtb_TrigonometricFunction1_o2;
  fusion_only_accellerometer_2d_B.A[4] =
    fusion_only_accellerometer_2d_P.Gain1_Gain * rtb_Product;
  fusion_only_accellerometer_2d_B.A[8] =
    fusion_only_accellerometer_2d_P.zero1_Value;
  fusion_only_accellerometer_2d_B.A[12] =
    fusion_only_accellerometer_2d_P.Constant_Value_iv;
  fusion_only_accellerometer_2d_B.A[1] = rtb_Product;
  fusion_only_accellerometer_2d_B.A[5] = rtb_TrigonometricFunction1_o2;
  fusion_only_accellerometer_2d_B.A[9] =
    fusion_only_accellerometer_2d_P.zero1_Value;
  fusion_only_accellerometer_2d_B.A[13] =
    fusion_only_accellerometer_2d_P.Constant1_Value;
  fusion_only_accellerometer_2d_B.A[2] =
    fusion_only_accellerometer_2d_P.zero1_Value;
  fusion_only_accellerometer_2d_B.A[6] =
    fusion_only_accellerometer_2d_P.zero1_Value;
  fusion_only_accellerometer_2d_B.A[10] =
    fusion_only_accellerometer_2d_P.one1_Value;
  fusion_only_accellerometer_2d_B.A[14] =
    fusion_only_accellerometer_2d_P.Constant2_Value;
  fusion_only_accellerometer_2d_B.A[3] =
    fusion_only_accellerometer_2d_P.zero2_Value;
  fusion_only_accellerometer_2d_B.A[7] =
    fusion_only_accellerometer_2d_P.zero2_Value;
  fusion_only_accellerometer_2d_B.A[11] =
    fusion_only_accellerometer_2d_P.zero2_Value;
  fusion_only_accellerometer_2d_B.A[15] =
    fusion_only_accellerometer_2d_P.one2_Value;

  /* DiscreteIntegrator: '<S6>/Discrete- Time Integrator1' */
  rtb_VectorConcatenate[0] =
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator1_DSTAT_f;

  /* DiscreteIntegrator: '<S6>/Discrete- Time Integrator3' */
  rtb_VectorConcatenate[1] =
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator3_DSTATE;

  /* Product: '<S30>/Product1' incorporates:
   *  Constant: '<S30>/one1'
   *  Constant: '<S30>/one3'
   *  SignalConversion: '<S30>/ConcatBufferAtquaternionIn1'
   */
  for (i = 0; i < 4; i++) {
    rtb_Product1[i] = 0.0;
    rtb_Product1[i] += fusion_only_accellerometer_2d_B.A[i] *
      rtb_VectorConcatenate[0];
    rtb_Product1[i] += fusion_only_accellerometer_2d_B.A[i + 4] *
      rtb_VectorConcatenate[1];
    rtb_Product1[i] += fusion_only_accellerometer_2d_B.A[i + 8] *
      fusion_only_accellerometer_2d_P.one1_Value_f;
    rtb_Product1[i] += fusion_only_accellerometer_2d_B.A[i + 12] *
      fusion_only_accellerometer_2d_P.one3_Value;
  }

  /* End of Product: '<S30>/Product1' */
  /* Trigonometry: '<S28>/Trigonometric Function1' incorporates:
   *  DiscreteIntegrator: '<S28>/Discrete-Time Integrator1'
   */
  rtb_Product = sin
    (fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator1_DSTAT_b);
  rtb_TrigonometricFunction1_o2 = cos
    (fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator1_DSTAT_b);

  /* MATLAB Function: '<S28>/MATLAB Function' incorporates:
   *  Constant: '<S28>/Constant'
   *  Constant: '<S28>/Constant1'
   *  Constant: '<S28>/Constant2'
   *  Constant: '<S28>/one1'
   *  Constant: '<S28>/one2'
   *  Constant: '<S28>/zero1'
   *  Constant: '<S28>/zero2'
   *  Gain: '<S28>/Gain1'
   */
  /* MATLAB Function 'Rotation matrix2/MATLAB Function': '<S128>:1' */
  /* '<S128>:1:2' */
  /* '<S128>:1:4' */
  rtb_TrigonometricFunction1_o2_0[0] = rtb_TrigonometricFunction1_o2;
  rtb_TrigonometricFunction1_o2_0[4] =
    fusion_only_accellerometer_2d_P.Gain1_Gain_b * rtb_Product;
  rtb_TrigonometricFunction1_o2_0[8] =
    fusion_only_accellerometer_2d_P.zero1_Value_k;
  rtb_TrigonometricFunction1_o2_0[12] =
    fusion_only_accellerometer_2d_P.Constant_Value_c;
  rtb_TrigonometricFunction1_o2_0[1] = rtb_Product;
  rtb_TrigonometricFunction1_o2_0[5] = rtb_TrigonometricFunction1_o2;
  rtb_TrigonometricFunction1_o2_0[9] =
    fusion_only_accellerometer_2d_P.zero1_Value_k;
  rtb_TrigonometricFunction1_o2_0[13] =
    fusion_only_accellerometer_2d_P.Constant1_Value_f;
  rtb_TrigonometricFunction1_o2_0[2] =
    fusion_only_accellerometer_2d_P.zero1_Value_k;
  rtb_TrigonometricFunction1_o2_0[6] =
    fusion_only_accellerometer_2d_P.zero1_Value_k;
  rtb_TrigonometricFunction1_o2_0[10] =
    fusion_only_accellerometer_2d_P.one1_Value_i;
  rtb_TrigonometricFunction1_o2_0[14] =
    fusion_only_accellerometer_2d_P.Constant2_Value_f;
  rtb_TrigonometricFunction1_o2_0[3] =
    fusion_only_accellerometer_2d_P.zero2_Value_d;
  rtb_TrigonometricFunction1_o2_0[7] =
    fusion_only_accellerometer_2d_P.zero2_Value_d;
  rtb_TrigonometricFunction1_o2_0[11] =
    fusion_only_accellerometer_2d_P.zero2_Value_d;
  rtb_TrigonometricFunction1_o2_0[15] =
    fusion_only_accellerometer_2d_P.one2_Value_p;

  /* Product: '<S31>/Product1' incorporates:
   *  Constant: '<S31>/one1'
   *  Constant: '<S31>/one3'
   *  DiscreteIntegrator: '<S7>/Discrete- Time Integrator1'
   *  DiscreteIntegrator: '<S7>/Discrete- Time Integrator3'
   */
  for (i = 0; i < 4; i++) {
    rtb_Product1_n[i] = 0.0;
    rtb_Product1_n[i] += rtb_TrigonometricFunction1_o2_0[i] *
      fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator1_DSTAT_p;
    rtb_Product1_n[i] += rtb_TrigonometricFunction1_o2_0[i + 4] *
      fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator3_DSTAT_b;
    rtb_Product1_n[i] += rtb_TrigonometricFunction1_o2_0[i + 8] *
      fusion_only_accellerometer_2d_P.one1_Value_g;
    rtb_Product1_n[i] += rtb_TrigonometricFunction1_o2_0[i + 12] *
      fusion_only_accellerometer_2d_P.one3_Value_f;
  }

  /* End of Product: '<S31>/Product1' */

  /* Gain: '<Root>/Gain' */
  rtb_RandomNumber = fusion_only_accellerometer_2d_P.Gain_Gain * rtb_Product1[0];

  /* Gain: '<Root>/Gain2' */
  rtb_TrigonometricFunction2 = fusion_only_accellerometer_2d_P.Gain2_Gain *
    rtb_Product1[1];

  /* DiscreteIntegrator: '<S39>/Discrete-Time Integrator' */
  rtb_s_c = fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_k;

  /* S-Function (sdspsubmtrx): '<S40>/Submatrix1' */
  fusion_only_accellerometer_2d_B.Submatrix1[0] =
    fusion_only_accellerometer_2d_B.A[0];
  fusion_only_accellerometer_2d_B.Submatrix1[1] =
    fusion_only_accellerometer_2d_B.A[1];
  fusion_only_accellerometer_2d_B.Submatrix1[2] =
    fusion_only_accellerometer_2d_B.A[4];
  fusion_only_accellerometer_2d_B.Submatrix1[3] =
    fusion_only_accellerometer_2d_B.A[5];

  /* MATLAB Function: '<S40>/fix_quadrant' */
  /* MATLAB Function 'yaw_calculatiion/fix_quadrant': '<S134>:1' */
  /* '<S134>:1:2' */
  rtb_Product = 99.0;
  if (fusion_only_accellerometer_2d_B.Submatrix1[0] == 0.0) {
    /* '<S134>:1:3' */
    if (fusion_only_accellerometer_2d_B.Submatrix1[1] > 0.0) {
      /* '<S134>:1:4' */
      /* '<S134>:1:5' */
      rtb_Product = asin(fusion_only_accellerometer_2d_B.Submatrix1[1]);
    } else {
      if (fusion_only_accellerometer_2d_B.Submatrix1[1] > 0.0) {
        /* '<S134>:1:6' */
        /* '<S134>:1:7' */
        rtb_Product = -asin(fusion_only_accellerometer_2d_B.Submatrix1[1]);
      }
    }
  } else if (fusion_only_accellerometer_2d_B.Submatrix1[0] > 0.0) {
    /* '<S134>:1:9' */
    /* primo quadrante e secondo quadrante */
    /* '<S134>:1:10' */
    rtb_Product = asin(fusion_only_accellerometer_2d_B.Submatrix1[1]);
  } else if (fusion_only_accellerometer_2d_B.Submatrix1[1] > 0.0) {
    /* '<S134>:1:11' */
    /* '<S134>:1:12' */
    rtb_Product = acos(fusion_only_accellerometer_2d_B.Submatrix1[0]);
  } else {
    /* '<S134>:1:14' */
    rtb_Product = -acos(fusion_only_accellerometer_2d_B.Submatrix1[0]);
  }

  /* Gain: '<S25>/Gain' incorporates:
   *  MATLAB Function: '<S40>/fix_quadrant'
   */
  /* '<S134>:1:16' */
  rtb_TrigonometricFunction2 = fusion_only_accellerometer_2d_P.Gain_Gain_g *
    rtb_Product;

  /* RandomNumber: '<S21>/Random Number' */
  rtb_RandomNumber = fusion_only_accellerometer_2_DW.NextOutput_i;

  /* Sum: '<Root>/Sum' incorporates:
   *  Constant: '<Root>/Constant1'
   */
  rtb_DiscreteTimeIntegrator_h[0] = rtb_RandomNumber +
    fusion_only_accellerometer_2d_P.Constant1_Value_e;
  rtb_DiscreteTimeIntegrator_h[1] = rtb_RandomNumber +
    fusion_only_accellerometer_2d_P.Constant1_Value_e;
  rtb_DiscreteTimeIntegrator_h[2] = rtb_RandomNumber +
    fusion_only_accellerometer_2d_P.Constant1_Value_e;

  /* Step: '<S14>/speed' */
  if (fusion_only_accellerometer_2_M->Timing.t[0] <
      fusion_only_accellerometer_2d_P.speed_Time) {
    /* DataTypeConversion: '<S14>/Data Type Conversion2' */
    fusion_only_accellerometer_2d_B.DataTypeConversion2 = (real32_T)
      fusion_only_accellerometer_2d_P.speed_Y0;
  } else {
    /* DataTypeConversion: '<S14>/Data Type Conversion2' */
    fusion_only_accellerometer_2d_B.DataTypeConversion2 = (real32_T)
      fusion_only_accellerometer_2d_P.speed_YFinal;
  }

  /* End of Step: '<S14>/speed' */

  /* Chart: '<S93>/mag_init_avg' incorporates:
   *  DataTypeConversion: '<S14>/Data Type Conversion1'
   *  Product: '<S94>/Product'
   *  Product: '<S94>/Product1'
   *  Product: '<S94>/Product2'
   *  Sqrt: '<S94>/Sqrt'
   *  Sum: '<S94>/Sum of Elements'
   */
  fusion_only_accellerometer_2_DW.presentTicks =
    fusion_only_accellerometer_2_M->Timing.clockTick1;
  fusion_only_accellerometer_2_DW.elapsedTicks =
    fusion_only_accellerometer_2_DW.presentTicks -
    fusion_only_accellerometer_2_DW.previousTicks;
  fusion_only_accellerometer_2_DW.previousTicks =
    fusion_only_accellerometer_2_DW.presentTicks;
  if (fusion_only_accellerometer_2_DW.temporalCounter_i1 +
      fusion_only_accellerometer_2_DW.elapsedTicks <= 63U) {
    fusion_only_accellerometer_2_DW.temporalCounter_i1 = (uint8_T)
      (fusion_only_accellerometer_2_DW.temporalCounter_i1 +
       fusion_only_accellerometer_2_DW.elapsedTicks);
  } else {
    fusion_only_accellerometer_2_DW.temporalCounter_i1 = 63U;
  }

  /* Gateway: MagnetoInit/mag_init_phase/mag_init_avg */
  /* During: MagnetoInit/mag_init_phase/mag_init_avg */
  /* During 'Steadystate_magnitude': '<S95>:9' */
  switch (fusion_only_accellerometer_2_DW.is_Steadystate_magnitude) {
   case fusion_only_accellero_IN_config:
    /* During 'config': '<S95>:28' */
    if (fusion_only_accellerometer_2_DW.temporalCounter_i1 >= 40U) {
      /* Transition: '<S95>:31' */
      fusion_only_accellerometer_2_DW.is_Steadystate_magnitude =
        fusion_only_accel_IN_init_phase;

      /* Entry 'init_phase': '<S95>:1' */
      fusion_only_accellerometer_2_DW.i = 0.0F;
      fusion_only_accellerometer_2_DW.sum = 0.0F;
      fusion_only_accellerometer_2_DW.sumx = 0.0F;
      fusion_only_accellerometer_2_DW.sumy = 0.0F;
      fusion_only_accellerometer_2_DW.sumz = 0.0F;
    }
    break;

   case fusion_only_accellerome_IN_exec:
    /* During 'exec': '<S95>:2' */
    break;

   case fusion_only_acc_IN_failure_mode:
    /* During 'failure_mode': '<S95>:35' */
    break;

   default:
    /* During 'init_phase': '<S95>:1' */
    if (fusion_only_accellerometer_2d_B.DataTypeConversion2 != 0.0F) {
      /* Transition: '<S95>:41' */
      fusion_only_accellerometer_2_DW.is_Steadystate_magnitude =
        fusion_only_acc_IN_failure_mode;

      /* Entry 'failure_mode': '<S95>:35' */
    } else if (fusion_only_accellerometer_2_DW.i >= 50.0F) {
      /* Transition: '<S95>:52' */
      fusion_only_accellerometer_2_DW.is_Steadystate_magnitude =
        fusion_only_accellerome_IN_exec;

      /* Entry 'exec': '<S95>:2' */
      fusion_only_accellerometer_2d_B.avr_mag_x =
        fusion_only_accellerometer_2_DW.sumx / fusion_only_accellerometer_2_DW.i;
      fusion_only_accellerometer_2d_B.avr_mag_y =
        fusion_only_accellerometer_2_DW.sumy / fusion_only_accellerometer_2_DW.i;
    } else {
      fusion_only_accellerometer_2_DW.i++;
      fusion_only_accellerometer_2_DW.sum += sqrtf(((real32_T)
        rtb_DiscreteTimeIntegrator_h[0] * (real32_T)
        rtb_DiscreteTimeIntegrator_h[0] + (real32_T)
        rtb_DiscreteTimeIntegrator_h[1] * (real32_T)
        rtb_DiscreteTimeIntegrator_h[1]) + (real32_T)
        rtb_DiscreteTimeIntegrator_h[2] * (real32_T)
        rtb_DiscreteTimeIntegrator_h[2]);
      fusion_only_accellerometer_2_DW.sumx += (real32_T)
        rtb_DiscreteTimeIntegrator_h[0];
      fusion_only_accellerometer_2_DW.sumy += (real32_T)
        rtb_DiscreteTimeIntegrator_h[1];
      fusion_only_accellerometer_2_DW.sumz += (real32_T)
        rtb_DiscreteTimeIntegrator_h[2];
    }
    break;
  }

  /* End of Chart: '<S93>/mag_init_avg' */

  /* Gain: '<S23>/Gain' incorporates:
   *  Gain: '<S14>/Gain'
   *  Gain: '<S22>/Gain'
   *  Gain: '<S3>/Gain1'
   *  MATLAB Function: '<S40>/fix_quadrant'
   *  Sum: '<Root>/Sum7'
   *  Trigonometry: '<S14>/Atan2'
   */
  rtb_TrigonometricFunction = (rt_atan2f_snf
    (fusion_only_accellerometer_2d_P.Gain_Gain_n *
     fusion_only_accellerometer_2d_B.avr_mag_y,
     fusion_only_accellerometer_2d_B.avr_mag_x) *
    fusion_only_accellerometer_2d_P.Gain_Gain_h5 *
    fusion_only_accellerometer_2d_P.Gain1_Gain_h + rtb_Product) *
    fusion_only_accellerometer_2d_P.Gain_Gain_o;

  /* DiscreteIntegrator: '<S6>/Discrete- Time Integrator' */
  rtb_DiscreteTimeIntegrator =
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_m;

  /* DiscreteIntegrator: '<S6>/Discrete- Time Integrator2' */
  rtb_DiscreteTimeIntegrator2 =
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator2_DSTATE;

  /* DiscreteIntegrator: '<S7>/Discrete- Time Integrator' */
  rtb_DiscreteTimeIntegrator_d =
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_o;

  /* DiscreteIntegrator: '<S7>/Discrete- Time Integrator2' */
  rtb_DiscreteTimeIntegrator2_d =
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator2_DSTAT_l;

  /* RandomNumber: '<S8>/Random Number' */
  rtb_TrigonometricFunction = fusion_only_accellerometer_2_DW.NextOutput_o;

  /* Product: '<S8>/Product' incorporates:
   *  Constant: '<S8>/Constant'
   */
  fusion_only_accellerometer_2d_B.Product = rtb_TrigonometricFunction *
    fusion_only_accellerometer_2d_P.Constant_Value_k;

  /* Sum: '<S45>/Sum' */
  rtb_Sum[0] = rtb_AxAy[0] -
    fusion_only_accellerometer_2d_B.Control_l.Assignment_m[0];
  rtb_Sum[1] = rtb_AxAy[1] -
    fusion_only_accellerometer_2d_B.Control_l.Assignment_m[1];

  /* Sum: '<S79>/Sum' */
  rtb_Sum[0] = fusion_only_accellerometer_2d_B.VectorConcatenate[0] -
    fusion_only_accellerometer_2d_B.Control.Assignment_m[0];
  rtb_Sum[1] = fusion_only_accellerometer_2d_B.VectorConcatenate[1] -
    fusion_only_accellerometer_2d_B.Control.Assignment_m[1];

  /* Gain: '<S100>/Gain' incorporates:
   *  Trigonometry: '<S18>/Atan1'
   */
  fusion_only_accellerometer_2d_B.Gain =
    fusion_only_accellerometer_2d_P.Gain_Gain_o2 * rt_atan2d_snf(rtb_FromWs[1],
    rtb_FromWs[0]);

  /* DiscreteIntegrator: '<S98>/Discrete-Time Integrator' */
  rtb_DiscreteTimeIntegrator_h[0] =
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_a[0];
  rtb_DiscreteTimeIntegrator_h[1] =
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_a[1];
  rtb_DiscreteTimeIntegrator_h[2] =
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_a[2];
  if (fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[3] == 0) {
    /* UnitDelay: '<S105>/Output' */
    rtb_Output = fusion_only_accellerometer_2_DW.Output_DSTATE;

    /* MultiPortSwitch: '<S102>/Output' incorporates:
     *  Constant: '<S102>/Vector'
     *  UnitDelay: '<S105>/Output'
     */
    rtb_steeringratelimit =
      fusion_only_accellerometer_2d_P.Steeringangle2indeg_OutValues[fusion_only_accellerometer_2_DW.Output_DSTATE];
  }

  /* Product: '<S97>/Product' incorporates:
   *  Constant: '<S18>/angular speed [rad//s] '
   *  Constant: '<S97>/radius [cm] '
   *  Gain: '<S97>/cm2mt '
   */
  rtb_TrigonometricFunction = fusion_only_accellerometer_2d_P.cm2mt_Gain *
    fusion_only_accellerometer_2d_P.Angspeed2whspeed_wheel_radius *
    fusion_only_accellerometer_2d_P.angularspeedrads_Value;

  /* Math: '<S104>/range' incorporates:
   *  SignalConversion: '<S98>/ConcatBufferAtVector ConcatenateIn1'
   *  SignalConversion: '<S98>/ConcatBufferAtVector ConcatenateIn2'
   */
  rtb_TrigonometricFunction2 = rt_hypotd_snf(rtb_DiscreteTimeIntegrator_h[0],
    rtb_DiscreteTimeIntegrator_h[1]);

  /* Trigonometry: '<S104>/bearing' incorporates:
   *  SignalConversion: '<S98>/ConcatBufferAtVector ConcatenateIn1'
   *  SignalConversion: '<S98>/ConcatBufferAtVector ConcatenateIn2'
   */
  rtb_Gain = rt_atan2d_snf(rtb_DiscreteTimeIntegrator_h[1],
    rtb_DiscreteTimeIntegrator_h[0]);
  if (fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[3] == 0) {
    /* Gain: '<S99>/Gain1' */
    rtb_steeringratelimit *= fusion_only_accellerometer_2d_P.Gain1_Gain_c;

    /* Saturate: '<S98>/steering angle limit' */
    if (rtb_steeringratelimit > fusion_only_accellerometer_2d_P.Bicycle_alim) {
      rtb_steeringratelimit = fusion_only_accellerometer_2d_P.Bicycle_alim;
    } else {
      if (rtb_steeringratelimit < -fusion_only_accellerometer_2d_P.Bicycle_alim)
      {
        rtb_steeringratelimit = -fusion_only_accellerometer_2d_P.Bicycle_alim;
      }
    }

    /* End of Saturate: '<S98>/steering angle limit' */

    /* RateLimiter: '<S98>/steering rate limit' */
    rtb_Product = rtb_steeringratelimit - fusion_only_accellerometer_2_DW.PrevY;
    if (rtb_Product >
        fusion_only_accellerometer_2d_P.steeringratelimit_RisingLim) {
      rtb_steeringratelimit = fusion_only_accellerometer_2_DW.PrevY +
        fusion_only_accellerometer_2d_P.steeringratelimit_RisingLim;
    } else {
      if (rtb_Product <
          fusion_only_accellerometer_2d_P.steeringratelimit_FallingLim) {
        rtb_steeringratelimit = fusion_only_accellerometer_2_DW.PrevY +
          fusion_only_accellerometer_2d_P.steeringratelimit_FallingLim;
      }
    }

    fusion_only_accellerometer_2_DW.PrevY = rtb_steeringratelimit;

    /* End of RateLimiter: '<S98>/steering rate limit' */

    /* Trigonometry: '<S98>/Atan2' incorporates:
     *  Constant: '<S18>/Wheel base [mt] '
     */
    fusion_only_accellerometer_2d_B.Atan2 = rt_atan2d_snf(rtb_steeringratelimit,
      fusion_only_accellerometer_2d_P.Wheelbasemt_Value);
  }

  /* Gain: '<S103>/Gain' incorporates:
   *  Trigonometry: '<S98>/Atan1'
   */
  rtb_Gain = fusion_only_accellerometer_2d_P.Gain_Gain_l * rt_atan2d_snf
    (rtb_DiscreteTimeIntegrator_h[1], rtb_DiscreteTimeIntegrator_h[0]);

  /* Trigonometry: '<S98>/Trigonometric Function' */
  rtb_Gain = cos(rtb_DiscreteTimeIntegrator_h[2]);

  /* Trigonometry: '<S98>/Trigonometric Function2' */
  rtb_TrigonometricFunction2 = sin(rtb_DiscreteTimeIntegrator_h[2]);

  /* Saturate: '<S98>/vel limit' */
  if (rtb_TrigonometricFunction > fusion_only_accellerometer_2d_P.Bicycle_vlim)
  {
    rtb_TrigonometricFunction = fusion_only_accellerometer_2d_P.Bicycle_vlim;
  } else {
    if (rtb_TrigonometricFunction <
        -fusion_only_accellerometer_2d_P.Bicycle_vlim) {
      rtb_TrigonometricFunction = -fusion_only_accellerometer_2d_P.Bicycle_vlim;
    }
  }

  /* End of Saturate: '<S98>/vel limit' */

  /* RateLimiter: '<S98>/acceleration limit' */
  rtb_Product = rtb_TrigonometricFunction -
    fusion_only_accellerometer_2_DW.PrevY_e;
  if (rtb_Product > fusion_only_accellerometer_2d_P.accelerationlimit_RisingLim)
  {
    rtb_TrigonometricFunction = fusion_only_accellerometer_2_DW.PrevY_e +
      fusion_only_accellerometer_2d_P.accelerationlimit_RisingLim;
  } else {
    if (rtb_Product <
        fusion_only_accellerometer_2d_P.accelerationlimit_FallingLim) {
      rtb_TrigonometricFunction = fusion_only_accellerometer_2_DW.PrevY_e +
        fusion_only_accellerometer_2d_P.accelerationlimit_FallingLim;
    }
  }

  fusion_only_accellerometer_2_DW.PrevY_e = rtb_TrigonometricFunction;

  /* End of RateLimiter: '<S98>/acceleration limit' */

  /* Product: '<S98>/Product' */
  rtb_Product_i[0] = rtb_Gain * rtb_TrigonometricFunction;
  rtb_Product_i[1] = rtb_TrigonometricFunction2 * rtb_TrigonometricFunction;
  rtb_Product_i[2] = fusion_only_accellerometer_2d_B.Atan2 *
    rtb_TrigonometricFunction;
  if (fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[3] == 0) {
    /* Sum: '<S106>/FixPt Sum1' incorporates:
     *  Constant: '<S106>/FixPt Constant'
     */
    rtb_Output = (uint8_T)((uint32_T)rtb_Output +
      fusion_only_accellerometer_2d_P.FixPtConstant_Value);

    /* Switch: '<S107>/FixPt Switch' incorporates:
     *  Constant: '<S107>/Constant'
     */
    if (rtb_Output > fusion_only_accellerometer_2d_P.LimitedCounter_uplimit) {
      rtb_FixPtSwitch = fusion_only_accellerometer_2d_P.Constant_Value_d;
    } else {
      rtb_FixPtSwitch = rtb_Output;
    }

    /* End of Switch: '<S107>/FixPt Switch' */
  }

  /* FromWorkspace: '<S111>/FromWs' */
  {
    real_T *pDataValues = (real_T *)
      fusion_only_accellerometer_2_DW.FromWs_PWORK_i.DataPtr;
    real_T *pTimeValues = (real_T *)
      fusion_only_accellerometer_2_DW.FromWs_PWORK_i.TimePtr;
    int_T currTimeIndex =
      fusion_only_accellerometer_2_DW.FromWs_IWORK_g.PrevIndex;
    real_T t = fusion_only_accellerometer_2_M->Timing.t[0];

    /* Get index */
    if (t <= pTimeValues[0]) {
      currTimeIndex = 0;
    } else if (t >= pTimeValues[5]) {
      currTimeIndex = 4;
    } else {
      if (t < pTimeValues[currTimeIndex]) {
        while (t < pTimeValues[currTimeIndex]) {
          currTimeIndex--;
        }
      } else {
        while (t >= pTimeValues[currTimeIndex + 1]) {
          currTimeIndex++;
        }
      }
    }

    fusion_only_accellerometer_2_DW.FromWs_IWORK_g.PrevIndex = currTimeIndex;

    /* Post output */
    {
      real_T t1 = pTimeValues[currTimeIndex];
      real_T t2 = pTimeValues[currTimeIndex + 1];
      if (t1 == t2) {
        if (t < t1) {
          fusion_only_accellerometer_2d_B.FromWs = pDataValues[currTimeIndex];
        } else {
          fusion_only_accellerometer_2d_B.FromWs = pDataValues[currTimeIndex + 1];
        }
      } else {
        real_T f1 = (t2 - t) / (t2 - t1);
        real_T f2 = 1.0 - f1;
        real_T d1;
        real_T d2;
        int_T TimeIndex= currTimeIndex;
        d1 = pDataValues[TimeIndex];
        d2 = pDataValues[TimeIndex + 1];
        fusion_only_accellerometer_2d_B.FromWs = (real_T) rtInterpolate(d1, d2,
          f1, f2);
        pDataValues += 6;
      }
    }
  }

  /* DiscreteIntegrator: '<S109>/Discrete-Time Integrator' */
  rtb_DiscreteTimeIntegrator_c[0] =
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_n[0];
  rtb_DiscreteTimeIntegrator_c[1] =
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_n[1];
  rtb_DiscreteTimeIntegrator_c[2] =
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_n[2];
  if (fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[3] == 0) {
    /* UnitDelay: '<S115>/Output' */
    rtb_Output_b = fusion_only_accellerometer_2_DW.Output_DSTATE_e;

    /* MultiPortSwitch: '<S112>/Output' incorporates:
     *  Constant: '<S112>/Vector'
     *  UnitDelay: '<S115>/Output'
     */
    rtb_steeringratelimit =
      fusion_only_accellerometer_2d_P.Steeringangle2indeg_OutValues_o[fusion_only_accellerometer_2_DW.Output_DSTATE_e];
  }

  /* Product: '<S108>/Product' incorporates:
   *  Constant: '<S108>/radius [cm] '
   *  Constant: '<S19>/angular speed [rad//s] '
   *  Gain: '<S108>/cm2mt '
   */
  rtb_Gain = fusion_only_accellerometer_2d_P.cm2mt_Gain_j *
    fusion_only_accellerometer_2d_P.Angspeed2whspeed_wheel_radius_a *
    fusion_only_accellerometer_2d_P.angularspeedrads_Value_k;

  /* Math: '<S114>/range' incorporates:
   *  SignalConversion: '<S109>/ConcatBufferAtVector ConcatenateIn1'
   *  SignalConversion: '<S109>/ConcatBufferAtVector ConcatenateIn2'
   */
  rtb_TrigonometricFunction = rt_hypotd_snf(rtb_DiscreteTimeIntegrator_c[0],
    rtb_DiscreteTimeIntegrator_c[1]);

  /* Trigonometry: '<S114>/bearing' incorporates:
   *  SignalConversion: '<S109>/ConcatBufferAtVector ConcatenateIn1'
   *  SignalConversion: '<S109>/ConcatBufferAtVector ConcatenateIn2'
   */
  rtb_TrigonometricFunction2 = rt_atan2d_snf(rtb_DiscreteTimeIntegrator_c[1],
    rtb_DiscreteTimeIntegrator_c[0]);
  if (fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[3] == 0) {
    /* Gain: '<S110>/Gain1' */
    rtb_steeringratelimit *= fusion_only_accellerometer_2d_P.Gain1_Gain_a;

    /* Saturate: '<S109>/steering angle limit' */
    if (rtb_steeringratelimit > fusion_only_accellerometer_2d_P.Bicycle_alim_o)
    {
      rtb_steeringratelimit = fusion_only_accellerometer_2d_P.Bicycle_alim_o;
    } else {
      if (rtb_steeringratelimit <
          -fusion_only_accellerometer_2d_P.Bicycle_alim_o) {
        rtb_steeringratelimit = -fusion_only_accellerometer_2d_P.Bicycle_alim_o;
      }
    }

    /* End of Saturate: '<S109>/steering angle limit' */

    /* RateLimiter: '<S109>/steering rate limit' */
    rtb_Product = rtb_steeringratelimit -
      fusion_only_accellerometer_2_DW.PrevY_i;
    if (rtb_Product >
        fusion_only_accellerometer_2d_P.steeringratelimit_RisingLim_c) {
      rtb_steeringratelimit = fusion_only_accellerometer_2_DW.PrevY_i +
        fusion_only_accellerometer_2d_P.steeringratelimit_RisingLim_c;
    } else {
      if (rtb_Product <
          fusion_only_accellerometer_2d_P.steeringratelimit_FallingLim_n) {
        rtb_steeringratelimit = fusion_only_accellerometer_2_DW.PrevY_i +
          fusion_only_accellerometer_2d_P.steeringratelimit_FallingLim_n;
      }
    }

    fusion_only_accellerometer_2_DW.PrevY_i = rtb_steeringratelimit;

    /* End of RateLimiter: '<S109>/steering rate limit' */

    /* Trigonometry: '<S109>/Atan2' incorporates:
     *  Constant: '<S19>/Wheel base [mt] '
     */
    fusion_only_accellerometer_2d_B.Atan2_c = rt_atan2d_snf
      (rtb_steeringratelimit,
       fusion_only_accellerometer_2d_P.Wheelbasemt_Value_a);
  }

  /* Gain: '<S113>/Gain' incorporates:
   *  Trigonometry: '<S109>/Atan1'
   */
  rtb_TrigonometricFunction = fusion_only_accellerometer_2d_P.Gain_Gain_b *
    rt_atan2d_snf(rtb_DiscreteTimeIntegrator_c[1], rtb_DiscreteTimeIntegrator_c
                  [0]);

  /* Trigonometry: '<S109>/Trigonometric Function' */
  rtb_TrigonometricFunction = cos(rtb_DiscreteTimeIntegrator_c[2]);

  /* Trigonometry: '<S109>/Trigonometric Function2' */
  rtb_TrigonometricFunction2 = sin(rtb_DiscreteTimeIntegrator_c[2]);

  /* Saturate: '<S109>/vel limit' */
  if (rtb_Gain > fusion_only_accellerometer_2d_P.Bicycle_vlim_h) {
    rtb_Gain = fusion_only_accellerometer_2d_P.Bicycle_vlim_h;
  } else {
    if (rtb_Gain < -fusion_only_accellerometer_2d_P.Bicycle_vlim_h) {
      rtb_Gain = -fusion_only_accellerometer_2d_P.Bicycle_vlim_h;
    }
  }

  /* End of Saturate: '<S109>/vel limit' */

  /* RateLimiter: '<S109>/acceleration limit' */
  rtb_Product = rtb_Gain - fusion_only_accellerometer_2_DW.PrevY_l;
  if (rtb_Product >
      fusion_only_accellerometer_2d_P.accelerationlimit_RisingLim_p) {
    rtb_Gain = fusion_only_accellerometer_2_DW.PrevY_l +
      fusion_only_accellerometer_2d_P.accelerationlimit_RisingLim_p;
  } else {
    if (rtb_Product <
        fusion_only_accellerometer_2d_P.accelerationlimit_FallingLim_h) {
      rtb_Gain = fusion_only_accellerometer_2_DW.PrevY_l +
        fusion_only_accellerometer_2d_P.accelerationlimit_FallingLim_h;
    }
  }

  fusion_only_accellerometer_2_DW.PrevY_l = rtb_Gain;

  /* End of RateLimiter: '<S109>/acceleration limit' */

  /* Product: '<S109>/Product' */
  rtb_Product_e[0] = rtb_TrigonometricFunction * rtb_Gain;
  rtb_Product_e[1] = rtb_TrigonometricFunction2 * rtb_Gain;
  rtb_Product_e[2] = fusion_only_accellerometer_2d_B.Atan2_c * rtb_Gain;
  if (fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[3] == 0) {
    /* Sum: '<S116>/FixPt Sum1' incorporates:
     *  Constant: '<S116>/FixPt Constant'
     */
    rtb_Output = (uint8_T)((uint32_T)rtb_Output_b +
      fusion_only_accellerometer_2d_P.FixPtConstant_Value_i);

    /* Switch: '<S117>/FixPt Switch' incorporates:
     *  Constant: '<S117>/Constant'
     */
    if (rtb_Output > fusion_only_accellerometer_2d_P.LimitedCounter_uplimit_b) {
      rtb_FixPtSwitch_e = fusion_only_accellerometer_2d_P.Constant_Value_c4;
    } else {
      rtb_FixPtSwitch_e = rtb_Output;
    }

    /* End of Switch: '<S117>/FixPt Switch' */
  }

  if (fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[2] == 0) {
    /* Gain: '<S126>/Gain1' */
    fusion_only_accellerometer_2d_B.Gain1 =
      fusion_only_accellerometer_2d_P.Gain1_Gain_b1 *
      fusion_only_accellerometer_2d_B.Control.Assignment_b[0];
  }

  /* Sum: '<Root>/Sum6' */
  fusion_only_accellerometer_2d_B.Gz_n = fusion_only_accellerometer_2d_B.Product
    + fusion_only_accellerometer_2d_B.FromWs;

  /* Trigonometry: '<S40>/Trigonometric Function5' */
  if (fusion_only_accellerometer_2d_B.Submatrix1[0] > 1.0) {
    rtb_Product = 1.0;
  } else if (fusion_only_accellerometer_2d_B.Submatrix1[0] < -1.0) {
    rtb_Product = -1.0;
  } else {
    rtb_Product = fusion_only_accellerometer_2d_B.Submatrix1[0];
  }

  /* Gain: '<S132>/Gain' incorporates:
   *  Trigonometry: '<S40>/Trigonometric Function5'
   */
  rtb_Gain = fusion_only_accellerometer_2d_P.Gain_Gain_h * acos(rtb_Product);

  /* Matfile logging */
  rt_UpdateTXYLogVars(fusion_only_accellerometer_2_M->rtwLogInfo,
                      (fusion_only_accellerometer_2_M->Timing.t));

  /* Update for DiscreteIntegrator: '<S38>/Discrete-Time Integrator' */
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_gainval *
    fusion_only_accellerometer_2d_B.Gz_n;
  if (fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[2] == 0) {
    /* Update for UnitDelay: '<S80>/Unit Delay2' */
    fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE[0] =
      fusion_only_accellerometer_2d_B.Control.Assignment_i[0];
    fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE[1] =
      fusion_only_accellerometer_2d_B.Control.Assignment_i[1];
    fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE[2] =
      fusion_only_accellerometer_2d_B.Control.Assignment_i[2];
    fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE[3] =
      fusion_only_accellerometer_2d_B.Control.Assignment_i[3];

    /* Update for UnitDelay: '<S80>/Unit Delay3' */
    memcpy(&fusion_only_accellerometer_2_DW.UnitDelay3_DSTATE[0],
           &fusion_only_accellerometer_2d_B.Control.Assignment[0], sizeof(real_T)
           << 4U);
  }

  /* Update for UnitDelay: '<S42>/UD' */
  fusion_only_accellerometer_2_DW.UD_DSTATE[0] = rtb_TSamp[0];

  /* Update for UnitDelay: '<S43>/UD' */
  fusion_only_accellerometer_2_DW.UD_DSTATE_n[0] = rtb_TSamp_f[0];

  /* Update for UnitDelay: '<S42>/UD' */
  fusion_only_accellerometer_2_DW.UD_DSTATE[1] = rtb_TSamp[1];

  /* Update for UnitDelay: '<S43>/UD' */
  fusion_only_accellerometer_2_DW.UD_DSTATE_n[1] = rtb_TSamp_f[1];

  /* Update for RandomNumber: '<S33>/Random Number' */
  fusion_only_accellerometer_2_DW.NextOutput = rt_nrand_Upu32_Yd_f_pw_snf
    (&fusion_only_accellerometer_2_DW.RandSeed) *
    fusion_only_accellerometer_2d_P.RandomNumber_StdDev +
    fusion_only_accellerometer_2d_P.RandomNumber_Mean;

  /* Update for UnitDelay: '<S46>/Unit Delay2' */
  fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE_e[0] =
    fusion_only_accellerometer_2d_B.Control_l.Assignment_i[0];
  fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE_e[1] =
    fusion_only_accellerometer_2d_B.Control_l.Assignment_i[1];
  fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE_e[2] =
    fusion_only_accellerometer_2d_B.Control_l.Assignment_i[2];
  fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE_e[3] =
    fusion_only_accellerometer_2d_B.Control_l.Assignment_i[3];

  /* Update for UnitDelay: '<S46>/Unit Delay3' */
  memcpy(&fusion_only_accellerometer_2_DW.UnitDelay3_DSTATE_d[0],
         &fusion_only_accellerometer_2d_B.Control_l.Assignment[0], sizeof(real_T)
         << 4U);

  /* Update for DiscreteIntegrator: '<S27>/Discrete-Time Integrator1' */
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator1_DSTATE +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator1_gainval *
    fusion_only_accellerometer_2d_B.Gain1;

  /* Update for DiscreteIntegrator: '<S6>/Discrete- Time Integrator1' */
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator1_DSTAT_f +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator1_gainv_g *
    rtb_DiscreteTimeIntegrator;

  /* Update for DiscreteIntegrator: '<S6>/Discrete- Time Integrator3' */
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator3_DSTATE +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator3_gainval *
    rtb_DiscreteTimeIntegrator2;

  /* Update for DiscreteIntegrator: '<S28>/Discrete-Time Integrator1' */
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator1_DSTAT_b +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator1_gainv_j *
    fusion_only_accellerometer_2d_B.VectorConcatenate[0];

  /* Update for DiscreteIntegrator: '<S7>/Discrete- Time Integrator1' */
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator1_DSTAT_p +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator1_gainv_c *
    rtb_DiscreteTimeIntegrator_d;

  /* Update for DiscreteIntegrator: '<S7>/Discrete- Time Integrator3' */
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator3_DSTAT_b +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator3_gainv_i *
    rtb_DiscreteTimeIntegrator2_d;

  /* Update for DiscreteIntegrator: '<S39>/Discrete-Time Integrator' */
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_k +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_gainva_n *
    fusion_only_accellerometer_2d_B.FromWs;

  /* Update for RandomNumber: '<S21>/Random Number' */
  fusion_only_accellerometer_2_DW.NextOutput_i = rt_nrand_Upu32_Yd_f_pw_snf
    (&fusion_only_accellerometer_2_DW.RandSeed_j) *
    fusion_only_accellerometer_2d_P.RandomNumber_StdDev_b +
    fusion_only_accellerometer_2d_P.RandomNumber_Mean_p;

  /* Update for DiscreteIntegrator: '<S6>/Discrete- Time Integrator' */
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_m +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_gainva_h *
    fusion_only_accellerometer_2d_B.Control_l.Assignment_b[0];

  /* Update for DiscreteIntegrator: '<S6>/Discrete- Time Integrator2' */
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator2_DSTATE +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator2_gainval *
    fusion_only_accellerometer_2d_B.Control_l.Assignment_b[2];

  /* Update for DiscreteIntegrator: '<S7>/Discrete- Time Integrator' */
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_o +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_gainva_k * rtb_Diff[0];

  /* Update for DiscreteIntegrator: '<S7>/Discrete- Time Integrator2' */
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator2_DSTAT_l +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator2_gainv_e * rtb_Diff[1];

  /* Update for RandomNumber: '<S8>/Random Number' */
  fusion_only_accellerometer_2_DW.NextOutput_o = rt_nrand_Upu32_Yd_f_pw_snf
    (&fusion_only_accellerometer_2_DW.RandSeed_a) *
    fusion_only_accellerometer_2d_P.RandomNumber_StdDev_d +
    fusion_only_accellerometer_2d_P.RandomNumber_Mean_k;

  /* Update for DiscreteIntegrator: '<S98>/Discrete-Time Integrator' */
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_a[0] +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_gainva_g *
    rtb_Product_i[0];
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_a[1] +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_gainva_g *
    rtb_Product_i[1];
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_a[2] +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_gainva_g *
    rtb_Product_i[2];
  if (fusion_only_accellerometer_2_M->Timing.TaskCounters.TID[3] == 0) {
    /* Update for UnitDelay: '<S105>/Output' */
    fusion_only_accellerometer_2_DW.Output_DSTATE = rtb_FixPtSwitch;

    /* Update for UnitDelay: '<S115>/Output' */
    fusion_only_accellerometer_2_DW.Output_DSTATE_e = rtb_FixPtSwitch_e;
  }

  /* Update for DiscreteIntegrator: '<S109>/Discrete-Time Integrator' */
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_n[0] +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_gainva_d *
    rtb_Product_e[0];
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_n[1] +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_gainva_d *
    rtb_Product_e[1];
  fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_n[2] +=
    fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_gainva_d *
    rtb_Product_e[2];

  /* signal main to stop simulation */
  {                                    /* Sample time: [0.0s, 0.0s] */
    if ((rtmGetTFinal(fusion_only_accellerometer_2_M)!=-1) &&
        !((rtmGetTFinal(fusion_only_accellerometer_2_M)-
           fusion_only_accellerometer_2_M->Timing.t[0]) >
          fusion_only_accellerometer_2_M->Timing.t[0] * (DBL_EPSILON))) {
      rtmSetErrorStatus(fusion_only_accellerometer_2_M, "Simulation finished");
    }
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++fusion_only_accellerometer_2_M->Timing.clockTick0)) {
    ++fusion_only_accellerometer_2_M->Timing.clockTickH0;
  }

  fusion_only_accellerometer_2_M->Timing.t[0] =
    fusion_only_accellerometer_2_M->Timing.clockTick0 *
    fusion_only_accellerometer_2_M->Timing.stepSize0 +
    fusion_only_accellerometer_2_M->Timing.clockTickH0 *
    fusion_only_accellerometer_2_M->Timing.stepSize0 * 4294967296.0;

  {
    /* Update absolute timer for sample time: [0.05s, 0.0s] */
    /* The "clockTick1" counts the number of times the code of this task has
     * been executed. The resolution of this integer timer is 0.05, which is the step size
     * of the task. Size of "clockTick1" ensures timer will not overflow during the
     * application lifespan selected.
     * Timer of this task consists of two 32 bit unsigned integers.
     * The two integers represent the low bits Timing.clockTick1 and the high bits
     * Timing.clockTickH1. When the low bit overflows to 0, the high bits increment.
     */
    fusion_only_accellerometer_2_M->Timing.clockTick1++;
    if (!fusion_only_accellerometer_2_M->Timing.clockTick1) {
      fusion_only_accellerometer_2_M->Timing.clockTickH1++;
    }
  }

  rate_scheduler();
}

/* Model initialize function */
void fusion_only_accellerometer_2dn3_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* non-finite (run-time) assignments */
  fusion_only_accellerometer_2d_P.steeringratelimit_RisingLim = rtInf;
  fusion_only_accellerometer_2d_P.steeringratelimit_FallingLim = rtMinusInf;
  fusion_only_accellerometer_2d_P.accelerationlimit_RisingLim = rtInf;
  fusion_only_accellerometer_2d_P.accelerationlimit_FallingLim = rtMinusInf;
  fusion_only_accellerometer_2d_P.steeringratelimit_RisingLim_c = rtInf;
  fusion_only_accellerometer_2d_P.steeringratelimit_FallingLim_n = rtMinusInf;
  fusion_only_accellerometer_2d_P.accelerationlimit_RisingLim_p = rtInf;
  fusion_only_accellerometer_2d_P.accelerationlimit_FallingLim_h = rtMinusInf;

  /* initialize real-time model */
  (void) memset((void *)fusion_only_accellerometer_2_M, 0,
                sizeof(RT_MODEL_fusion_only_acceller_T));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&fusion_only_accellerometer_2_M->solverInfo,
                          &fusion_only_accellerometer_2_M->Timing.simTimeStep);
    rtsiSetTPtr(&fusion_only_accellerometer_2_M->solverInfo, &rtmGetTPtr
                (fusion_only_accellerometer_2_M));
    rtsiSetStepSizePtr(&fusion_only_accellerometer_2_M->solverInfo,
                       &fusion_only_accellerometer_2_M->Timing.stepSize0);
    rtsiSetErrorStatusPtr(&fusion_only_accellerometer_2_M->solverInfo,
                          (&rtmGetErrorStatus(fusion_only_accellerometer_2_M)));
    rtsiSetRTModelPtr(&fusion_only_accellerometer_2_M->solverInfo,
                      fusion_only_accellerometer_2_M);
  }

  rtsiSetSimTimeStep(&fusion_only_accellerometer_2_M->solverInfo,
                     MAJOR_TIME_STEP);
  rtsiSetSolverName(&fusion_only_accellerometer_2_M->solverInfo,
                    "FixedStepDiscrete");
  rtmSetTPtr(fusion_only_accellerometer_2_M,
             &fusion_only_accellerometer_2_M->Timing.tArray[0]);
  rtmSetTFinal(fusion_only_accellerometer_2_M, 100.0);
  fusion_only_accellerometer_2_M->Timing.stepSize0 = 0.05;

  /* Setup for data logging */
  {
    static RTWLogInfo rt_DataLoggingInfo;
    rt_DataLoggingInfo.loggingInterval = NULL;
    fusion_only_accellerometer_2_M->rtwLogInfo = &rt_DataLoggingInfo;
  }

  /* Setup for data logging */
  {
    rtliSetLogXSignalInfo(fusion_only_accellerometer_2_M->rtwLogInfo, (NULL));
    rtliSetLogXSignalPtrs(fusion_only_accellerometer_2_M->rtwLogInfo, (NULL));
    rtliSetLogT(fusion_only_accellerometer_2_M->rtwLogInfo, "tout");
    rtliSetLogX(fusion_only_accellerometer_2_M->rtwLogInfo, "");
    rtliSetLogXFinal(fusion_only_accellerometer_2_M->rtwLogInfo, "");
    rtliSetLogVarNameModifier(fusion_only_accellerometer_2_M->rtwLogInfo, "rt_");
    rtliSetLogFormat(fusion_only_accellerometer_2_M->rtwLogInfo, 4);
    rtliSetLogMaxRows(fusion_only_accellerometer_2_M->rtwLogInfo, 0);
    rtliSetLogDecimation(fusion_only_accellerometer_2_M->rtwLogInfo, 1);
    rtliSetLogY(fusion_only_accellerometer_2_M->rtwLogInfo, "");
    rtliSetLogYSignalInfo(fusion_only_accellerometer_2_M->rtwLogInfo, (NULL));
    rtliSetLogYSignalPtrs(fusion_only_accellerometer_2_M->rtwLogInfo, (NULL));
  }

  /* block I/O */
  (void) memset(((void *) &fusion_only_accellerometer_2d_B), 0,
                sizeof(B_fusion_only_accellerometer__T));

  /* states (dwork) */
  (void) memset((void *)&fusion_only_accellerometer_2_DW, 0,
                sizeof(DW_fusion_only_accellerometer_T));

  /* Matfile logging */
  rt_StartDataLoggingWithStartTime(fusion_only_accellerometer_2_M->rtwLogInfo,
    0.0, rtmGetTFinal(fusion_only_accellerometer_2_M),
    fusion_only_accellerometer_2_M->Timing.stepSize0, (&rtmGetErrorStatus
    (fusion_only_accellerometer_2_M)));

  /* Start for FromWorkspace: '<S101>/FromWs' */
  {
    static real_T pTimeValues0[] = { 0.0, 7.0, 7.0, 12.0, 12.0, 18.0, 18.0, 20.0,
      20.0, 25.0, 25.0, 33.0, 33.0, 40.0, 40.0, 70.0, 70.0, 100.0 } ;

    static real_T pDataValues0[] = { 0.0, 0.0, 0.0, 1.0, 1.0, 0.0, 0.0, 0.0, 0.0,
      0.0, 0.0, -0.8, -0.8, 0.5, 0.5, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
      0.0, 0.0, 0.0, 0.0, 0.5, 0.5, 0.44666666666666677, 0.44666666666666677,
      0.40000000000000008, 0.40000000000000008, 0.20000000000000007,
      0.20000000000000007, 0.0 } ;

    fusion_only_accellerometer_2_DW.FromWs_PWORK.TimePtr = (void *) pTimeValues0;
    fusion_only_accellerometer_2_DW.FromWs_PWORK.DataPtr = (void *) pDataValues0;
    fusion_only_accellerometer_2_DW.FromWs_IWORK.PrevIndex = 0;
  }

  /* Start for FromWorkspace: '<S111>/FromWs' */
  {
    static real_T pTimeValues0[] = { 0.0, 20.0, 20.0, 23.0, 23.0, 100.0 } ;

    static real_T pDataValues0[] = { 0.0, 0.0, 0.4, 0.4, 0.0, 0.0 } ;

    fusion_only_accellerometer_2_DW.FromWs_PWORK_i.TimePtr = (void *)
      pTimeValues0;
    fusion_only_accellerometer_2_DW.FromWs_PWORK_i.DataPtr = (void *)
      pDataValues0;
    fusion_only_accellerometer_2_DW.FromWs_IWORK_g.PrevIndex = 0;
  }

  {
    uint32_T tseed;
    int32_T r;
    int32_T t;
    real_T tmp;

    /* InitializeConditions for DiscreteIntegrator: '<S38>/Discrete-Time Integrator' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_IC;

    /* InitializeConditions for UnitDelay: '<S80>/Unit Delay2' */
    fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE[0] =
      fusion_only_accellerometer_2d_P.UnitDelay2_InitialCondition[0];
    fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE[1] =
      fusion_only_accellerometer_2d_P.UnitDelay2_InitialCondition[1];
    fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE[2] =
      fusion_only_accellerometer_2d_P.UnitDelay2_InitialCondition[2];
    fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE[3] =
      fusion_only_accellerometer_2d_P.UnitDelay2_InitialCondition[3];

    /* InitializeConditions for UnitDelay: '<S80>/Unit Delay3' */
    memcpy(&fusion_only_accellerometer_2_DW.UnitDelay3_DSTATE[0],
           &fusion_only_accellerometer_2d_P.UnitDelay3_InitialCondition[0],
           sizeof(real_T) << 4U);

    /* InitializeConditions for UnitDelay: '<S42>/UD' */
    fusion_only_accellerometer_2_DW.UD_DSTATE[0] =
      fusion_only_accellerometer_2d_P.DiscreteDerivative_ICPrevScaled;

    /* InitializeConditions for UnitDelay: '<S43>/UD' */
    fusion_only_accellerometer_2_DW.UD_DSTATE_n[0] =
      fusion_only_accellerometer_2d_P.DiscreteDerivative1_ICPrevScale;

    /* InitializeConditions for UnitDelay: '<S42>/UD' */
    fusion_only_accellerometer_2_DW.UD_DSTATE[1] =
      fusion_only_accellerometer_2d_P.DiscreteDerivative_ICPrevScaled;

    /* InitializeConditions for UnitDelay: '<S43>/UD' */
    fusion_only_accellerometer_2_DW.UD_DSTATE_n[1] =
      fusion_only_accellerometer_2d_P.DiscreteDerivative1_ICPrevScale;

    /* InitializeConditions for RandomNumber: '<S33>/Random Number' */
    tmp = floor(fusion_only_accellerometer_2d_P.RandomNumber_Seed);
    if (rtIsNaN(tmp) || rtIsInf(tmp)) {
      tmp = 0.0;
    } else {
      tmp = fmod(tmp, 4.294967296E+9);
    }

    tseed = tmp < 0.0 ? (uint32_T)-(int32_T)(uint32_T)-tmp : (uint32_T)tmp;
    r = (int32_T)(tseed >> 16U);
    t = (int32_T)(tseed & 32768U);
    tseed = ((((tseed - ((uint32_T)r << 16U)) + t) << 16U) + t) + r;
    if (tseed < 1U) {
      tseed = 1144108930U;
    } else {
      if (tseed > 2147483646U) {
        tseed = 2147483646U;
      }
    }

    fusion_only_accellerometer_2_DW.RandSeed = tseed;
    fusion_only_accellerometer_2_DW.NextOutput = rt_nrand_Upu32_Yd_f_pw_snf
      (&fusion_only_accellerometer_2_DW.RandSeed) *
      fusion_only_accellerometer_2d_P.RandomNumber_StdDev +
      fusion_only_accellerometer_2d_P.RandomNumber_Mean;

    /* End of InitializeConditions for RandomNumber: '<S33>/Random Number' */

    /* InitializeConditions for UnitDelay: '<S46>/Unit Delay2' */
    fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE_e[0] =
      fusion_only_accellerometer_2d_P.UnitDelay2_InitialCondition_p[0];
    fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE_e[1] =
      fusion_only_accellerometer_2d_P.UnitDelay2_InitialCondition_p[1];
    fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE_e[2] =
      fusion_only_accellerometer_2d_P.UnitDelay2_InitialCondition_p[2];
    fusion_only_accellerometer_2_DW.UnitDelay2_DSTATE_e[3] =
      fusion_only_accellerometer_2d_P.UnitDelay2_InitialCondition_p[3];

    /* InitializeConditions for UnitDelay: '<S46>/Unit Delay3' */
    memcpy(&fusion_only_accellerometer_2_DW.UnitDelay3_DSTATE_d[0],
           &fusion_only_accellerometer_2d_P.UnitDelay3_InitialCondition_p[0],
           sizeof(real_T) << 4U);

    /* InitializeConditions for DiscreteIntegrator: '<S27>/Discrete-Time Integrator1' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator1_DSTATE =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator1_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S6>/Discrete- Time Integrator1' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator1_DSTAT_f =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator1_IC_p;

    /* InitializeConditions for DiscreteIntegrator: '<S6>/Discrete- Time Integrator3' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator3_DSTATE =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator3_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S28>/Discrete-Time Integrator1' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator1_DSTAT_b =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator1_IC_c;

    /* InitializeConditions for DiscreteIntegrator: '<S7>/Discrete- Time Integrator1' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator1_DSTAT_p =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator1_IC_m;

    /* InitializeConditions for DiscreteIntegrator: '<S7>/Discrete- Time Integrator3' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator3_DSTAT_b =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator3_IC_c;

    /* InitializeConditions for DiscreteIntegrator: '<S39>/Discrete-Time Integrator' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_k =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_IC_d;

    /* InitializeConditions for RandomNumber: '<S21>/Random Number' */
    tmp = floor(fusion_only_accellerometer_2d_P.RandomNumber_Seed_m);
    if (rtIsNaN(tmp) || rtIsInf(tmp)) {
      tmp = 0.0;
    } else {
      tmp = fmod(tmp, 4.294967296E+9);
    }

    tseed = tmp < 0.0 ? (uint32_T)-(int32_T)(uint32_T)-tmp : (uint32_T)tmp;
    r = (int32_T)(tseed >> 16U);
    t = (int32_T)(tseed & 32768U);
    tseed = ((((tseed - ((uint32_T)r << 16U)) + t) << 16U) + t) + r;
    if (tseed < 1U) {
      tseed = 1144108930U;
    } else {
      if (tseed > 2147483646U) {
        tseed = 2147483646U;
      }
    }

    fusion_only_accellerometer_2_DW.RandSeed_j = tseed;
    fusion_only_accellerometer_2_DW.NextOutput_i = rt_nrand_Upu32_Yd_f_pw_snf
      (&fusion_only_accellerometer_2_DW.RandSeed_j) *
      fusion_only_accellerometer_2d_P.RandomNumber_StdDev_b +
      fusion_only_accellerometer_2d_P.RandomNumber_Mean_p;

    /* End of InitializeConditions for RandomNumber: '<S21>/Random Number' */

    /* InitializeConditions for DiscreteIntegrator: '<S6>/Discrete- Time Integrator' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_m =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_IC_l;

    /* InitializeConditions for DiscreteIntegrator: '<S6>/Discrete- Time Integrator2' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator2_DSTATE =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator2_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S7>/Discrete- Time Integrator' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_o =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_IC_h;

    /* InitializeConditions for DiscreteIntegrator: '<S7>/Discrete- Time Integrator2' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator2_DSTAT_l =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator2_IC_a;

    /* InitializeConditions for RandomNumber: '<S8>/Random Number' */
    tmp = floor(fusion_only_accellerometer_2d_P.RandomNumber_Seed_c);
    if (rtIsNaN(tmp) || rtIsInf(tmp)) {
      tmp = 0.0;
    } else {
      tmp = fmod(tmp, 4.294967296E+9);
    }

    tseed = tmp < 0.0 ? (uint32_T)-(int32_T)(uint32_T)-tmp : (uint32_T)tmp;
    r = (int32_T)(tseed >> 16U);
    t = (int32_T)(tseed & 32768U);
    tseed = ((((tseed - ((uint32_T)r << 16U)) + t) << 16U) + t) + r;
    if (tseed < 1U) {
      tseed = 1144108930U;
    } else {
      if (tseed > 2147483646U) {
        tseed = 2147483646U;
      }
    }

    fusion_only_accellerometer_2_DW.RandSeed_a = tseed;
    fusion_only_accellerometer_2_DW.NextOutput_o = rt_nrand_Upu32_Yd_f_pw_snf
      (&fusion_only_accellerometer_2_DW.RandSeed_a) *
      fusion_only_accellerometer_2d_P.RandomNumber_StdDev_d +
      fusion_only_accellerometer_2d_P.RandomNumber_Mean_k;

    /* End of InitializeConditions for RandomNumber: '<S8>/Random Number' */

    /* InitializeConditions for UnitDelay: '<S105>/Output' */
    fusion_only_accellerometer_2_DW.Output_DSTATE =
      fusion_only_accellerometer_2d_P.Output_InitialCondition;

    /* InitializeConditions for RateLimiter: '<S98>/steering rate limit' */
    fusion_only_accellerometer_2_DW.PrevY =
      fusion_only_accellerometer_2d_P.steeringratelimit_IC;

    /* InitializeConditions for RateLimiter: '<S98>/acceleration limit' */
    fusion_only_accellerometer_2_DW.PrevY_e =
      fusion_only_accellerometer_2d_P.accelerationlimit_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S98>/Discrete-Time Integrator' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_a[0] =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_IC_g;

    /* InitializeConditions for DiscreteIntegrator: '<S109>/Discrete-Time Integrator' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_n[0] =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_IC_j;

    /* InitializeConditions for DiscreteIntegrator: '<S98>/Discrete-Time Integrator' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_a[1] =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_IC_g;

    /* InitializeConditions for DiscreteIntegrator: '<S109>/Discrete-Time Integrator' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_n[1] =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_IC_j;

    /* InitializeConditions for DiscreteIntegrator: '<S98>/Discrete-Time Integrator' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_a[2] =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_IC_g;

    /* InitializeConditions for DiscreteIntegrator: '<S109>/Discrete-Time Integrator' */
    fusion_only_accellerometer_2_DW.DiscreteTimeIntegrator_DSTATE_n[2] =
      fusion_only_accellerometer_2d_P.DiscreteTimeIntegrator_IC_j;

    /* InitializeConditions for UnitDelay: '<S115>/Output' */
    fusion_only_accellerometer_2_DW.Output_DSTATE_e =
      fusion_only_accellerometer_2d_P.Output_InitialCondition_o;

    /* InitializeConditions for RateLimiter: '<S109>/steering rate limit' */
    fusion_only_accellerometer_2_DW.PrevY_i =
      fusion_only_accellerometer_2d_P.steeringratelimit_IC_e;

    /* InitializeConditions for RateLimiter: '<S109>/acceleration limit' */
    fusion_only_accellerometer_2_DW.PrevY_l =
      fusion_only_accellerometer_2d_P.accelerationlimit_IC_k;

    /* SystemInitialize for Iterator SubSystem: '<S80>/Control' */
    fusion_only_accell_Control_Init(&fusion_only_accellerometer_2d_B.Control,
      (P_Control_fusion_only_accelle_T *)
      &fusion_only_accellerometer_2d_P.Control);

    /* End of SystemInitialize for SubSystem: '<S80>/Control' */

    /* SystemInitialize for Iterator SubSystem: '<S46>/Control' */
    fusion_only_accell_Control_Init(&fusion_only_accellerometer_2d_B.Control_l,
      (P_Control_fusion_only_accelle_T *)
      &fusion_only_accellerometer_2d_P.Control_l);

    /* End of SystemInitialize for SubSystem: '<S46>/Control' */

    /* SystemInitialize for Chart: '<S93>/mag_init_avg' */
    fusion_only_accellerometer_2_DW.presentTicks = 0U;
    fusion_only_accellerometer_2_DW.elapsedTicks = 0U;
    fusion_only_accellerometer_2_DW.previousTicks = 0U;

    /* Entry: MagnetoInit/mag_init_phase/mag_init_avg */
    /* Entry Internal: MagnetoInit/mag_init_phase/mag_init_avg */
    /* Entry Internal 'Steadystate_magnitude': '<S95>:9' */
    /* Transition: '<S95>:38' */
    fusion_only_accellerometer_2_DW.is_Steadystate_magnitude =
      fusion_only_accellero_IN_config;
    fusion_only_accellerometer_2_DW.temporalCounter_i1 = 0U;

    /* Entry 'config': '<S95>:28' */
  }

  /* Enable for Chart: '<S93>/mag_init_avg' */
  fusion_only_accellerometer_2_DW.presentTicks =
    fusion_only_accellerometer_2_M->Timing.clockTick1;
  fusion_only_accellerometer_2_DW.previousTicks =
    fusion_only_accellerometer_2_DW.presentTicks;
}

/* Model terminate function */
void fusion_only_accellerometer_2dn3_terminate(void)
{
  /* (no terminate code required) */
}
