/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * File: integ_accel.c
 *
 * Code generated for Simulink model 'integ_accel'.
 *
 * Model version                  : 1.6
 * Simulink Coder version         : 8.12 (R2017a) 16-Feb-2017
 * C/C++ source code generated on : Tue Dec 05 15:11:10 2017
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "integ_accel.h"
#include "integ_accel_private.h"
#include "integ_accel_dt.h"

/* Block signals (auto storage) */
B_integ_accel_T integ_accel_B;

/* Block states (auto storage) */
DW_integ_accel_T integ_accel_DW;

/* Real-time model */
RT_MODEL_integ_accel_T integ_accel_M_;
RT_MODEL_integ_accel_T *const integ_accel_M = &integ_accel_M_;

/* Forward declaration for local functions */
static void integ_accel_LDLf_int32_Treal_T(real_T out[], real_T vArray[],
  int32_T nRows, const real_T in[]);
static void rate_scheduler(void);

/*
 *   This function updates active task flag for each subrate.
 * The function is called at model base rate, hence the
 * generated code self-manages all its subrates.
 */
static void rate_scheduler(void)
{
  /* Compute which subrates run during the next base time step.  Subrates
   * are an integer multiple of the base rate counter.  Therefore, the subtask
   * counter is reset when it reaches its limit (zero means run).
   */
  (integ_accel_M->Timing.TaskCounters.TID[2])++;
  if ((integ_accel_M->Timing.TaskCounters.TID[2]) > 999) {/* Sample time: [1.0s, 0.0s] */
    integ_accel_M->Timing.TaskCounters.TID[2] = 0;
  }
}

static void integ_accel_LDLf_int32_Treal_T(real_T out[], real_T vArray[],
  int32_T nRows, const real_T in[])
{
  int32_T c;
  int32_T r;
  int32_T idx1;
  int32_T idx2;
  boolean_T done;
  int32_T k;
  real_T prod;

  /* S-Function (sdspldl2): '<S12>/LDL Factorization' */
  done = false;

  /* use done to control the for loop return early  */
  /* when non-positive definite eigenvalue is detected */
  c = 0;
  while ((c < nRows) && (!done)) {
    idx2 = c * nRows;
    for (r = 0; r < c; r++) {
      idx1 = r * nRows;
      integ_accel_B.mYTmp = out[idx1 + c];
      integ_accel_B.mYTmpR = out[idx1 + r];
      vArray[r] = integ_accel_B.mYTmp * integ_accel_B.mYTmpR;
    }

    integ_accel_B.mYTmp = in[idx2 + c];
    idx1 = c;
    for (r = 0; r < c; r++) {
      prod = out[idx1] * vArray[r];
      integ_accel_B.mYTmp -= prod;
      idx1 += nRows;
    }

    integ_accel_B.mYTmpR = integ_accel_B.mYTmp;
    if (integ_accel_B.mYTmp <= 0.0) {
      done = true;
    } else {
      out[idx2 + c] = integ_accel_B.mYTmp;
      for (r = c + 1; r < nRows; r++) {
        integ_accel_B.mYTmp = in[idx2 + r];
        idx1 = r;
        for (k = 0; k < c; k++) {
          prod = out[idx1] * vArray[k];
          integ_accel_B.mYTmp -= prod;
          idx1 += nRows;
        }

        out[idx2 + r] = integ_accel_B.mYTmp / integ_accel_B.mYTmpR;
      }
    }

    c++;
  }

  /* transpose and copy lower sub-triang to upper */
  c = 0;
  while ((c < nRows) && (!done)) {
    for (r = c + 1; r < nRows; r++) {
      integ_accel_B.mYTmp = out[c * nRows + r];
      out[r * nRows + c] = integ_accel_B.mYTmp;
    }

    c++;
  }

  /* End of S-Function (sdspldl2): '<S12>/LDL Factorization' */
}

/* Model step function */
void integ_accel_step(void)
{
  boolean_T p;
  boolean_T p_0;
  int16_T output[3];
  uint8_T status;
  uint8_T output_raw[6];
  uint8_T y[2];
  uint8_T x[2];
  int32_T idxV;
  int32_T i;
  int32_T s5_iter;
  int16_T output_0;

  /* Reset subsysRan breadcrumbs */
  srClearBC(integ_accel_DW.Subsystem1_SubsysRanBC);
  if (integ_accel_M->Timing.TaskCounters.TID[2] == 0) {
    /* Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' incorporates:
     *  MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor'
     */
    p = false;
    p_0 = true;
    if (!(integ_accel_DW.obj.SampleTime ==
          integ_accel_P.FXOS87006AxesSensor_SampleTime)) {
      p_0 = false;
    }

    if (p_0) {
      p = true;
    }

    if (!p) {
      integ_accel_DW.obj.SampleTime =
        integ_accel_P.FXOS87006AxesSensor_SampleTime;
    }

    output[0] = 0;
    output[1] = 0;
    output[2] = 0;
    status = 1U;
    integ_accel_B.i2cname = 0;
    status = MW_I2C_MasterWrite(integ_accel_B.i2cname, 29U, &status, 1U, true,
      false);
    if (0 == status) {
      integ_accel_B.i2cname = 0;
      MW_I2C_MasterRead(integ_accel_B.i2cname, 29U, output_raw, 6U, false, true);
      memcpy((void *)&output[0], (void *)&output_raw[0], (size_t)3 * sizeof
             (int16_T));
      output_0 = output[0];
      memcpy((void *)&y[0], (void *)&output_0, (size_t)2 * sizeof(uint8_T));
      x[0] = y[1];
      x[1] = y[0];
      memcpy((void *)&output_0, (void *)&x[0], (size_t)1 * sizeof(int16_T));
      output[0] = output_0;
      output_0 = output[1];
      memcpy((void *)&y[0], (void *)&output_0, (size_t)2 * sizeof(uint8_T));
      x[0] = y[1];
      x[1] = y[0];
      memcpy((void *)&output_0, (void *)&x[0], (size_t)1 * sizeof(int16_T));
      output[1] = output_0;
      output_0 = output[2];
      memcpy((void *)&y[0], (void *)&output_0, (size_t)2 * sizeof(uint8_T));
      x[0] = y[1];
      x[1] = y[0];
      memcpy((void *)&output_0, (void *)&x[0], (size_t)1 * sizeof(int16_T));
      output[2] = output_0;
    }

    /* MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' incorporates:
     *  Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor'
     */
    integ_accel_B.FXOS87006AxesSensor[0] = (real_T)(int16_T)(output[0] >> 2) *
      0.244 / 1000.0;
    integ_accel_B.FXOS87006AxesSensor[1] = (real_T)(int16_T)(output[1] >> 2) *
      0.244 / 1000.0;
    integ_accel_B.FXOS87006AxesSensor[2] = (real_T)(int16_T)(output[2] >> 2) *
      0.244 / 1000.0;

    /* Outputs for Iterator SubSystem: '<S3>/Control' incorporates:
     *  ForIterator: '<S5>/Iterator'
     */
    /* UnitDelay: '<S3>/Unit Delay3' */
    memcpy(&integ_accel_B.Assignment[0], &integ_accel_DW.UnitDelay3_DSTATE[0],
           sizeof(real_T) << 4U);

    /* UnitDelay: '<S3>/Unit Delay2' */
    integ_accel_B.Assignment_c[0] = integ_accel_DW.UnitDelay2_DSTATE[0];
    integ_accel_B.Assignment_c[1] = integ_accel_DW.UnitDelay2_DSTATE[1];
    integ_accel_B.Assignment_c[2] = integ_accel_DW.UnitDelay2_DSTATE[2];
    integ_accel_B.Assignment_c[3] = integ_accel_DW.UnitDelay2_DSTATE[3];

    /* Selector: '<S6>/Selector' incorporates:
     *  Math: '<S12>/Math Function'
     *  S-Function (sdspdiag2): '<S12>/Extract Diagonal'
     *
     * About '<S12>/Math Function':
     *  Operator: reciprocal
     */
    for (s5_iter = 0; s5_iter + 1 <= integ_accel_P.Iterator_IterationLimit;
         s5_iter++) {
      for (idxV = 0; idxV < 2; idxV++) {
        /* Product: '<S7>/H*P_prdt' incorporates:
         *  Constant: '<S7>/Hcst'
         *  Math: '<S7>/P_prd Trans'
         *  UnitDelay: '<S3>/Unit Delay3'
         */
        for (i = 0; i < 4; i++) {
          integ_accel_B.y[idxV + (i << 1)] = 0.0;
          integ_accel_B.y[idxV + (i << 1)] += integ_accel_P.Hcst_Value[idxV] *
            integ_accel_DW.UnitDelay3_DSTATE[i];
          integ_accel_B.y[idxV + (i << 1)] += integ_accel_P.Hcst_Value[idxV + 2]
            * integ_accel_DW.UnitDelay3_DSTATE[i + 4];
          integ_accel_B.y[idxV + (i << 1)] += integ_accel_P.Hcst_Value[idxV + 4]
            * integ_accel_DW.UnitDelay3_DSTATE[i + 8];
          integ_accel_B.y[idxV + (i << 1)] += integ_accel_P.Hcst_Value[idxV + 6]
            * integ_accel_DW.UnitDelay3_DSTATE[i + 12];
        }

        /* End of Product: '<S7>/H*P_prdt' */

        /* Sum: '<S7>/H*P_prdt*Ht+R' incorporates:
         *  Constant: '<S7>/Constant2'
         *  Constant: '<S7>/Hcst_t'
         *  Product: '<S7>/H*P_prdt*Ht'
         */
        for (i = 0; i < 2; i++) {
          integ_accel_B.LDLFactorization[idxV + (i << 1)] =
            (((integ_accel_P.Hcst_t_Value[(i << 2) + 1] * integ_accel_B.y[idxV +
               2] + integ_accel_P.Hcst_t_Value[i << 2] * integ_accel_B.y[idxV])
              + integ_accel_P.Hcst_t_Value[(i << 2) + 2] * integ_accel_B.y[idxV
              + 4]) + integ_accel_P.Hcst_t_Value[(i << 2) + 3] *
             integ_accel_B.y[idxV + 6]) + integ_accel_P.Constant2_Value[(i << 1)
            + idxV];
        }

        /* End of Sum: '<S7>/H*P_prdt*Ht+R' */
      }

      /* S-Function (sdspldl2): '<S12>/LDL Factorization' */
      integ_accel_LDLf_int32_Treal_T(&integ_accel_B.LDLFactorization[0U],
        &integ_accel_DW.LDLFactorization_VMX[0U], 2,
        &integ_accel_B.LDLFactorization[0U]);

      /* S-Function (sdspfbsub2): '<S12>/Forward Substitution' */
      idxV = 1;
      integ_accel_B.currentTime = integ_accel_B.y[1];
      i = 0;
      while (i < 1) {
        integ_accel_B.currentTime -= integ_accel_B.LDLFactorization[idxV] *
          integ_accel_B.y[0];
        idxV += 2;
        i = 1;
      }

      integ_accel_B.y[1] = integ_accel_B.currentTime;
      idxV = 1;
      integ_accel_B.currentTime = integ_accel_B.y[3];
      i = 0;
      while (i < 1) {
        integ_accel_B.currentTime -= integ_accel_B.LDLFactorization[idxV] *
          integ_accel_B.y[2];
        idxV += 2;
        i = 1;
      }

      integ_accel_B.y[3] = integ_accel_B.currentTime;
      idxV = 1;
      integ_accel_B.currentTime = integ_accel_B.y[5];
      i = 0;
      while (i < 1) {
        integ_accel_B.currentTime -= integ_accel_B.LDLFactorization[idxV] *
          integ_accel_B.y[4];
        idxV += 2;
        i = 1;
      }

      integ_accel_B.y[5] = integ_accel_B.currentTime;
      idxV = 1;
      integ_accel_B.currentTime = integ_accel_B.y[7];
      i = 0;
      while (i < 1) {
        integ_accel_B.currentTime -= integ_accel_B.LDLFactorization[idxV] *
          integ_accel_B.y[6];
        idxV += 2;
        i = 1;
      }

      integ_accel_B.y[7] = integ_accel_B.currentTime;

      /* End of S-Function (sdspfbsub2): '<S12>/Forward Substitution' */
      integ_accel_B.ZHX_prd[0] = 1.0 / integ_accel_B.LDLFactorization[0];

      /* Math: '<S12>/Math Function' incorporates:
       *  S-Function (sdspdiag2): '<S12>/Extract Diagonal'
       *
       * About '<S12>/Math Function':
       *  Operator: reciprocal
       */
      integ_accel_B.currentTime = 1.0 / integ_accel_B.LDLFactorization[3];

      /* S-Function (sdspdmult2): '<S12>/Matrix Scaling' */
      idxV = 0;
      for (i = 0; i < 4; i++) {
        integ_accel_B.BackwardSubstitution[idxV] = integ_accel_B.y[idxV] *
          integ_accel_B.ZHX_prd[0];
        idxV++;
        integ_accel_B.BackwardSubstitution[idxV] = integ_accel_B.y[idxV] *
          integ_accel_B.currentTime;
        idxV++;
      }

      /* End of S-Function (sdspdmult2): '<S12>/Matrix Scaling' */

      /* S-Function (sdspfbsub2): '<S12>/Backward Substitution' */
      idxV = 0;
      integ_accel_B.currentTime = integ_accel_B.BackwardSubstitution[0];
      i = 1;
      while (i > 0) {
        integ_accel_B.currentTime -= integ_accel_B.LDLFactorization[idxV + 2] *
          integ_accel_B.BackwardSubstitution[1];
        idxV -= 2;
        i = 0;
      }

      integ_accel_B.BackwardSubstitution[0] = integ_accel_B.currentTime;
      idxV = 0;
      integ_accel_B.currentTime = integ_accel_B.BackwardSubstitution[2];
      i = 1;
      while (i > 0) {
        integ_accel_B.currentTime -= integ_accel_B.LDLFactorization[idxV + 2] *
          integ_accel_B.BackwardSubstitution[3];
        idxV -= 2;
        i = 0;
      }

      integ_accel_B.BackwardSubstitution[2] = integ_accel_B.currentTime;
      idxV = 0;
      integ_accel_B.currentTime = integ_accel_B.BackwardSubstitution[4];
      i = 1;
      while (i > 0) {
        integ_accel_B.currentTime -= integ_accel_B.LDLFactorization[idxV + 2] *
          integ_accel_B.BackwardSubstitution[5];
        idxV -= 2;
        i = 0;
      }

      integ_accel_B.BackwardSubstitution[4] = integ_accel_B.currentTime;
      idxV = 0;
      integ_accel_B.currentTime = integ_accel_B.BackwardSubstitution[6];
      i = 1;
      while (i > 0) {
        integ_accel_B.currentTime -= integ_accel_B.LDLFactorization[idxV + 2] *
          integ_accel_B.BackwardSubstitution[7];
        idxV -= 2;
        i = 0;
      }

      integ_accel_B.BackwardSubstitution[6] = integ_accel_B.currentTime;

      /* End of S-Function (sdspfbsub2): '<S12>/Backward Substitution' */
      for (idxV = 0; idxV < 2; idxV++) {
        for (i = 0; i < 4; i++) {
          /* Math: '<S7>/K Trans' */
          integ_accel_B.y[i + (idxV << 2)] = integ_accel_B.BackwardSubstitution
            [(i << 1) + idxV];

          /* Product: '<S7>/K*H*P_prd' incorporates:
           *  Constant: '<S7>/Hcst'
           */
          integ_accel_B.dv2[idxV + (i << 1)] = 0.0;
          integ_accel_B.dv2[idxV + (i << 1)] +=
            integ_accel_DW.UnitDelay3_DSTATE[i << 2] *
            integ_accel_P.Hcst_Value[idxV];
          integ_accel_B.dv2[idxV + (i << 1)] +=
            integ_accel_DW.UnitDelay3_DSTATE[(i << 2) + 1] *
            integ_accel_P.Hcst_Value[idxV + 2];
          integ_accel_B.dv2[idxV + (i << 1)] +=
            integ_accel_DW.UnitDelay3_DSTATE[(i << 2) + 2] *
            integ_accel_P.Hcst_Value[idxV + 4];
          integ_accel_B.dv2[idxV + (i << 1)] +=
            integ_accel_DW.UnitDelay3_DSTATE[(i << 2) + 3] *
            integ_accel_P.Hcst_Value[idxV + 6];
        }
      }

      for (idxV = 0; idxV < 4; idxV++) {
        /* Sum: '<S7>/P_prd-K*H*P_prd' incorporates:
         *  Product: '<S7>/A*P*At'
         *  Product: '<S7>/K*H*P_prd'
         *  UnitDelay: '<S3>/Unit Delay3'
         */
        for (i = 0; i < 4; i++) {
          integ_accel_B.dv0[idxV + (i << 2)] = integ_accel_DW.UnitDelay3_DSTATE
            [(i << 2) + idxV] - (integ_accel_B.dv2[(i << 1) + 1] *
            integ_accel_B.y[idxV + 4] + integ_accel_B.dv2[i << 1] *
            integ_accel_B.y[idxV]);
        }

        /* End of Sum: '<S7>/P_prd-K*H*P_prd' */

        /* Product: '<S7>/A*P*At' incorporates:
         *  Constant: '<S7>/Constant4'
         */
        for (i = 0; i < 4; i++) {
          integ_accel_B.dv1[idxV + (i << 2)] = 0.0;
          integ_accel_B.dv1[idxV + (i << 2)] += integ_accel_P.Constant4_Value[i <<
            2] * integ_accel_B.dv0[idxV];
          integ_accel_B.dv1[idxV + (i << 2)] += integ_accel_P.Constant4_Value[(i
            << 2) + 1] * integ_accel_B.dv0[idxV + 4];
          integ_accel_B.dv1[idxV + (i << 2)] += integ_accel_P.Constant4_Value[(i
            << 2) + 2] * integ_accel_B.dv0[idxV + 8];
          integ_accel_B.dv1[idxV + (i << 2)] += integ_accel_P.Constant4_Value[(i
            << 2) + 3] * integ_accel_B.dv0[idxV + 12];
        }
      }

      /* Reshape: '<S7>/P_prd_Reshape' incorporates:
       *  Constant: '<S7>/Constant3'
       *  Constant: '<S7>/Constant5'
       *  Constant: '<S7>/Hcst'
       *  Product: '<S7>/A*P*At'
       *  Product: '<S7>/K*H*P_prd'
       *  Sum: '<S7>/A*P*At+Q'
       *  UnitDelay: '<S3>/Unit Delay3'
       */
      for (idxV = 0; idxV < 4; idxV++) {
        for (i = 0; i < 4; i++) {
          integ_accel_B.P_prd_Reshape[idxV + (i << 2)] = (((integ_accel_B.dv1[(i
            << 2) + 1] * integ_accel_P.Constant3_Value[idxV + 4] +
            integ_accel_B.dv1[i << 2] * integ_accel_P.Constant3_Value[idxV]) +
            integ_accel_B.dv1[(i << 2) + 2] * integ_accel_P.Constant3_Value[idxV
            + 8]) + integ_accel_B.dv1[(i << 2) + 3] *
            integ_accel_P.Constant3_Value[idxV + 12]) +
            integ_accel_P.Constant5_Value[(i << 2) + idxV];
        }
      }

      /* End of Reshape: '<S7>/P_prd_Reshape' */

      /* Sum: '<S7>/Z-H*X_prd' incorporates:
       *  Constant: '<S7>/Hcst'
       *  Product: '<S7>/H*X_prd'
       *  UnitDelay: '<S3>/Unit Delay2'
       */
      for (idxV = 0; idxV < 2; idxV++) {
        integ_accel_B.ZHX_prd[idxV] = integ_accel_B.FXOS87006AxesSensor[idxV] -
          (((integ_accel_P.Hcst_Value[idxV + 2] *
             integ_accel_DW.UnitDelay2_DSTATE[1] + integ_accel_P.Hcst_Value[idxV]
             * integ_accel_DW.UnitDelay2_DSTATE[0]) +
            integ_accel_P.Hcst_Value[idxV + 4] *
            integ_accel_DW.UnitDelay2_DSTATE[2]) + integ_accel_P.Hcst_Value[idxV
           + 6] * integ_accel_DW.UnitDelay2_DSTATE[3]);
      }

      /* End of Sum: '<S7>/Z-H*X_prd' */

      /* Sum: '<S7>/X_prd+K*(Z-H*X_prd)' incorporates:
       *  Product: '<S7>/K*(Z-H*X_prd)'
       *  UnitDelay: '<S3>/Unit Delay2'
       */
      for (idxV = 0; idxV < 4; idxV++) {
        integ_accel_B.LDLFactorization[idxV] = (integ_accel_B.y[idxV + 4] *
          integ_accel_B.ZHX_prd[1] + integ_accel_B.y[idxV] *
          integ_accel_B.ZHX_prd[0]) + integ_accel_DW.UnitDelay2_DSTATE[idxV];
      }

      /* End of Sum: '<S7>/X_prd+K*(Z-H*X_prd)' */

      /* Assignment: '<S8>/Assignment' */
      memcpy(&integ_accel_B.Assignment[0], &integ_accel_B.P_prd_Reshape[0],
             sizeof(real_T) << 4U);
      for (i = 0; i < 4; i++) {
        /* Assignment: '<S9>/Assignment' */
        integ_accel_B.Assignment_o[i] = integ_accel_B.LDLFactorization[i];

        /* Product: '<S7>/A*X' incorporates:
         *  Constant: '<S7>/Constant3'
         */
        integ_accel_B.currentTime = integ_accel_P.Constant3_Value[i + 12] *
          integ_accel_B.LDLFactorization[3] + (integ_accel_P.Constant3_Value[i +
          8] * integ_accel_B.LDLFactorization[2] +
          (integ_accel_P.Constant3_Value[i + 4] *
           integ_accel_B.LDLFactorization[1] + integ_accel_P.Constant3_Value[i] *
           integ_accel_B.LDLFactorization[0]));

        /* Assignment: '<S10>/Assignment' incorporates:
         *  Product: '<S7>/A*X'
         */
        integ_accel_B.Assignment_c[i] = integ_accel_B.currentTime;
      }
    }

    /* End of Selector: '<S6>/Selector' */
    /* End of Outputs for SubSystem: '<S3>/Control' */
  }

  /* Step: '<Root>/Step' */
  integ_accel_B.currentTime = integ_accel_M->Timing.t[0];
  if (integ_accel_B.currentTime < integ_accel_P.Step_Time) {
    integ_accel_B.currentTime = integ_accel_P.Step_Y0;
  } else {
    integ_accel_B.currentTime = integ_accel_P.Step_YFinal;
  }

  /* End of Step: '<Root>/Step' */

  /* Outputs for Enabled SubSystem: '<Root>/Subsystem1' incorporates:
   *  EnablePort: '<S2>/Enable'
   */
  if (integ_accel_B.currentTime > 0.0) {
    if (!integ_accel_DW.Subsystem1_MODE) {
      integ_accel_DW.Subsystem1_MODE = true;
    }

    if (integ_accel_M->Timing.TaskCounters.TID[2] == 0) {
      /* DiscreteIntegrator: '<S2>/Discrete-Time Integrator4' */
      integ_accel_B.DiscreteTimeIntegrator4 =
        integ_accel_DW.DiscreteTimeIntegrator4_DSTATE;

      /* DiscreteIntegrator: '<S2>/Discrete-Time Integrator6' */
      integ_accel_B.DiscreteTimeIntegrator6 =
        integ_accel_DW.DiscreteTimeIntegrator6_DSTATE;

      /* DiscreteIntegrator: '<S2>/Discrete-Time Integrator5' */
      integ_accel_B.DiscreteTimeIntegrator5 =
        integ_accel_DW.DiscreteTimeIntegrator5_DSTATE;

      /* DiscreteIntegrator: '<S2>/Discrete-Time Integrator7' */
      integ_accel_B.DiscreteTimeIntegrator7 =
        integ_accel_DW.DiscreteTimeIntegrator7_DSTATE;

      /* DiscreteIntegrator: '<S2>/Discrete-Time Integrator' */
      integ_accel_B.DiscreteTimeIntegrator =
        integ_accel_DW.DiscreteTimeIntegrator_DSTATE;

      /* DiscreteIntegrator: '<S2>/Discrete-Time Integrator2' */
      integ_accel_B.DiscreteTimeIntegrator2 =
        integ_accel_DW.DiscreteTimeIntegrator2_DSTATE;

      /* DiscreteIntegrator: '<S2>/Discrete-Time Integrator1' */
      integ_accel_B.DiscreteTimeIntegrator1 =
        integ_accel_DW.DiscreteTimeIntegrator1_DSTATE;

      /* DiscreteIntegrator: '<S2>/Discrete-Time Integrator3' */
      integ_accel_B.DiscreteTimeIntegrator3 =
        integ_accel_DW.DiscreteTimeIntegrator3_DSTATE;
    }

    srUpdateBC(integ_accel_DW.Subsystem1_SubsysRanBC);
  } else {
    if (integ_accel_DW.Subsystem1_MODE) {
      integ_accel_DW.Subsystem1_MODE = false;
    }
  }

  /* End of Outputs for SubSystem: '<Root>/Subsystem1' */
  if (integ_accel_M->Timing.TaskCounters.TID[2] == 0) {
  }

  if (integ_accel_M->Timing.TaskCounters.TID[2] == 0) {
    /* Update for UnitDelay: '<S3>/Unit Delay2' */
    integ_accel_DW.UnitDelay2_DSTATE[0] = integ_accel_B.Assignment_c[0];
    integ_accel_DW.UnitDelay2_DSTATE[1] = integ_accel_B.Assignment_c[1];
    integ_accel_DW.UnitDelay2_DSTATE[2] = integ_accel_B.Assignment_c[2];
    integ_accel_DW.UnitDelay2_DSTATE[3] = integ_accel_B.Assignment_c[3];

    /* Update for UnitDelay: '<S3>/Unit Delay3' */
    memcpy(&integ_accel_DW.UnitDelay3_DSTATE[0], &integ_accel_B.Assignment[0],
           sizeof(real_T) << 4U);
  }

  /* Update for Enabled SubSystem: '<Root>/Subsystem1' incorporates:
   *  Update for EnablePort: '<S2>/Enable'
   */
  if (integ_accel_DW.Subsystem1_MODE && (integ_accel_M->Timing.TaskCounters.TID
       [2] == 0)) {
    /* Update for DiscreteIntegrator: '<S2>/Discrete-Time Integrator4' */
    integ_accel_DW.DiscreteTimeIntegrator4_DSTATE +=
      integ_accel_P.DiscreteTimeIntegrator4_gainval *
      integ_accel_B.Assignment_o[0];

    /* Update for DiscreteIntegrator: '<S2>/Discrete-Time Integrator6' */
    integ_accel_DW.DiscreteTimeIntegrator6_DSTATE +=
      integ_accel_P.DiscreteTimeIntegrator6_gainval *
      integ_accel_B.DiscreteTimeIntegrator4;

    /* Update for DiscreteIntegrator: '<S2>/Discrete-Time Integrator5' */
    integ_accel_DW.DiscreteTimeIntegrator5_DSTATE +=
      integ_accel_P.DiscreteTimeIntegrator5_gainval *
      integ_accel_B.Assignment_o[2];

    /* Update for DiscreteIntegrator: '<S2>/Discrete-Time Integrator7' */
    integ_accel_DW.DiscreteTimeIntegrator7_DSTATE +=
      integ_accel_P.DiscreteTimeIntegrator7_gainval *
      integ_accel_B.DiscreteTimeIntegrator5;

    /* Update for DiscreteIntegrator: '<S2>/Discrete-Time Integrator' */
    integ_accel_DW.DiscreteTimeIntegrator_DSTATE +=
      integ_accel_P.DiscreteTimeIntegrator_gainval *
      integ_accel_B.FXOS87006AxesSensor[0];

    /* Update for DiscreteIntegrator: '<S2>/Discrete-Time Integrator2' */
    integ_accel_DW.DiscreteTimeIntegrator2_DSTATE +=
      integ_accel_P.DiscreteTimeIntegrator2_gainval *
      integ_accel_B.DiscreteTimeIntegrator;

    /* Update for DiscreteIntegrator: '<S2>/Discrete-Time Integrator1' */
    integ_accel_DW.DiscreteTimeIntegrator1_DSTATE +=
      integ_accel_P.DiscreteTimeIntegrator1_gainval *
      integ_accel_B.FXOS87006AxesSensor[1];

    /* Update for DiscreteIntegrator: '<S2>/Discrete-Time Integrator3' */
    integ_accel_DW.DiscreteTimeIntegrator3_DSTATE +=
      integ_accel_P.DiscreteTimeIntegrator3_gainval *
      integ_accel_B.DiscreteTimeIntegrator1;
  }

  /* End of Update for SubSystem: '<Root>/Subsystem1' */

  /* External mode */
  rtExtModeUploadCheckTrigger(3);

  {                                    /* Sample time: [0.0s, 0.0s] */
    rtExtModeUpload(0, integ_accel_M->Timing.t[0]);
  }

  {                                    /* Sample time: [0.001s, 0.0s] */
    rtExtModeUpload(1, ((integ_accel_M->Timing.clockTick1) * 0.001));
  }

  if (integ_accel_M->Timing.TaskCounters.TID[2] == 0) {/* Sample time: [1.0s, 0.0s] */
    rtExtModeUpload(2, ((integ_accel_M->Timing.clockTick2) * 1.0));
  }

  /* signal main to stop simulation */
  {                                    /* Sample time: [0.0s, 0.0s] */
    if ((rtmGetTFinal(integ_accel_M)!=-1) &&
        !((rtmGetTFinal(integ_accel_M)-integ_accel_M->Timing.t[0]) >
          integ_accel_M->Timing.t[0] * (DBL_EPSILON))) {
      rtmSetErrorStatus(integ_accel_M, "Simulation finished");
    }

    if (rtmGetStopRequested(integ_accel_M)) {
      rtmSetErrorStatus(integ_accel_M, "Simulation finished");
    }
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   */
  integ_accel_M->Timing.t[0] =
    (++integ_accel_M->Timing.clockTick0) * integ_accel_M->Timing.stepSize0;

  {
    /* Update absolute timer for sample time: [0.001s, 0.0s] */
    /* The "clockTick1" counts the number of times the code of this task has
     * been executed. The resolution of this integer timer is 0.001, which is the step size
     * of the task. Size of "clockTick1" ensures timer will not overflow during the
     * application lifespan selected.
     */
    integ_accel_M->Timing.clockTick1++;
  }

  if (integ_accel_M->Timing.TaskCounters.TID[2] == 0) {
    /* Update absolute timer for sample time: [1.0s, 0.0s] */
    /* The "clockTick2" counts the number of times the code of this task has
     * been executed. The resolution of this integer timer is 1.0, which is the step size
     * of the task. Size of "clockTick2" ensures timer will not overflow during the
     * application lifespan selected.
     */
    integ_accel_M->Timing.clockTick2++;
  }

  rate_scheduler();
}

/* Model initialize function */
void integ_accel_initialize(void)
{
  /* Registration code */

  /* initialize real-time model */
  (void) memset((void *)integ_accel_M, 0,
                sizeof(RT_MODEL_integ_accel_T));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&integ_accel_M->solverInfo,
                          &integ_accel_M->Timing.simTimeStep);
    rtsiSetTPtr(&integ_accel_M->solverInfo, &rtmGetTPtr(integ_accel_M));
    rtsiSetStepSizePtr(&integ_accel_M->solverInfo,
                       &integ_accel_M->Timing.stepSize0);
    rtsiSetErrorStatusPtr(&integ_accel_M->solverInfo, (&rtmGetErrorStatus
      (integ_accel_M)));
    rtsiSetRTModelPtr(&integ_accel_M->solverInfo, integ_accel_M);
  }

  rtsiSetSimTimeStep(&integ_accel_M->solverInfo, MAJOR_TIME_STEP);
  rtsiSetSolverName(&integ_accel_M->solverInfo,"FixedStepDiscrete");
  rtmSetTPtr(integ_accel_M, &integ_accel_M->Timing.tArray[0]);
  rtmSetTFinal(integ_accel_M, -1);
  integ_accel_M->Timing.stepSize0 = 0.001;

  /* External mode info */
  integ_accel_M->Sizes.checksums[0] = (2691778551U);
  integ_accel_M->Sizes.checksums[1] = (2170082580U);
  integ_accel_M->Sizes.checksums[2] = (426877032U);
  integ_accel_M->Sizes.checksums[3] = (801698773U);

  {
    static const sysRanDType rtAlwaysEnabled = SUBSYS_RAN_BC_ENABLE;
    static RTWExtModeInfo rt_ExtModeInfo;
    static const sysRanDType *systemRan[4];
    integ_accel_M->extModeInfo = (&rt_ExtModeInfo);
    rteiSetSubSystemActiveVectorAddresses(&rt_ExtModeInfo, systemRan);
    systemRan[0] = &rtAlwaysEnabled;
    systemRan[1] = &rtAlwaysEnabled;
    systemRan[2] = &rtAlwaysEnabled;
    systemRan[3] = (sysRanDType *)&integ_accel_DW.Subsystem1_SubsysRanBC;
    rteiSetModelMappingInfoPtr(integ_accel_M->extModeInfo,
      &integ_accel_M->SpecialInfo.mappingInfo);
    rteiSetChecksumsPtr(integ_accel_M->extModeInfo,
                        integ_accel_M->Sizes.checksums);
    rteiSetTPtr(integ_accel_M->extModeInfo, rtmGetTPtr(integ_accel_M));
  }

  /* block I/O */
  (void) memset(((void *) &integ_accel_B), 0,
                sizeof(B_integ_accel_T));

  /* states (dwork) */
  (void) memset((void *)&integ_accel_DW, 0,
                sizeof(DW_integ_accel_T));

  /* data type transition information */
  {
    static DataTypeTransInfo dtInfo;
    (void) memset((char_T *) &dtInfo, 0,
                  sizeof(dtInfo));
    integ_accel_M->SpecialInfo.mappingInfo = (&dtInfo);
    dtInfo.numDataTypes = 15;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.BTransTable = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.PTransTable = &rtPTransTable;
  }

  {
    freedomk64f_fxos8700_integ_ac_T *obj;
    uint32_T i2cname;
    uint8_T output;
    uint8_T status;
    uint8_T SwappedDataBytes[2];
    int32_T i;

    /* Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' */
    obj = &integ_accel_DW.obj;
    integ_accel_DW.obj.isInitialized = 0;
    obj->i2cobj.isInitialized = 0;

    /* [EOF] */
    /*  */
    integ_accel_DW.obj.SampleTime = integ_accel_P.FXOS87006AxesSensor_SampleTime;
    obj = &integ_accel_DW.obj;
    integ_accel_DW.obj.isInitialized = 1;
    i2cname = 0;
    MW_I2C_Open(i2cname, 0U);

    /* KHz */
    obj->i2cobj.BusSpeed = 100000U;
    i2cname = 0;
    MW_I2C_SetBusSpeed(i2cname, obj->i2cobj.BusSpeed);
    SwappedDataBytes[0] = 43U;
    SwappedDataBytes[1] = 64U;
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);
    OSA_TimeDelay(500U);
    output = 0U;
    status = 42U;
    i2cname = 0;
    status = MW_I2C_MasterWrite(i2cname, 29U, &status, 1U, true, false);
    if (0 == status) {
      i2cname = 0;
      MW_I2C_MasterRead(i2cname, 29U, &status, 1U, false, true);
      memcpy((void *)&output, (void *)&status, (size_t)1 * sizeof(uint8_T));
    }

    SwappedDataBytes[0] = 42U;
    SwappedDataBytes[1] = (uint8_T)(output & 254);
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);
    SwappedDataBytes[0] = 14U;
    SwappedDataBytes[1] = 0U;
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);
    SwappedDataBytes[0] = 91U;
    SwappedDataBytes[1] = 0U;
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);
    SwappedDataBytes[0] = 42U;
    SwappedDataBytes[1] = 1U;
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);

    /* End of Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' */

    /* InitializeConditions for UnitDelay: '<S3>/Unit Delay2' */
    integ_accel_DW.UnitDelay2_DSTATE[0] =
      integ_accel_P.UnitDelay2_InitialCondition[0];
    integ_accel_DW.UnitDelay2_DSTATE[1] =
      integ_accel_P.UnitDelay2_InitialCondition[1];
    integ_accel_DW.UnitDelay2_DSTATE[2] =
      integ_accel_P.UnitDelay2_InitialCondition[2];
    integ_accel_DW.UnitDelay2_DSTATE[3] =
      integ_accel_P.UnitDelay2_InitialCondition[3];

    /* SystemInitialize for Iterator SubSystem: '<S3>/Control' */
    /* SystemInitialize for Outport: '<S5>/X_est' */
    integ_accel_B.Assignment_o[0] = integ_accel_P.X_est_Y0;

    /* SystemInitialize for Outport: '<S5>/X_prd' */
    integ_accel_B.Assignment_c[0] = integ_accel_P.X_prd_Y0;

    /* SystemInitialize for Outport: '<S5>/X_est' */
    integ_accel_B.Assignment_o[1] = integ_accel_P.X_est_Y0;

    /* SystemInitialize for Outport: '<S5>/X_prd' */
    integ_accel_B.Assignment_c[1] = integ_accel_P.X_prd_Y0;

    /* SystemInitialize for Outport: '<S5>/X_est' */
    integ_accel_B.Assignment_o[2] = integ_accel_P.X_est_Y0;

    /* SystemInitialize for Outport: '<S5>/X_prd' */
    integ_accel_B.Assignment_c[2] = integ_accel_P.X_prd_Y0;

    /* SystemInitialize for Outport: '<S5>/X_est' */
    integ_accel_B.Assignment_o[3] = integ_accel_P.X_est_Y0;

    /* SystemInitialize for Outport: '<S5>/X_prd' */
    integ_accel_B.Assignment_c[3] = integ_accel_P.X_prd_Y0;
    for (i = 0; i < 16; i++) {
      /* InitializeConditions for UnitDelay: '<S3>/Unit Delay3' */
      integ_accel_DW.UnitDelay3_DSTATE[i] =
        integ_accel_P.UnitDelay3_InitialCondition[i];

      /* SystemInitialize for Outport: '<S5>/P_prd' */
      integ_accel_B.Assignment[i] = integ_accel_P.P_prd_Y0;
    }

    /* End of SystemInitialize for SubSystem: '<S3>/Control' */

    /* SystemInitialize for Enabled SubSystem: '<Root>/Subsystem1' */
    /* InitializeConditions for DiscreteIntegrator: '<S2>/Discrete-Time Integrator4' */
    integ_accel_DW.DiscreteTimeIntegrator4_DSTATE =
      integ_accel_P.DiscreteTimeIntegrator4_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S2>/Discrete-Time Integrator6' */
    integ_accel_DW.DiscreteTimeIntegrator6_DSTATE =
      integ_accel_P.DiscreteTimeIntegrator6_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S2>/Discrete-Time Integrator5' */
    integ_accel_DW.DiscreteTimeIntegrator5_DSTATE =
      integ_accel_P.DiscreteTimeIntegrator5_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S2>/Discrete-Time Integrator7' */
    integ_accel_DW.DiscreteTimeIntegrator7_DSTATE =
      integ_accel_P.DiscreteTimeIntegrator7_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S2>/Discrete-Time Integrator' */
    integ_accel_DW.DiscreteTimeIntegrator_DSTATE =
      integ_accel_P.DiscreteTimeIntegrator_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S2>/Discrete-Time Integrator2' */
    integ_accel_DW.DiscreteTimeIntegrator2_DSTATE =
      integ_accel_P.DiscreteTimeIntegrator2_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S2>/Discrete-Time Integrator1' */
    integ_accel_DW.DiscreteTimeIntegrator1_DSTATE =
      integ_accel_P.DiscreteTimeIntegrator1_IC;

    /* InitializeConditions for DiscreteIntegrator: '<S2>/Discrete-Time Integrator3' */
    integ_accel_DW.DiscreteTimeIntegrator3_DSTATE =
      integ_accel_P.DiscreteTimeIntegrator3_IC;

    /* SystemInitialize for Outport: '<S2>/x_filter' */
    integ_accel_B.DiscreteTimeIntegrator6 = integ_accel_P.x_filter_Y0;

    /* SystemInitialize for Outport: '<S2>/y_filter' */
    integ_accel_B.DiscreteTimeIntegrator7 = integ_accel_P.y_filter_Y0;

    /* SystemInitialize for Outport: '<S2>/x_meas' */
    integ_accel_B.DiscreteTimeIntegrator2 = integ_accel_P.x_meas_Y0;

    /* SystemInitialize for Outport: '<S2>/y_meas' */
    integ_accel_B.DiscreteTimeIntegrator3 = integ_accel_P.y_meas_Y0;

    /* End of SystemInitialize for SubSystem: '<Root>/Subsystem1' */
  }
}

/* Model terminate function */
void integ_accel_terminate(void)
{
  uint32_T i2cname;

  /* Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' incorporates:
   *  Terminate for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor'
   */
  if (integ_accel_DW.obj.isInitialized == 1) {
    integ_accel_DW.obj.isInitialized = 2;
    i2cname = 0;
    MW_I2C_Close(i2cname);
  }

  /* End of Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
