/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * File: magneto_tarato.c
 *
 * Code generated for Simulink model 'magneto_tarato'.
 *
 * Model version                  : 1.20
 * Simulink Coder version         : 8.12 (R2017a) 16-Feb-2017
 * C/C++ source code generated on : Mon Nov 13 17:07:50 2017
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: ARM Compatible->ARM Cortex
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "magneto_tarato.h"
#include "magneto_tarato_private.h"
#include "magneto_tarato_dt.h"

/* Block signals (auto storage) */
B_magneto_tarato_T magneto_tarato_B;

/* Block states (auto storage) */
DW_magneto_tarato_T magneto_tarato_DW;

/* Real-time model */
RT_MODEL_magneto_tarato_T magneto_tarato_M_;
RT_MODEL_magneto_tarato_T *const magneto_tarato_M = &magneto_tarato_M_;
real_T rt_atan2d_snf(real_T u0, real_T u1)
{
  real_T y;
  int32_T u0_0;
  int32_T u1_0;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = (rtNaN);
  } else if (rtIsInf(u0) && rtIsInf(u1)) {
    if (u0 > 0.0) {
      u0_0 = 1;
    } else {
      u0_0 = -1;
    }

    if (u1 > 0.0) {
      u1_0 = 1;
    } else {
      u1_0 = -1;
    }

    y = atan2(u0_0, u1_0);
  } else if (u1 == 0.0) {
    if (u0 > 0.0) {
      y = RT_PI / 2.0;
    } else if (u0 < 0.0) {
      y = -(RT_PI / 2.0);
    } else {
      y = 0.0;
    }
  } else {
    y = atan2(u0, u1);
  }

  return y;
}

/* Model step function */
void magneto_tarato_step(void)
{
  boolean_T p;
  boolean_T p_0;
  int16_T output[3];
  uint8_T status;
  uint8_T output_raw[6];
  uint8_T y[2];
  uint8_T x[2];
  int32_T i;
  int16_T output_0;
  real_T tmp;
  real_T tmp_0;
  real_T tmp_1;

  /* Constant: '<Root>/Constant' */
  magneto_tarato_B.VectorConcatenate[0] = magneto_tarato_P.Constant_Value;

  /* Constant: '<Root>/Constant6' */
  magneto_tarato_B.VectorConcatenate[1] = magneto_tarato_P.Constant6_Value;

  /* Constant: '<Root>/Constant5' */
  magneto_tarato_B.VectorConcatenate[2] = magneto_tarato_P.Constant5_Value;

  /* Constant: '<Root>/Constant2' */
  magneto_tarato_B.VectorConcatenate[3] = magneto_tarato_P.Constant2_Value;

  /* Product: '<Root>/Divide' incorporates:
   *  Constant: '<Root>/Constant8'
   *  Constant: '<Root>/Constant9'
   */
  magneto_tarato_B.VectorConcatenate[4] = magneto_tarato_P.Constant8_Value /
    magneto_tarato_P.Constant9_Value;

  /* Constant: '<Root>/Constant4' */
  magneto_tarato_B.VectorConcatenate[5] = magneto_tarato_P.Constant4_Value;

  /* Constant: '<Root>/Constant3' */
  magneto_tarato_B.VectorConcatenate[6] = magneto_tarato_P.Constant3_Value;

  /* Constant: '<Root>/Constant7' */
  magneto_tarato_B.VectorConcatenate[7] = magneto_tarato_P.Constant7_Value;

  /* Constant: '<Root>/Constant1' */
  magneto_tarato_B.VectorConcatenate[8] = magneto_tarato_P.Constant1_Value;

  /* Reshape: '<S1>/Reshape (9) to [3x3] column-major' */
  memcpy(&magneto_tarato_B.Reshape9to3x3columnmajor[0],
         &magneto_tarato_B.VectorConcatenate[0], 9U * sizeof(real_T));

  /* Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' incorporates:
   *  MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor'
   */
  p = false;
  p_0 = true;
  if (!(magneto_tarato_DW.obj.SampleTime ==
        magneto_tarato_P.FXOS87006AxesSensor_SampleTime)) {
    p_0 = false;
  }

  if (p_0) {
    p = true;
  }

  if (!p) {
    magneto_tarato_DW.obj.SampleTime =
      magneto_tarato_P.FXOS87006AxesSensor_SampleTime;
  }

  output[0] = 0;
  output[1] = 0;
  output[2] = 0;
  status = 51U;
  magneto_tarato_B.i2cname = 0;
  status = MW_I2C_MasterWrite(magneto_tarato_B.i2cname, 29U, &status, 1U, true,
    false);
  if (0 == status) {
    magneto_tarato_B.i2cname = 0;
    MW_I2C_MasterRead(magneto_tarato_B.i2cname, 29U, output_raw, 6U, false, true);
    memcpy((void *)&output[0], (void *)&output_raw[0], (size_t)3 * sizeof
           (int16_T));
    output_0 = output[0];
    memcpy((void *)&y[0], (void *)&output_0, (size_t)2 * sizeof(uint8_T));
    x[0] = y[1];
    x[1] = y[0];
    memcpy((void *)&output_0, (void *)&x[0], (size_t)1 * sizeof(int16_T));
    output[0] = output_0;
    output_0 = output[1];
    memcpy((void *)&y[0], (void *)&output_0, (size_t)2 * sizeof(uint8_T));
    x[0] = y[1];
    x[1] = y[0];
    memcpy((void *)&output_0, (void *)&x[0], (size_t)1 * sizeof(int16_T));
    output[1] = output_0;
    output_0 = output[2];
    memcpy((void *)&y[0], (void *)&output_0, (size_t)2 * sizeof(uint8_T));
    x[0] = y[1];
    x[1] = y[0];
    memcpy((void *)&output_0, (void *)&x[0], (size_t)1 * sizeof(int16_T));
    output[2] = output_0;
  }

  /* MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' incorporates:
   *  Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor'
   */
  magneto_tarato_B.FXOS87006AxesSensor[0] = (real_T)output[0] * 0.1;
  magneto_tarato_B.FXOS87006AxesSensor[1] = (real_T)output[1] * 0.1;
  magneto_tarato_B.FXOS87006AxesSensor[2] = (real_T)output[2] * 0.1;

  /* MATLAB Function: '<Root>/MATLAB Function' incorporates:
   *  Bias: '<Root>/Bias'
   *  Bias: '<Root>/Bias1'
   *  Bias: '<Root>/Bias2'
   */
  /* MATLAB Function 'MATLAB Function': '<S2>:1' */
  /* '<S2>:1:2' Raw_B=[RawX_B,RawY_B,RawZ_B]; */
  /* '<S2>:1:4' CorrMag = Raw_B*S; */
  tmp = magneto_tarato_B.FXOS87006AxesSensor[0] + magneto_tarato_P.Bias_Bias;
  tmp_0 = magneto_tarato_B.FXOS87006AxesSensor[1] + magneto_tarato_P.Bias1_Bias;
  tmp_1 = magneto_tarato_B.FXOS87006AxesSensor[2] + magneto_tarato_P.Bias2_Bias;
  for (i = 0; i < 3; i++) {
    magneto_tarato_B.CorrMag[i] = 0.0;
    magneto_tarato_B.CorrMag[i] += magneto_tarato_B.Reshape9to3x3columnmajor[3 *
      i] * tmp;
    magneto_tarato_B.CorrMag[i] += magneto_tarato_B.Reshape9to3x3columnmajor[3 *
      i + 1] * tmp_0;
    magneto_tarato_B.CorrMag[i] += magneto_tarato_B.Reshape9to3x3columnmajor[3 *
      i + 2] * tmp_1;
  }

  /* End of MATLAB Function: '<Root>/MATLAB Function' */

  /* Gain: '<S3>/Gain' incorporates:
   *  Gain: '<Root>/Gain'
   *  Trigonometry: '<Root>/Atan2'
   */
  magneto_tarato_B.Gain = rt_atan2d_snf(magneto_tarato_P.Gain_Gain *
    magneto_tarato_B.CorrMag[1], magneto_tarato_B.CorrMag[0]) *
    magneto_tarato_P.Gain_Gain_j;

  /* Gain: '<S4>/Gain' incorporates:
   *  Gain: '<Root>/Gain1'
   *  Trigonometry: '<Root>/Atan1'
   */
  magneto_tarato_B.Gain_g = rt_atan2d_snf(magneto_tarato_P.Gain1_Gain *
    magneto_tarato_B.FXOS87006AxesSensor[1],
    magneto_tarato_B.FXOS87006AxesSensor[0]) * magneto_tarato_P.Gain_Gain_h;

  /* External mode */
  rtExtModeUploadCheckTrigger(1);

  {                                    /* Sample time: [0.02s, 0.0s] */
    rtExtModeUpload(0, magneto_tarato_M->Timing.taskTime0);
  }

  /* signal main to stop simulation */
  {                                    /* Sample time: [0.02s, 0.0s] */
    if ((rtmGetTFinal(magneto_tarato_M)!=-1) &&
        !((rtmGetTFinal(magneto_tarato_M)-magneto_tarato_M->Timing.taskTime0) >
          magneto_tarato_M->Timing.taskTime0 * (DBL_EPSILON))) {
      rtmSetErrorStatus(magneto_tarato_M, "Simulation finished");
    }

    if (rtmGetStopRequested(magneto_tarato_M)) {
      rtmSetErrorStatus(magneto_tarato_M, "Simulation finished");
    }
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   */
  magneto_tarato_M->Timing.taskTime0 =
    (++magneto_tarato_M->Timing.clockTick0) * magneto_tarato_M->Timing.stepSize0;
}

/* Model initialize function */
void magneto_tarato_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)magneto_tarato_M, 0,
                sizeof(RT_MODEL_magneto_tarato_T));
  rtmSetTFinal(magneto_tarato_M, -1);
  magneto_tarato_M->Timing.stepSize0 = 0.02;

  /* External mode info */
  magneto_tarato_M->Sizes.checksums[0] = (359932345U);
  magneto_tarato_M->Sizes.checksums[1] = (1492314972U);
  magneto_tarato_M->Sizes.checksums[2] = (3572482939U);
  magneto_tarato_M->Sizes.checksums[3] = (30296138U);

  {
    static const sysRanDType rtAlwaysEnabled = SUBSYS_RAN_BC_ENABLE;
    static RTWExtModeInfo rt_ExtModeInfo;
    static const sysRanDType *systemRan[3];
    magneto_tarato_M->extModeInfo = (&rt_ExtModeInfo);
    rteiSetSubSystemActiveVectorAddresses(&rt_ExtModeInfo, systemRan);
    systemRan[0] = &rtAlwaysEnabled;
    systemRan[1] = &rtAlwaysEnabled;
    systemRan[2] = &rtAlwaysEnabled;
    rteiSetModelMappingInfoPtr(magneto_tarato_M->extModeInfo,
      &magneto_tarato_M->SpecialInfo.mappingInfo);
    rteiSetChecksumsPtr(magneto_tarato_M->extModeInfo,
                        magneto_tarato_M->Sizes.checksums);
    rteiSetTPtr(magneto_tarato_M->extModeInfo, rtmGetTPtr(magneto_tarato_M));
  }

  /* block I/O */
  (void) memset(((void *) &magneto_tarato_B), 0,
                sizeof(B_magneto_tarato_T));

  /* states (dwork) */
  (void) memset((void *)&magneto_tarato_DW, 0,
                sizeof(DW_magneto_tarato_T));

  /* data type transition information */
  {
    static DataTypeTransInfo dtInfo;
    (void) memset((char_T *) &dtInfo, 0,
                  sizeof(dtInfo));
    magneto_tarato_M->SpecialInfo.mappingInfo = (&dtInfo);
    dtInfo.numDataTypes = 15;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.BTransTable = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.PTransTable = &rtPTransTable;
  }

  {
    freedomk64f_fxos8700_magneto__T *obj;
    uint32_T i2cname;
    uint8_T output;
    uint8_T status;
    uint8_T SwappedDataBytes[2];

    /* Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' */
    obj = &magneto_tarato_DW.obj;
    magneto_tarato_DW.obj.isInitialized = 0;
    obj->i2cobj.isInitialized = 0;

    /* [EOF] */
    /*  */
    magneto_tarato_DW.obj.SampleTime =
      magneto_tarato_P.FXOS87006AxesSensor_SampleTime;
    obj = &magneto_tarato_DW.obj;
    magneto_tarato_DW.obj.isInitialized = 1;
    i2cname = 0;
    MW_I2C_Open(i2cname, 0U);

    /* KHz */
    obj->i2cobj.BusSpeed = 100000U;
    i2cname = 0;
    MW_I2C_SetBusSpeed(i2cname, obj->i2cobj.BusSpeed);
    SwappedDataBytes[0] = 43U;
    SwappedDataBytes[1] = 64U;
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);
    OSA_TimeDelay(500U);
    output = 0U;
    status = 42U;
    i2cname = 0;
    status = MW_I2C_MasterWrite(i2cname, 29U, &status, 1U, true, false);
    if (0 == status) {
      i2cname = 0;
      MW_I2C_MasterRead(i2cname, 29U, &status, 1U, false, true);
      memcpy((void *)&output, (void *)&status, (size_t)1 * sizeof(uint8_T));
    }

    SwappedDataBytes[0] = 42U;
    SwappedDataBytes[1] = (uint8_T)(output & 254);
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);
    SwappedDataBytes[0] = 14U;
    SwappedDataBytes[1] = 1U;
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);
    SwappedDataBytes[0] = 91U;
    SwappedDataBytes[1] = 1U;
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);
    SwappedDataBytes[0] = 42U;
    SwappedDataBytes[1] = 9U;
    i2cname = 0;
    MW_I2C_MasterWrite(i2cname, 29U, SwappedDataBytes, 2U, false, false);

    /* End of Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' */
  }
}

/* Model terminate function */
void magneto_tarato_terminate(void)
{
  uint32_T i2cname;

  /* Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' incorporates:
   *  Terminate for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor'
   */
  if (magneto_tarato_DW.obj.isInitialized == 1) {
    magneto_tarato_DW.obj.isInitialized = 2;
    i2cname = 0;
    MW_I2C_Close(i2cname);
  }

  /* End of Start for MATLABSystem: '<Root>/FXOS8700 6-Axes Sensor' */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
